/*
   acpi.h - access to ACPI BIOS structures header file
   
   FanIO driver V2.0
   Copyright(c) 2001-2006 Christian Diefer

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as
   published by the Free Software Foundation.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

// turn off on final build:
#define ACPI_DEBUG 1

#define EBDA_SIZE     0x400
#define BIOSAREA_SIZE 0x20000
#define SIG_STEP      0x10

// "RSD PTR "
#define RSDP_SIG1     0x20445352
#define RSDP_SIG2     0x20525450

#define SDT_HDRSIZE   36

int acpiInit( char* pIOBuffer );
void acpiExit();

/////////////////////////////////////////////////////////////////////////////
