/*
   acpimem.h - dynamic memory allocation for ACPI subsystem header file
   
   FanIO driver V2.0
   Copyright(c) 2001-2006 Christian Diefer

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as
   published by the Free Software Foundation.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

// this structure records one physical -> virtual block mapping
struct pvadata {
  PUCHAR phys;
  PUCHAR virt;
  ULONG size;
  ULONG unmap;     // automatic unmapping
};

// here we store our mappings in a static array:
static struct pvadata pva_mappings[100];
static int nextEntry = 0;

extern void initMappings( PUCHAR virtual );
extern PUCHAR mapPhysicalToVirtual( PUCHAR phys, ULONG size );
extern void cleanUp();
extern void dumpMappings( char* pIOBuffer );
extern PUCHAR changeMapping( PUCHAR phys, ULONG oldsize, ULONG newsize );
