/*
   diagio.h - Dell Inspiron 8x00 access functions for SMBIOS diagnostics interface

   FanIO driver V2.x
   Copyright(c) 2001-2007 Christian Diefer

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as
   published by the Free Software Foundation.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

typedef struct {
  unsigned long cmd;    // = cmd
  unsigned long data;   // = data
  unsigned long stat1;  // = 0
  unsigned long stat2;  // = 0
} SMBIOSCMD;


ULONG getFanSpeedIO( ULONG fanNo, PULONG pIOBuffer );
ULONG setFanSpeedIO( ULONG fanNo, ULONG speed, PULONG pIOBuffer );
ULONG getFanRPMIO( ULONG fanNo, PULONG pIOBuffer );
ULONG getTempIO( ULONG thermNo, PULONG pIOBuffer );
ULONG execSMMOp( ULONG cmd, ULONG data, ULONG stat1, ULONG stat2, PULONG pIOBuffer );

#ifndef _WIN64
static int smfunction( SMBIOSCMD* sc );
#else
extern int smfunction( SMBIOSCMD* sc );
#endif
