/*
   fanio.h - Dell Inspiron 8x00 fan io driver header file

   FanIO driver V2.x
   Copyright(c) 2001-2007 Christian Diefer
*/

#define FANIO_DRIVER_BUILD

#include <ntddk.h>
#include <stdio.h>
#include "fanioctl.h"
#include "smbios.h"
#include "lpc.h"
#include "diagio.h"
#include "acpi.h"
#include "acpimem.h"
#include "vbios.h"

#ifndef __FANIO_H__
#define __FANIO_H__

#define FANIO_DEVICE_NAME L"\\Device\\FanIO"
#define DOS_DEVICE_NAME L"\\DosDevices\\FanIODev"

#define MAJORVERSION 2
#define MINORVERSION 3

static PHYSICAL_ADDRESS biosPA;
static PHYSICAL_ADDRESS biosPA2;

#define SENSOR_BUFSIZE 16

#if DBG
#define DebugPrint(_x_) \
               DbgPrint ("FanIO:"); \
               DbgPrint _x_;
#else
#define DebugPrint(_x_)
#endif

// driver function prototypes
NTSTATUS DriverEntry( IN PDRIVER_OBJECT DriverObject, IN PUNICODE_STRING RegistryPath );
NTSTATUS FanIO_DispatchCreateClose( IN PDEVICE_OBJECT devObj, IN PIRP Irp );
NTSTATUS FanIO_DispatchDeviceControl( IN PDEVICE_OBJECT devObj, IN PIRP Irp );
VOID FanIO_Unload( IN PDRIVER_OBJECT DriverObject );

#ifdef _WIN64
extern UINT64 readMSR( int msrNo );
#endif

#endif
