/*
   fanioctl.h - ioctl codes for fanio.sys driver

   FanIO driver V2.x
   Copyright(c) 2001-2007 Christian Diefer
*/

#ifndef __FANIOCTL_H__
#define __FANIOCTL_H__

#define FANIO_TYPE 40000

// The IOCTL function codes from 0x800 to 0xFFF are for customer use.

#define IOCTL_FANIO_SET_FAN_SPEED \
    CTL_CODE( FANIO_TYPE, 0x800, METHOD_BUFFERED, FILE_WRITE_ACCESS )

#define IOCTL_FANIO_GET_FAN_SPEED \
    CTL_CODE( FANIO_TYPE, 0x801, METHOD_BUFFERED, FILE_WRITE_ACCESS )

#define IOCTL_FANIO_GET_FAN_RPM \
    CTL_CODE( FANIO_TYPE, 0x802, METHOD_BUFFERED, FILE_WRITE_ACCESS )

#define IOCTL_FANIO_SET_FAN_SPEED_OLD \
    CTL_CODE( FANIO_TYPE, 0x803, METHOD_BUFFERED, FILE_WRITE_ACCESS )

#define IOCTL_FANIO_GET_CPU_SPEED \
    CTL_CODE( FANIO_TYPE, 0x804, METHOD_BUFFERED, FILE_WRITE_ACCESS )

#define IOCTL_FANIO_CHECK_SENSOR \
    CTL_CODE( FANIO_TYPE, 0x805, METHOD_BUFFERED, FILE_WRITE_ACCESS )

#define IOCTL_FANIO_SET_SENSOR_SPEED \
    CTL_CODE( FANIO_TYPE, 0x806, METHOD_BUFFERED, FILE_WRITE_ACCESS )

#define IOCTL_FANIO_GET_SENSOR_SPEED \
    CTL_CODE( FANIO_TYPE, 0x807, METHOD_BUFFERED, FILE_WRITE_ACCESS )

#define IOCTL_FANIO_GET_TEMP \
    CTL_CODE( FANIO_TYPE, 0x808, METHOD_BUFFERED, FILE_WRITE_ACCESS)

#define IOCTL_FANIO_GET_VERSION \
    CTL_CODE( FANIO_TYPE, 0x809, METHOD_BUFFERED, FILE_WRITE_ACCESS )

#define IOCTL_FANIO_GET_SYSTEM_INFO \
    CTL_CODE( FANIO_TYPE, 0x810, METHOD_BUFFERED, FILE_WRITE_ACCESS )

#define IOCTL_FANIO_ACPI_INFO \
    CTL_CODE( FANIO_TYPE, 0x811, METHOD_BUFFERED, FILE_WRITE_ACCESS )

#define IOCTL_FANIO_GET_SENSOR_MAX_FANS \
    CTL_CODE( FANIO_TYPE, 0x812, METHOD_BUFFERED, FILE_WRITE_ACCESS )

#define IOCTL_FANIO_MAP_VBIOS \
    CTL_CODE( FANIO_TYPE, 0x813, METHOD_BUFFERED, FILE_WRITE_ACCESS )

#define IOCTL_FANIO_UNMAP_VBIOS \
    CTL_CODE( FANIO_TYPE, 0x814, METHOD_BUFFERED, FILE_WRITE_ACCESS )

#define IOCTL_FANIO_GET_VBIOS_CHUNK \
    CTL_CODE( FANIO_TYPE, 0x815, METHOD_BUFFERED, FILE_WRITE_ACCESS )

#define IOCTL_FANIO_READ_MSR \
    CTL_CODE( FANIO_TYPE, 0x816, METHOD_BUFFERED, FILE_WRITE_ACCESS )

// this is the ioctl from former I8kfanGUI versions so they don't 
// silenty crash when talking to this new driver implementation and these 
// new ioctl's (namely the spin-off I9kfanGUI that may be started separately)
#define IOCTL_FANIO_GET_VERSION_LEGACY \
    CTL_CODE( FANIO_TYPE, 0x911, METHOD_BUFFERED, FILE_WRITE_ACCESS )

#endif
