/*
   smbios.h - access to SMBIOS table header file

   FanIO driver V2.x
   Copyright(c) 2001-2007 Christian Diefer

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as
   published by the Free Software Foundation.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef __SMBIOS_H
#define __SMBIOS_H

// enable for debug messages
// #define SMBIOSMSG 1

#define SMBIOS_MAGIC_DWORD 0x5F4D535F
#define DMI_STRING  "_DMI_"

#define RD_BIOS "bios"
#define RD_SYSTEM "system"
#define RD_BASEBOARD "baseboard"
#define RD_ENCLOSURE "enclosure"
#define RD_PROCESSOR "processor"
#define RD_MEMCTRL "memory_controller"
#define RD_MEMMOD "memory_module"
#define RD_CACHE "cache"
#define RD_PORT "port_connector"
#define RD_SLOT "system_slot"
#define RD_ONBOARD "onboard_device"
#define RD_OEMSTRINGS "oem_strings"
#define RD_SYSTEMCONFIG "system_configuration"
#define RD_BIOSLANG "bios_language"
#define RD_GROUPASSOC "group_association"
#define RD_EVENTLOG "system_event_log"
#define RD_MEMARRAY "physical_memory_array"
#define RD_MEMDEV "physical_memory_device"
#define RD_32MEMERR "32bit_memory_error_information"
#define RD_MEMMAPPEDADR "memory_array_mapped_address"
#define RD_MEMMAPPEDDEV "memory_device_mapped_address"
#define RD_POINTINGDEV "pointing_device"
#define RD_BATTERY "portable_battery"
#define RD_RESET "system_reset"
#define RD_SECURITY "hardware_security"
#define RD_PWRCTRL "system_power_controls"
#define RD_VOLTAGE "voltage_probe"
#define RD_COOLINGDEV "cooling_device"
#define RD_TEMP "temperature_probe"
#define RD_CURRENT "current_probe"
#define RD_RMTACCESS "out_of_band_remote_access"
#define RD_BIS "boot_integrity_services"
#define RD_BOOT_INFO "system_boot_information"
#define RD_64MEMERR "64bit_memory_error_information"
#define RD_MANAGDEV "management_device"
#define RD_MANAGDEVCOMP "management_device_component"
#define RD_MANAGDEVTHRESH "management_device_thresholds"
#define RD_MEMCHANNEL	"memory_channel"
#define RD_IPMI "ipmi_information"
#define RD_PWRSUP "system_power_supply"
#define RD_INACTIVE "inactive"
#define RD_EOT "end_of_table"

void getSMBIOS( char* buf );
void getCPUSpeed( char* buf );

extern PVOID biosVA;
extern USHORT smTableLength;

#ifdef FANIO_DRIVER_BUILD
extern PVOID biosVA2;
extern int biosVA2Mapped;
#endif

#endif
