/*
   I8kfanGUI V3.0
   Copyright(c) 2001-2006 Christian Diefer
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as 
   published by the Free Software Foundation.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "stdafx.h"
#include "AtlBase.h"
#include "i8kfangui.h"
#include "TOptions.h"
#include "OptionsCPUMon.h"
#include "ChipMonTab.h"
#include "I8kfanctrl.h"
#include "GlobalVars.h"

// CChipMonTabDlg dialog

IMPLEMENT_DYNAMIC(CChipMonTabDlg, CDialog)
CChipMonTabDlg::CChipMonTabDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CChipMonTabDlg::IDD, pParent)
  , m_bEnabled(TRUE)
  , m_bFan1(TRUE)
  , m_bFan2(FALSE)
  , m_iTurnOn1(0)
  , m_iTurnOff1(0)
  , m_iTurnOn2(0)
  , m_iTurnOff2(0)
  , m_iTurnOn3(0)
  , m_iTurnOff3(0)
  , m_iTurnOn4(0)
  , m_iTurnOff4(0)
  , m_iMonSpeed11(0)
  , m_iMonSpeed12(0)
  , m_iMonSpeed21(0)
  , m_iMonSpeed22(0)
  , m_iMonSpeed31(0)
  , m_iMonSpeed32(0)
  , m_iMonSpeed41(0)
  , m_iMonSpeed42(0)
  , m_iSensorSpeed11(0)
  , m_iSensorSpeed12(0)
  , m_iSensorSpeed21(0)
  , m_iSensorSpeed22(0)
  , m_iSensorSpeed31(0)
  , m_iSensorSpeed32(0)
  , m_iSensorSpeed41(0)
  , m_iSensorSpeed42(0)
{ }

CChipMonTabDlg::~CChipMonTabDlg()
{ }

void CChipMonTabDlg::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  DDX_Check(pDX, IDC_CHECK1, m_bEnabled);
  DDX_Check(pDX, IDC_CHECK2, m_bFan1);
  DDX_Check(pDX, IDC_CHECK4, m_bFan2);
  DDX_CBIndex(pDX, IDC_TURNON1, m_iTurnOn1);
  DDX_CBIndex(pDX, IDC_TURNOFF1, m_iTurnOff1);
  DDX_CBIndex(pDX, IDC_TURNON2, m_iTurnOn2);
  DDX_Text(pDX, IDC_TURNOFF2, m_iTurnOff2);
  DDX_CBIndex(pDX, IDC_TURNON3, m_iTurnOn3);
  DDX_Text(pDX, IDC_TURNOFF3, m_iTurnOff3);
  DDX_CBIndex(pDX, IDC_TURNON4, m_iTurnOn4);
  DDX_Text(pDX, IDC_TURNOFF4, m_iTurnOff4);
  DDX_CBIndex(pDX, IDC_MONSPEED00, m_iMonSpeed11);
  DDX_CBIndex(pDX, IDC_MONSPEED01, m_iMonSpeed12);
  DDX_CBIndex(pDX, IDC_MONSPEED10, m_iMonSpeed21);
  DDX_CBIndex(pDX, IDC_MONSPEED11, m_iMonSpeed22);
  DDX_CBIndex(pDX, IDC_MONSPEED20, m_iMonSpeed31);
  DDX_CBIndex(pDX, IDC_MONSPEED21, m_iMonSpeed32);
  DDX_CBIndex(pDX, IDC_MONSPEED30, m_iMonSpeed41);
  DDX_CBIndex(pDX, IDC_MONSPEED31, m_iMonSpeed42);
  DDX_Control(pDX, IDC_SENSOR00, m_cSensor11);
  DDX_Control(pDX, IDC_SPIN00, m_sSpin11);
  DDX_Text(pDX, IDC_SENSOR00, m_iSensorSpeed11);
  DDX_Control(pDX, IDC_SENSOR01, m_cSensor12);
  DDX_Text(pDX, IDC_SENSOR01, m_iSensorSpeed12);
  DDX_Control(pDX, IDC_SPIN01, m_sSpin12);
  DDX_Control(pDX, IDC_SENSOR10, m_cSensor21);
  DDX_Text(pDX, IDC_SENSOR10, m_iSensorSpeed21);
  DDX_Control(pDX, IDC_SPIN10, m_sSpin21);
  DDX_Control(pDX, IDC_SENSOR11, m_cSensor22);
  DDX_Text(pDX, IDC_SENSOR11, m_iSensorSpeed22);
  DDX_Control(pDX, IDC_SPIN11, m_sSpin22);
  DDX_Control(pDX, IDC_SENSOR20, m_cSensor31);
  DDX_Text(pDX, IDC_SENSOR20, m_iSensorSpeed31);
  DDX_Control(pDX, IDC_SPIN20, m_sSpin31);
  DDX_Control(pDX, IDC_SENSOR21, m_cSensor32);
  DDX_Text(pDX, IDC_SENSOR21, m_iSensorSpeed32);
  DDX_Control(pDX, IDC_SPIN21, m_sSpin32);
  DDX_Control(pDX, IDC_SENSOR30, m_cSensor41);
  DDX_Text(pDX, IDC_SENSOR30, m_iSensorSpeed41);
  DDX_Control(pDX, IDC_SPIN30, m_sSpin41);
  DDX_Control(pDX, IDC_SENSOR31, m_cSensor42);
  DDX_Text(pDX, IDC_SENSOR31, m_iSensorSpeed42);
  DDX_Control(pDX, IDC_SPIN31, m_sSpin42);
  DDX_Control(pDX, IDC_CHECK1, m_cTitle);
}

BEGIN_MESSAGE_MAP(CChipMonTabDlg, CDialog)
  ON_CBN_SELCHANGE(IDC_TURNOFF1, OnCbnSelchangeTurnoff1)
  ON_CBN_SELCHANGE(IDC_TURNON1, OnCbnSelchangeTurnon1)
  ON_CBN_SELCHANGE(IDC_TURNON2, OnCbnSelchangeTurnon2)
  ON_CBN_SELCHANGE(IDC_TURNON3, OnCbnSelchangeTurnon3)
  ON_CBN_SELCHANGE(IDC_TURNON4, OnCbnSelchangeTurnon4)
  ON_BN_CLICKED(IDC_CHECK1, OnCbnSelchangeChecks)
  ON_BN_CLICKED(IDC_CHECK2, OnCbnSelchangeChecks)
  ON_BN_CLICKED(IDC_CHECK4, OnCbnSelchangeChecks)
END_MESSAGE_MAP()


// CChipMonTabDlg message handlers
BOOL CChipMonTabDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

  CString s1;
  s1.LoadStringW( IDS_CHIPMON1 );

  CString name;
  name.Format( s1, options.fan1Alias );
  ((CWnd*)GetDlgItem(IDC_CHECK2))->SetWindowText( name );
  
  name.Format( s1, options.fan2Alias );
  ((CWnd*)GetDlgItem(IDC_CHECK4))->SetWindowText( name );

  m_sSpin11.SetBuddy( &m_cSensor11 );
  m_sSpin11.SetRange( 0, 63 );
  m_sSpin12.SetBuddy( &m_cSensor12 );
  m_sSpin12.SetRange( 0, 63 );
  m_sSpin21.SetBuddy( &m_cSensor21 );
  m_sSpin21.SetRange( 0, 63 );
  m_sSpin22.SetBuddy( &m_cSensor22 );
  m_sSpin22.SetRange( 0, 63 );
  m_sSpin31.SetBuddy( &m_cSensor31 );
  m_sSpin31.SetRange( 0, 63 );
  m_sSpin32.SetBuddy( &m_cSensor32 );
  m_sSpin32.SetRange( 0, 63 );
  m_sSpin41.SetBuddy( &m_cSensor41 );
  m_sSpin41.SetRange( 0, 63 );
  m_sSpin42.SetBuddy( &m_cSensor42 );
  m_sSpin42.SetRange( 0, 63 );

  s1.LoadStringW( IDS_CHIPMON2 );
  m_cTitle.SetWindowTextW( s1 );

  if( options.fahrenHeit )
    changeUnits( true );

  UpdateData( FALSE );

  return TRUE;
}

void CChipMonTabDlg::changeUnits( BOOL fahrenHeit )
{
  fa = fahrenHeit;
  CString s1, s2;
  s1.LoadStringW( IDS_CHIPMON3 );
  s2.LoadStringW( IDS_CHIPMON4 );
  ((CWnd*)GetDlgItem(IDC_STATIC34))->SetWindowText( fa ? s1 : s2 );
  ((CWnd*)GetDlgItem(IDC_STATIC35))->SetWindowText( fa ? s1 : s2 );
  ((CWnd*)GetDlgItem(IDC_STATIC36))->SetWindowText( fa ? s1 : s2 );
  ((CWnd*)GetDlgItem(IDC_STATIC37))->SetWindowText( fa ? s1 : s2 );
  ((CWnd*)GetDlgItem(IDC_STATIC38))->SetWindowText( fa ? s1 : s2 );
  ((CWnd*)GetDlgItem(IDC_STATIC39))->SetWindowText( fa ? s1 : s2 );
  ((CWnd*)GetDlgItem(IDC_STATIC40))->SetWindowText( fa ? s1 : s2 );
  ((CWnd*)GetDlgItem(IDC_STATIC41))->SetWindowText( fa ? s1 : s2 );

  changeBoxUnits( IDC_TURNON1, 20, 70, fahrenHeit );
  changeBoxUnits( IDC_TURNON2, 20, 75, fahrenHeit );
  changeBoxUnits( IDC_TURNON3, 30, 85, fahrenHeit );
  changeBoxUnits( IDC_TURNON4, 30, 85, fahrenHeit );
  changeBoxUnits( IDC_TURNOFF1, 20, 60, fahrenHeit );

  UpdateData();

  m_iTurnOff2 = fa ? options.convertTemp( m_iTurnOn1+20, FAHRENHEIT) : m_iTurnOn1+20;
  m_iTurnOff3 = fa ? options.convertTemp( m_iTurnOn2+20, FAHRENHEIT) : m_iTurnOn2+20;;
  m_iTurnOff4 = fa ? options.convertTemp( m_iTurnOn3+30, FAHRENHEIT) : m_iTurnOn3+30;;

  UpdateData( FALSE );
}

void CChipMonTabDlg::changeBoxUnits( int elem, int t1, int t2, BOOL fahrenHeit )
{
  CComboBox* cb = (CComboBox*)GetDlgItem( elem );
  int curSel = cb->GetCurSel();

  cb->ResetContent();
  
  for( int i=t1; i<=t2; i++ )
  {
	CString buf;
	buf.Format( L"%d", fahrenHeit ? options.convertTemp(i,FAHRENHEIT) : i );
    cb->AddString( buf );
  }

  cb->SetCurSel( curSel );
}


void CChipMonTabDlg::OnCbnSelchangeTurnoff1()
{ }

void CChipMonTabDlg::OnCbnSelchangeTurnon1()
{
  UpdateData();
  m_iTurnOff2 = fa ? options.convertTemp(m_iTurnOn1+20,FAHRENHEIT) : m_iTurnOn1+20;
  UpdateData( FALSE );
}

void CChipMonTabDlg::OnCbnSelchangeTurnon2()
{
  UpdateData();
  m_iTurnOff3 = fa ? options.convertTemp(m_iTurnOn2+20,FAHRENHEIT) : m_iTurnOn2+20;
  UpdateData( FALSE );	
}

void CChipMonTabDlg::OnCbnSelchangeTurnon3()
{
  UpdateData();
  m_iTurnOff4 = fa ? options.convertTemp(m_iTurnOn3+30,FAHRENHEIT) : m_iTurnOn3+30;
  UpdateData( FALSE );	
}

void CChipMonTabDlg::OnCbnSelchangeTurnon4()
{
  UpdateData();
}

void CChipMonTabDlg::setValues( TMonSettings* ms )
{
  if( ms->chipsetFan[0] && options.numFans<=0 )
    ms->chipsetFan[0] = FALSE;

  if( ms->chipsetFan[1] && options.numFans<=1 )
    ms->chipsetFan[1] = FALSE;

  this->ms = ms;
  m_bEnabled = ms->monEnabled[3];
  m_bFan1 = ms->chipsetFan[0];
  m_bFan2 = ms->chipsetFan[1];
  m_iTurnOn1 = ms->chipsetMonTemp[0]-20;
  m_iTurnOff1 = ms->chipsetMonTemp[1]-20;
  m_iTurnOn2 = ms->chipsetMonTemp[2]-20;
  m_iTurnOff2 = fa ? options.convertTemp(ms->chipsetMonTemp[3],FAHRENHEIT) : ms->chipsetMonTemp[3];
  m_iTurnOn3 = ms->chipsetMonTemp[4]-30;
  m_iTurnOff3 = fa ? options.convertTemp(ms->chipsetMonTemp[5],FAHRENHEIT) : ms->chipsetMonTemp[5];
  m_iTurnOn4 = ms->chipsetMonTemp[6]-30;
  m_iTurnOff4 = fa ? options.convertTemp(ms->chipsetMonTemp[7],FAHRENHEIT) : ms->chipsetMonTemp[7];
  m_iMonSpeed11 = ms->chipsetFanSpeeds[0];
  m_iMonSpeed21 = ms->chipsetFanSpeeds[1];
  m_iMonSpeed31 = ms->chipsetFanSpeeds[2];
  m_iMonSpeed41 = ms->chipsetFanSpeeds[3];
  m_iMonSpeed12 = ms->chipsetFanSpeeds[4];
  m_iMonSpeed22 = ms->chipsetFanSpeeds[5];
  m_iMonSpeed32 = ms->chipsetFanSpeeds[6];
  m_iMonSpeed42 = ms->chipsetFanSpeeds[7];
  m_iSensorSpeed11 = ms->chipsetFanSpeeds[8];
  m_iSensorSpeed21 = ms->chipsetFanSpeeds[9];
  m_iSensorSpeed31 = ms->chipsetFanSpeeds[10];
  m_iSensorSpeed41 = ms->chipsetFanSpeeds[11];
  m_iSensorSpeed12 = ms->chipsetFanSpeeds[12];
  m_iSensorSpeed22 = ms->chipsetFanSpeeds[13];
  m_iSensorSpeed32 = ms->chipsetFanSpeeds[14];
  m_iSensorSpeed42 = ms->chipsetFanSpeeds[15];

  setConstraints();

  UpdateData( FALSE );
}

void CChipMonTabDlg::sensorSwitch( BOOL hw )
{
  ((CWnd*)GetDlgItem(IDC_MONSPEED00))->ShowWindow( !hw );
  ((CWnd*)GetDlgItem(IDC_SENSOR00))->ShowWindow( hw );
  ((CWnd*)GetDlgItem(IDC_SPIN00))->ShowWindow( hw );
  ((CWnd*)GetDlgItem(IDC_MONSPEED01))->ShowWindow( !hw );
  ((CWnd*)GetDlgItem(IDC_SENSOR01))->ShowWindow( hw );
  ((CWnd*)GetDlgItem(IDC_SPIN01))->ShowWindow( hw );
  ((CWnd*)GetDlgItem(IDC_MONSPEED10))->ShowWindow( !hw );
  ((CWnd*)GetDlgItem(IDC_SENSOR10))->ShowWindow( hw );
  ((CWnd*)GetDlgItem(IDC_SPIN10))->ShowWindow( hw );
  ((CWnd*)GetDlgItem(IDC_MONSPEED11))->ShowWindow( !hw );
  ((CWnd*)GetDlgItem(IDC_SENSOR11))->ShowWindow( hw );
  ((CWnd*)GetDlgItem(IDC_SPIN11))->ShowWindow( hw );
  ((CWnd*)GetDlgItem(IDC_MONSPEED20))->ShowWindow( !hw );
  ((CWnd*)GetDlgItem(IDC_SENSOR20))->ShowWindow( hw );
  ((CWnd*)GetDlgItem(IDC_SPIN20))->ShowWindow( hw );
  ((CWnd*)GetDlgItem(IDC_MONSPEED21))->ShowWindow( !hw );
  ((CWnd*)GetDlgItem(IDC_SENSOR21))->ShowWindow( hw );
  ((CWnd*)GetDlgItem(IDC_SPIN21))->ShowWindow( hw );
  ((CWnd*)GetDlgItem(IDC_MONSPEED30))->ShowWindow( !hw );
  ((CWnd*)GetDlgItem(IDC_SENSOR30))->ShowWindow( hw );
  ((CWnd*)GetDlgItem(IDC_SPIN30))->ShowWindow( hw );
  ((CWnd*)GetDlgItem(IDC_MONSPEED31))->ShowWindow( !hw );
  ((CWnd*)GetDlgItem(IDC_SENSOR31))->ShowWindow( hw );
  ((CWnd*)GetDlgItem(IDC_SPIN31))->ShowWindow( hw );
}

void CChipMonTabDlg::setConstraints()
{
  ((CWnd*)GetDlgItem(IDC_TURNON1))->EnableWindow( m_bEnabled );
  ((CWnd*)GetDlgItem(IDC_TURNOFF1))->EnableWindow( m_bEnabled );
  ((CWnd*)GetDlgItem(IDC_TURNON2))->EnableWindow( m_bEnabled );
  ((CWnd*)GetDlgItem(IDC_TURNOFF2))->EnableWindow( m_bEnabled );
  ((CWnd*)GetDlgItem(IDC_TURNON3))->EnableWindow( m_bEnabled );
  ((CWnd*)GetDlgItem(IDC_TURNOFF3))->EnableWindow( m_bEnabled );
  ((CWnd*)GetDlgItem(IDC_TURNON4))->EnableWindow( m_bEnabled );
  ((CWnd*)GetDlgItem(IDC_TURNOFF4))->EnableWindow( m_bEnabled );

  ((CWnd*)GetDlgItem(IDC_CHECK2))->EnableWindow( m_bEnabled && options.numFans>0 );
  ((CWnd*)GetDlgItem(IDC_CHECK4))->EnableWindow( m_bEnabled && options.numFans>1 );

  ((CWnd*)GetDlgItem(IDC_MONSPEED00))->EnableWindow( m_bEnabled && m_bFan1 && options.numFans>0 );
  ((CWnd*)GetDlgItem(IDC_MONSPEED01))->EnableWindow( m_bEnabled && m_bFan2 && options.numFans>1 );
  ((CWnd*)GetDlgItem(IDC_MONSPEED10))->EnableWindow( m_bEnabled && m_bFan1 && options.numFans>0 );
  ((CWnd*)GetDlgItem(IDC_MONSPEED11))->EnableWindow( m_bEnabled && m_bFan2 && options.numFans>1 );
  ((CWnd*)GetDlgItem(IDC_MONSPEED20))->EnableWindow( m_bEnabled && m_bFan1 && options.numFans>0 );
  ((CWnd*)GetDlgItem(IDC_MONSPEED21))->EnableWindow( m_bEnabled && m_bFan2 && options.numFans>1 );
  ((CWnd*)GetDlgItem(IDC_MONSPEED30))->EnableWindow( m_bEnabled && m_bFan1 && options.numFans>0 );
  ((CWnd*)GetDlgItem(IDC_MONSPEED31))->EnableWindow( m_bEnabled && m_bFan2 && options.numFans>1 );

  ((CWnd*)GetDlgItem(IDC_SENSOR00))->EnableWindow( m_bEnabled && m_bFan1 && options.numFans>0 );
  ((CWnd*)GetDlgItem(IDC_SENSOR01))->EnableWindow( m_bEnabled && m_bFan2 && options.numFans>1 );
  ((CWnd*)GetDlgItem(IDC_SENSOR10))->EnableWindow( m_bEnabled && m_bFan1 && options.numFans>0 );
  ((CWnd*)GetDlgItem(IDC_SENSOR11))->EnableWindow( m_bEnabled && m_bFan2 && options.numFans>1 );
  ((CWnd*)GetDlgItem(IDC_SENSOR20))->EnableWindow( m_bEnabled && m_bFan1 && options.numFans>0 );
  ((CWnd*)GetDlgItem(IDC_SENSOR21))->EnableWindow( m_bEnabled && m_bFan2 && options.numFans>1 );
  ((CWnd*)GetDlgItem(IDC_SENSOR30))->EnableWindow( m_bEnabled && m_bFan1 && options.numFans>0 );
  ((CWnd*)GetDlgItem(IDC_SENSOR31))->EnableWindow( m_bEnabled && m_bFan2 && options.numFans>1 );
}

void CChipMonTabDlg::OnCbnSelchangeChecks()
{
  UpdateData();
  setConstraints();
}

void CChipMonTabDlg::getVars()
{
  if( m_bEnabled )
  {
    if( m_iTurnOff1+20 < m_iTurnOn1+20
    &&  m_iTurnOn1+20 < m_iTurnOn2+20 
    &&  m_iTurnOn2+20 < m_iTurnOn3+30
    &&  m_iTurnOn3+30 < m_iTurnOn4+30 )
      ;
    else
    {
      CString s1, s2;
      s1.LoadStringW( IDS_CHIPMON5 );
      s2.LoadStringW( IDS_ERROR );
      MessageBox( s1, s2, MB_ICONEXCLAMATION|MB_OK );
      return;
    }
  }

  ms->monEnabled[3] = m_bEnabled;
  ms->chipsetFan[0] = m_bFan1;
  ms->chipsetFan[1] = m_bFan2;
  ms->chipsetMonTemp[0] = m_iTurnOn1+20;
  ms->chipsetMonTemp[1] = m_iTurnOff1+20;
  ms->chipsetMonTemp[2] = m_iTurnOn2+20;
  ms->chipsetMonTemp[3] = m_iTurnOn1+20;
  ms->chipsetMonTemp[4] = m_iTurnOn3+30;
  ms->chipsetMonTemp[5] = m_iTurnOn2+20;
  ms->chipsetMonTemp[6] = m_iTurnOn4+30;
  ms->chipsetMonTemp[7] = m_iTurnOn3+30;
  ms->chipsetFanSpeeds[0] = m_iMonSpeed11;
  ms->chipsetFanSpeeds[1] = m_iMonSpeed21;
  ms->chipsetFanSpeeds[2] = m_iMonSpeed31;
  ms->chipsetFanSpeeds[3] = m_iMonSpeed41;
  ms->chipsetFanSpeeds[4] = m_iMonSpeed12;
  ms->chipsetFanSpeeds[5] = m_iMonSpeed22;
  ms->chipsetFanSpeeds[6] = m_iMonSpeed32;
  ms->chipsetFanSpeeds[7] = m_iMonSpeed42;
  ms->chipsetFanSpeeds[8] = m_iSensorSpeed11;
  ms->chipsetFanSpeeds[9] = m_iSensorSpeed21;
  ms->chipsetFanSpeeds[10] = m_iSensorSpeed31;
  ms->chipsetFanSpeeds[11] = m_iSensorSpeed41;
  ms->chipsetFanSpeeds[12] = m_iSensorSpeed12;
  ms->chipsetFanSpeeds[13] = m_iSensorSpeed22;
  ms->chipsetFanSpeeds[14] = m_iSensorSpeed32;
  ms->chipsetFanSpeeds[15] = m_iSensorSpeed42;
}
