/*
   I8kfanGUI V3.1
   Copyright(c) 2001-2007 Christian Diefer
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as 
   published by the Free Software Foundation.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#pragma once
#include "afxwin.h"

#ifndef __CPUDATA_H
#define __CPUDATA_H

class TCPUData
{
public:
  void checkCPUType();

  BOOL supportsCPUID;
  WORD cpuType;
  CString cpuStr;
  DWORD exlevel;
  int maxIDVal;
  char vendorID[16];
  int brandID;
  int family;
  DWORD features;
  DWORD exfeatures;
  DWORD exfeatures2;
  int vendor;
  int familyid;
  int modelid;
  wchar_t* cacheSize;
  wchar_t* structureSize;
  wchar_t* coreType;
  int steppingid;
  int typid;
  wchar_t* brandStr;
  BOOL f_fpu;
  BOOL f_vme;
  BOOL f_de;
  BOOL f_pse;
  BOOL f_tsc;
  BOOL f_msr;
  BOOL f_pae;
  BOOL f_mce;
  BOOL f_c8x;
  BOOL f_apic;
  BOOL f_sep;
  BOOL f_mtrr;
  BOOL f_pge;
  BOOL f_mca;
  BOOL f_cmov;
  BOOL f_pse36;
  BOOL f_psn;
  BOOL f_mmx;
  BOOL f_pat;
  BOOL f_fxsr;
  BOOL f_fcmov;
  BOOL f_fsc;
  BOOL f_mmxext;
  BOOL f_cxmmx;
  BOOL f_3dnow;
  BOOL f_3dnowext;
  BOOL f_sse;
  BOOL f_sse2;
  BOOL f_ss;
  BOOL f_htt;
  BOOL f_tm1;
  BOOL f_acpi;
  BOOL f_ia64;
  BOOL f_pbe;
  BOOL f_sse3;
  BOOL f_mon;
  BOOL f_cpl;
  BOOL f_vmx;
  BOOL f_est;
  BOOL f_tm2;
  BOOL f_l1id;
  BOOL f_c16b; 
  BOOL f_xtpr;
  BOOL f_em64t;
  BOOL f_dts;
  wchar_t flagText[65536];

private:
  void init();
  void getCPUFeatures();
  void getCPUType();
  void identifyIntel();
  void identifyAMD();
  void identifyCyrix();
  void Message( LPCTSTR lpszMessage );
  void readCPUIDLevel( unsigned level, unsigned level2, ULONG* target );
  void readCacheInfo();
  void printCacheInfo( int value );
};

typedef struct cachid {
  int id;
  wchar_t* text;
} CACHEID;

#endif
