/*
   I8kfanGUI V3.0
   Copyright(c) 2001-2006 Christian Diefer
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as 
   published by the Free Software Foundation.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef htspeed_h
#define htspeed_h

typedef unsigned short ushort;
typedef unsigned long ulong;

int cpuSpeedHT();
int getRDTSCSpeed( struct FREQ_INFO* info );

struct FREQ_INFO
{
  unsigned long in_cycles;    // Internal clock cycles during test
  unsigned long ex_ticks;     // Microseconds elapsed during test
  UINT64 raw_freq;            // Raw frequency of CPU in MHz
  UINT64 norm_freq;           // Normalized frequency of CPU in MHz
};


#define TSC_SUPPORT 0x00000010
#define CLONE_MASK 0x8000
#define ROUND_THRESHOLD 6
#define TOLERANCE 1

#ifdef _WIN64
extern "C" void readRDTSC( UINT64* v );
#endif

#endif
