/*
   I8kfanGUI V3.0
   Copyright(c) 2001-2006 Christian Diefer
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as 
   published by the Free Software Foundation.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "stdafx.h"
#include "AtlBase.h"
#include "TOptions.h"
#include "i8kfangui.h"
#include "I8kfanguiOptionDlg.h"
#include "I8kfanctrl.h"
#include "OptionsAutostart.h"
#include "OptionsCPUMon.h"
#include "OptionsDisplay.h"
#include "OptionsReading.h"
#include "OptionsDirect.h"
#include "OptionsMisc.h"
#include "OptionsAdvanced.h"
#include "GlobalVars.h"
#include "OptionsIcons.h"

// globale Instanzen der einzelnen Tabs:
static COptionsAutostart startDlg;
static COptionsCPUMon monDlg;
static COptionsDisplay dispDlg;
static COptionsReading readDlg;
static COptionsDirect directDlg;
static COptionsMisc miscDlg;
static COptionsAdvanced advDlg;
static COptionsIcons iconDlg;

// CI8kfanguiOptionDlg Dialog

IMPLEMENT_DYNAMIC(CI8kfanguiOptionDlg, CDialog)
CI8kfanguiOptionDlg::CI8kfanguiOptionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CI8kfanguiOptionDlg::IDD, pParent)
{ }

CI8kfanguiOptionDlg::~CI8kfanguiOptionDlg()
{ }

void CI8kfanguiOptionDlg::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange( pDX );
  DDX_Control(pDX, IDC_TAB1, tabCtrl);
}

BEGIN_MESSAGE_MAP(CI8kfanguiOptionDlg, CDialog)
  ON_NOTIFY(TCN_SELCHANGE, IDC_TAB1, OnTcnSelchangeTab1)
END_MESSAGE_MAP()


// CI8kfanguiOptionDlg Nachrichten-Handler

// erst GUI-Elemente anlegen, dann Dialog anzeigen
BOOL CI8kfanguiOptionDlg::OnInitDialog()
{
  log( L"OnInitDialog von Options" );
  CDialog::OnInitDialog();

  if( !glb_pCallPI && options.readCPUVar==2 )
    options.readCPUVar = 0;

  if( options.opmode==TEMPMONITOR || options.opmode==OBSERVERMODE )
    options.autoFanSetting = FALSE;

  // Tab Header anlegen:
  TC_ITEM TabCtrlItem;
  TabCtrlItem.mask = TCIF_TEXT;
  CString s1;
  wchar_t text[64];
  s1.LoadStringW( IDS_OPT1 );
  wcscpy_s( text, s1 );
  TabCtrlItem.pszText = text;
  tabCtrl.InsertItem( 0, &TabCtrlItem );
  s1.LoadStringW( IDS_OPT2 );
  wcscpy_s( text, s1 );
  TabCtrlItem.pszText = text;
  tabCtrl.InsertItem( 1, &TabCtrlItem );
  s1.LoadStringW( IDS_OPT3 );
  wcscpy_s( text, s1 );
  TabCtrlItem.pszText = text;
  tabCtrl.InsertItem( 2, &TabCtrlItem );
  s1.LoadStringW( IDS_OPT4 );
  wcscpy_s( text, s1 );
  TabCtrlItem.pszText = text;
  tabCtrl.InsertItem( 3, &TabCtrlItem );
  s1.LoadStringW( IDS_OPT5 );
  wcscpy_s( text, s1 );
  TabCtrlItem.pszText = text;
  tabCtrl.InsertItem( 4, &TabCtrlItem );
  s1.LoadStringW( IDS_OPT6 );
  wcscpy_s( text, s1 );
  TabCtrlItem.pszText = text;
  tabCtrl.InsertItem( 5, &TabCtrlItem );
  s1.LoadStringW( IDS_OPT7 );
  wcscpy_s( text, s1 );
  TabCtrlItem.pszText = text;
  tabCtrl.InsertItem( 6, &TabCtrlItem );
  s1.LoadStringW( IDS_OPT8 );
  wcscpy_s( text, s1 );
  TabCtrlItem.pszText = text;
  tabCtrl.InsertItem( 7, &TabCtrlItem );

  tabs[0] = &startDlg;
  tabs[1] = &monDlg;
  tabs[2] = &dispDlg;
  tabs[3] = &readDlg;
  tabs[4] = &directDlg;
  tabs[5] = &iconDlg;
  tabs[6] = &miscDlg;
  tabs[7] = &advDlg;

  startDlg.setParent( this );
  monDlg.setParent( this );
  dispDlg.setParent( this );
  readDlg.setParent( this );
  directDlg.setParent( this );
  iconDlg.setParent( this );
  miscDlg.setParent( this );
  advDlg.setParent( this );

  // die Tabs anlegen:
  startDlg.Create( IDD_OPTIONS_AUTOSTART, this );
  monDlg.Create( IDD_OPTIONS_CPUMON, this );
  dispDlg.Create( IDD_OPTIONS_DISPLAY, this );
  readDlg.Create( IDD_OPTIONS_READING, this );
  directDlg.Create( IDD_OPTIONS_DIRECT, this );
  iconDlg.Create( IDD_OPTIONS_ICONS, this );
  miscDlg.Create( IDD_OPTIONS_MISC, this );
  advDlg.Create( IDD_OPTIONS_ADVANCED, this );

  // 'Autostart'-Tab anzeigen, alle anderen ausblenden:
  startDlg.ShowWindow( SW_SHOW );
  monDlg.ShowWindow( SW_HIDE );
  dispDlg.ShowWindow( SW_HIDE );
  readDlg.ShowWindow( SW_HIDE );
  directDlg.ShowWindow( SW_HIDE );
  iconDlg.ShowWindow( SW_HIDE );
  miscDlg.ShowWindow( SW_HIDE );
  advDlg.ShowWindow( SW_HIDE );

  // Fensterposition und -gre berechnen:
  for( int i=0; i<8; i++ )
  {
    RECT rect;

    tabs[i]->GetClientRect( &rect );
    TabCtrl_AdjustRect( tabCtrl, 0, &rect );
    tabCtrl.ClientToScreen( &rect );
    ScreenToClient( &rect );

    tabs[i]->SetWindowPos( &wndTop,
                           rect.left,
                           rect.top,
                           rect.right - rect.left,
                           rect.bottom - rect.top + 22,
                           (i ? SWP_HIDEWINDOW : SWP_SHOWWINDOW) );

    // nur fr XP und hher (zerstrt Kompatibilitt mit Windows NT4 und 2000):
    if( glb_bWinXP && glb_pCallThemeEnable!=NULL )
      glb_pCallThemeEnable( tabs[i]->m_hWnd, ETDT_ENABLETAB );
  }

  // 'Temperature control'-Dialog
  //-----------------------------
  // umschalten zwischen SMBIOS- und HW-Sensor-Reglern fr Drehzahlauswahl:
  monDlg.sensorSwitch();

  startDlg.UpdateData( FALSE );
  monDlg.UpdateData( FALSE );
  dispDlg.UpdateData( FALSE );
  readDlg.UpdateData( FALSE );
  directDlg.UpdateData( FALSE );
  iconDlg.UpdateData( FALSE );
  miscDlg.UpdateData( FALSE );
  advDlg.UpdateData( FALSE );

  fieldConstraints();

  // im Tempmonitor-Tab auf Fahrenheit umschalten?
  if( options.fahrenHeit )
    monDlg.changeUnits( true );

  // Daten in Tabs anzeigen:
  startDlg.UpdateData( FALSE );
  monDlg.UpdateData( FALSE );
  dispDlg.UpdateData( FALSE );
  readDlg.UpdateData( FALSE );
  directDlg.UpdateData( FALSE );
  iconDlg.UpdateData( FALSE );
  miscDlg.UpdateData( FALSE );
  advDlg.UpdateData( FALSE );

  log( L"OnInitDialog von Options zuende" );

  return TRUE;
}

void CI8kfanguiOptionDlg::OnTcnSelchangeTab1( NMHDR *pNMHDR, LRESULT *pResult )
{
  int i = tabCtrl.GetCurSel();

  for( int x=0; x<8; x++ )
    tabs[x]->ShowWindow( x==i ? SW_SHOW : SW_HIDE );

  *pResult = 0;
}

void CI8kfanguiOptionDlg::OnOK()
{
  UpdateData();
  
  startDlg.UpdateData();
  monDlg.UpdateData();
  dispDlg.UpdateData();
  readDlg.UpdateData();
  directDlg.UpdateData();
  iconDlg.UpdateData();
  miscDlg.UpdateData();
  advDlg.UpdateData();

  monDlg.UpdateTabData();

  if( dispDlg.m_iUpdSec<0 || dispDlg.m_iUpdSec>=61 )
  {
    dispDlg.m_iUpdSec = 2;
    dispDlg.UpdateData( FALSE );
  }

  if( dispDlg.m_iUpdMinHD<0 || dispDlg.m_iUpdMinHD>=30 )
  {
    dispDlg.m_iUpdMinHD = 2;
    dispDlg.UpdateData( FALSE );
  }

  options.drawCPUTemp = (dispDlg.m_lDrawGraphs.GetSel(0) != 0);
  options.drawGPUTemp = (dispDlg.m_lDrawGraphs.GetSel(1) != 0);
  options.drawMemoryTemp = (dispDlg.m_lDrawGraphs.GetSel(2) != 0);
  options.drawChipsetTemp = (dispDlg.m_lDrawGraphs.GetSel(3) != 0);
  options.drawCPULoad = (dispDlg.m_lDrawGraphs.GetSel(4) != 0);
  options.drawCPUSpeed = (dispDlg.m_lDrawGraphs.GetSel(5) != 0);

  CDialog::OnOK();
}

void CI8kfanguiOptionDlg::fieldConstraints()
{
  startDlg.fieldConstraints( options.opmode==OBSERVERMODE );
}

void CI8kfanguiOptionDlg::getVars()
{
  startDlg.getVars();
  monDlg.getVars();
  readDlg.getVars();
  dispDlg.getVars();
  advDlg.getVars();
  directDlg.getVars();
  iconDlg.getVars();
  miscDlg.getVars();
}

// Callback-Routinen von untergeordneten Tabs
void CI8kfanguiOptionDlg::OnEnauto() 
{
  startDlg.UpdateData();
  monDlg.UpdateData();
  dispDlg.UpdateData();
  readDlg.UpdateData();
  directDlg.UpdateData();
  iconDlg.UpdateData();
  miscDlg.UpdateData();
  advDlg.UpdateData();

  fieldConstraints();

  startDlg.UpdateData( FALSE );
}

void CI8kfanguiOptionDlg::OnDirectSensor()
{
  startDlg.changeSliders( directDlg.m_bSensorSupport );
}

void CI8kfanguiOptionDlg::OnTempScale()
{
  dispDlg.UpdateData();
  monDlg.changeUnits( dispDlg.m_iTempScale==1 );
}

bool CI8kfanguiOptionDlg::tempMonChanged()
{
  return true;
}

void CI8kfanguiOptionDlg::hwSensorFound()
{
  advDlg.fieldConstraints();
}
