/*
   I8kfanGUI V3.0
   Copyright(c) 2001-2006 Christian Diefer

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as 
   published by the Free Software Foundation.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#pragma once
#include "afxwin.h"
#include "afxcmn.h"

class CMemoryMonTabDlg;

class CMemoryMonTabDlg : public CDialog
{
  DECLARE_DYNAMIC(CMemoryMonTabDlg)

public:
  CMemoryMonTabDlg(CWnd* pParent = NULL);   // standard constructor
  virtual ~CMemoryMonTabDlg();
  void setParent( COptionsCPUMon* p ) { parent=p; }
  void changeUnits( BOOL m_bFahrenHeit );

// Dialog Data
  enum { IDD = IDD_CPUMON_TAB };

protected:
  virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
  virtual BOOL OnInitDialog();
  afx_msg void OnCbnSelchangeTurnoff1();
  afx_msg void OnCbnSelchangeTurnon1();
  afx_msg void OnCbnSelchangeTurnon2();
  afx_msg void OnCbnSelchangeTurnon3();
  afx_msg void OnCbnSelchangeTurnon4();
  afx_msg void OnCbnSelchangeChecks();
  DECLARE_MESSAGE_MAP()

private:
  void changeBoxUnits( int elem, int t1, int t2, BOOL fahrenHeit );
  void setConstraints();

  COptionsCPUMon* parent;
  TMonSettings* ms;
  CButton m_cTitle;

public:
  BOOL fa;            // current status of temp boxes
  BOOL m_bEnabled;
  BOOL m_bFan1;
  BOOL m_bFan2;
  void setValues( TMonSettings* ms );
  void sensorSwitch( BOOL hw );
  void getVars();

  int m_iTurnOn1;
  int m_iTurnOff1;
  int m_iTurnOn2;
  int m_iTurnOff2;
  int m_iTurnOn3;
  int m_iTurnOff3;
  int m_iTurnOn4;
  int m_iTurnOff4;
  int m_iMonSpeed11;
  int m_iMonSpeed12;
  int m_iMonSpeed21;
  int m_iMonSpeed22;
  int m_iMonSpeed31;
  int m_iMonSpeed32;
  int m_iMonSpeed41;
  int m_iMonSpeed42;
  CEdit m_cSensor11;
  CSpinButtonCtrl m_sSpin11;
  int m_iSensorSpeed11;
  CEdit m_cSensor12;
  int m_iSensorSpeed12;
  CSpinButtonCtrl m_sSpin12;
  CEdit m_cSensor21;
  int m_iSensorSpeed21;
  CSpinButtonCtrl m_sSpin21;
  CEdit m_cSensor22;
  int m_iSensorSpeed22;
  CSpinButtonCtrl m_sSpin22;
  CEdit m_cSensor31;
  int m_iSensorSpeed31;
  CSpinButtonCtrl m_sSpin31;
  CEdit m_cSensor32;
  int m_iSensorSpeed32;
  CSpinButtonCtrl m_sSpin32;
  CEdit m_cSensor41;
  int m_iSensorSpeed41;
  CSpinButtonCtrl m_sSpin41;
  CEdit m_cSensor42;
  int m_iSensorSpeed42;
  CSpinButtonCtrl m_sSpin42;
};

