/*
   I8kfanGUI V3.0
   Copyright(c) 2001-2006 Christian Diefer
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as 
   published by the Free Software Foundation.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "stdafx.h"
#include "AtlBase.h"
#include "TOptions.h"
#include "i8kfangui.h"
#include "I8kfanguiOptionDlg.h"
#include "OptionsAutostart.h"
#include "I8kfanctrl.h"
#include "GlobalVars.h"

// COptionsAutostart Dialog

IMPLEMENT_DYNAMIC(COptionsAutostart, CDialog)
COptionsAutostart::COptionsAutostart(CWnd* pParent /*=NULL*/)
	: CDialog(COptionsAutostart::IDD, pParent)
  , m_bEnAuto(FALSE)
  , m_iOuterSpeed(0)
  , m_iInnerSpeed(0)
  , m_bAcOnly(FALSE)
  , m_bAutoTerminate(FALSE)
  , m_iAutoSpeed1(0)
  , m_iAutoSpeed2(0)
  , m_iSpeedInd1(0)
  , m_iSpeedInd2(0)
  , m_bAutoSetting(FALSE)
  , m_bHardwareFans(FALSE)
{ }

COptionsAutostart::~COptionsAutostart()
{ }

void COptionsAutostart::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  DDX_Check(pDX, IDC_ENAUTO, m_bEnAuto);
  DDX_CBIndex(pDX, IDC_OUTERCOMBO, m_iOuterSpeed);
  DDX_CBIndex(pDX, IDC_INNERCOMBO, m_iInnerSpeed);
  DDX_Check(pDX, IDC_ACONLY, m_bAcOnly);
  DDX_Check(pDX, IDC_TERMINATE, m_bAutoTerminate);
  DDX_Slider(pDX, IDC_SLIDER1, m_iAutoSpeed1);
  DDX_Slider(pDX, IDC_SLIDER2, m_iAutoSpeed2);
  DDX_Text(pDX, IDC_EDIT1, m_iSpeedInd1);
  DDX_Text(pDX, IDC_EDIT2, m_iSpeedInd2);
  DDX_Control(pDX, IDC_SLIDER1, m_scSlider1);
  DDX_Control(pDX, IDC_SLIDER2, m_scSlider2);
  DDX_Check(pDX, IDC_AUTOFANS, m_bAutoSetting);
  DDX_Check(pDX, IDC_HWFANS, m_bHardwareFans);
}


BEGIN_MESSAGE_MAP(COptionsAutostart, CDialog)
  ON_BN_CLICKED(IDC_ENAUTO, OnBnClickedEnauto)
  ON_WM_HSCROLL()
  ON_BN_CLICKED(IDC_AUTOFANS, OnBnClickedAutofans)
  ON_BN_CLICKED(IDC_HWFANS, OnBnClickedHwfans)
END_MESSAGE_MAP()


// COptionsAutostart Messagehandler
// erst GUI-Elemente anlegen, dann Dialog anzeigen
BOOL COptionsAutostart::OnInitDialog()
{
  CDialog::OnInitDialog();

  // Dimension 0-63 fr HW-Sensoren setzen
  m_scSlider1.SetRange( 0, 63, true );
  m_scSlider2.SetRange( 0, 63, true );

  CString s1, s2;
  s1.LoadStringW( IDS_AUTO1 );
  s2.Format( s1, options.fan1Alias );
  ((CWnd*)GetDlgItem(IDC_STATIC20))->SetWindowText( s2 );
  s2.Format( s1, options.fan2Alias );
  ((CWnd*)GetDlgItem(IDC_STATIC21))->SetWindowText( s2 );

  m_bEnAuto = options.autoStart;
  m_bAcOnly = options.acOnly;
  m_bAutoSetting = options.autoFanSetting;
  m_iInnerSpeed = options.autoInnerSlider;
  m_iOuterSpeed = options.autoOuterSlider;
  m_iAutoSpeed1 = options.autoSpeedDirect1;
  m_iAutoSpeed2 = options.autoSpeedDirect2;
  m_iSpeedInd1 = options.autoSpeedDirect1;
  m_iSpeedInd2 = options.autoSpeedDirect2;
  m_bHardwareFans = options.autoStartHWFans;
  m_bAutoTerminate = options.terminate;

  ((CWnd*)GetDlgItem(IDC_ACONLY))->EnableWindow( m_bEnAuto );
  ((CWnd*)GetDlgItem(IDC_AUTOFANS))->EnableWindow( m_bEnAuto );

  ((CWnd*)GetDlgItem(IDC_STATIC20))->EnableWindow( m_bEnAuto && m_bAutoSetting && options.numFans>0 );
  ((CWnd*)GetDlgItem(IDC_STATIC21))->EnableWindow( m_bEnAuto && m_bAutoSetting && options.numFans>1 );
  ((CWnd*)GetDlgItem(IDC_OUTERCOMBO))->EnableWindow( m_bEnAuto && m_bAutoSetting && options.numFans>0 );
  ((CWnd*)GetDlgItem(IDC_INNERCOMBO))->EnableWindow( m_bEnAuto && m_bAutoSetting && options.numFans>1 );
  ((CWnd*)GetDlgItem(IDC_HWFANS))->EnableWindow( m_bEnAuto && m_bAutoSetting );
  ((CWnd*)GetDlgItem(IDC_TERMINATE))->EnableWindow( m_bEnAuto && m_bAutoSetting );
  m_scSlider1.EnableWindow( m_bEnAuto && m_bAutoSetting && options.numFans>0 );
  m_scSlider2.EnableWindow( m_bEnAuto && m_bAutoSetting && options.numFans>1 );
  ((CWnd*)GetDlgItem(IDC_EDIT1))->EnableWindow( m_bEnAuto && m_bAutoSetting && options.numFans>0 );
  ((CWnd*)GetDlgItem(IDC_EDIT2))->EnableWindow( m_bEnAuto && m_bAutoSetting && options.numFans>1 );

  ((CWnd*)GetDlgItem(IDC_OUTERCOMBO))->ShowWindow( !options.autoStartHWFans );
  ((CWnd*)GetDlgItem(IDC_INNERCOMBO))->ShowWindow( !options.autoStartHWFans );
  m_scSlider1.ShowWindow( options.autoStartHWFans );
  m_scSlider2.ShowWindow( options.autoStartHWFans );
  ((CWnd*)GetDlgItem(IDC_EDIT1))->ShowWindow( options.autoStartHWFans );
  ((CWnd*)GetDlgItem(IDC_EDIT2))->ShowWindow( options.autoStartHWFans );

  return true;
}

// 'Enable autostart'
void COptionsAutostart::OnBnClickedEnauto()
{
  parent->OnEnauto();
}

// horizontales Scrollen im Sensorschieber: Position ermitteln und anzeigen
void COptionsAutostart::OnHScroll( UINT nSBCode, UINT nPos, CScrollBar* pScrollBar )
{
  int curpos;

  if( pScrollBar == ((CScrollBar*)GetDlgItem(IDC_SLIDER1)) )
  {
    curpos = m_scSlider1.GetPos();
    m_iAutoSpeed1 = curpos;
    m_iSpeedInd1 = curpos;
    UpdateData( FALSE );
  }
  else if( pScrollBar == ((CScrollBar*)GetDlgItem(IDC_SLIDER2)) )
  {
    curpos = m_scSlider2.GetPos();
    m_iAutoSpeed2 = curpos;
    m_iSpeedInd2 = curpos;
    UpdateData( FALSE );
  }

  CDialog::OnHScroll( nSBCode, nPos, pScrollBar );
}

// Umschalten zwischen Sensorschiebern und SMBIOS-Reglern:
void COptionsAutostart::changeSliders( BOOL direct )
{
  ((CWnd*)GetDlgItem(IDC_INNERCOMBO))->ShowWindow( !direct );
  ((CWnd*)GetDlgItem(IDC_OUTERCOMBO))->ShowWindow( !direct );
  m_scSlider1.ShowWindow( direct );
  m_scSlider2.ShowWindow( direct );
  ((CWnd*)GetDlgItem(IDC_EDIT1))->ShowWindow( direct );
  ((CWnd*)GetDlgItem(IDC_EDIT2))->ShowWindow( direct );
}

// 'Enable automatic fan setting'
void COptionsAutostart::OnBnClickedAutofans()
{
  UpdateData();

  // Ein-/ausblenden der untergeordneten Optionen:
  ((CWnd*)GetDlgItem(IDC_STATIC20))->EnableWindow( m_bAutoSetting && options.numFans>0 );
  ((CWnd*)GetDlgItem(IDC_STATIC21))->EnableWindow( m_bAutoSetting && options.numFans>1 );
  ((CWnd*)GetDlgItem(IDC_OUTERCOMBO))->EnableWindow( m_bAutoSetting && options.numFans>0 );
  ((CWnd*)GetDlgItem(IDC_INNERCOMBO))->EnableWindow( m_bAutoSetting && options.numFans>1 );
  ((CWnd*)GetDlgItem(IDC_HWFANS))->EnableWindow( m_bAutoSetting );
  ((CWnd*)GetDlgItem(IDC_TERMINATE))->EnableWindow( m_bAutoSetting );
  m_scSlider1.EnableWindow( m_bAutoSetting && options.numFans>0 );
  m_scSlider2.EnableWindow( m_bAutoSetting && options.numFans>1 );
  ((CWnd*)GetDlgItem(IDC_EDIT1))->EnableWindow( m_bAutoSetting && options.numFans>0 );
  ((CWnd*)GetDlgItem(IDC_EDIT2))->EnableWindow( m_bAutoSetting && options.numFans>1 );
}

// 'Enable hardware sensor support'
void COptionsAutostart::OnBnClickedHwfans()
{
  UpdateData();

  if( m_bHardwareFans && options.sensorCheck )
  {
    CString s1, s2;
    s1.LoadStringW( IDS_AUTO2 );
    s2.LoadStringW( IDS_WARN );
    if( MessageBoxW(s1,s2,MB_ICONEXCLAMATION|MB_YESNO) == IDYES )
    {
      if( !detectFanSensor(glb_hHndFile) )
      {
        s1.LoadStringW( IDS_AUTO3 );
        s2.LoadStringW( IDS_ERROR );
        MessageBoxW( s1, s2, MB_ICONSTOP|MB_OK );
        m_bHardwareFans = FALSE;
        UpdateData( FALSE );
        return;
      }
      else
      {
        s1.LoadStringW( IDS_AUTO4 );
        s2.LoadStringW( IDS_INFO );
        MessageBoxW( s1, s2, MB_ICONINFORMATION|MB_OK );
        options.sensorCheck = false;
        options.compatibleSensor = true;
        parent->hwSensorFound();
      }
    }
    else
    {
      m_bHardwareFans = FALSE;
      UpdateData( FALSE );
      return;
    }
  }

  // Sensorschieber ein-/ausblenden je nachdem, ob ein Sensor gefunden wurde:
  ((CWnd*)GetDlgItem(IDC_OUTERCOMBO))->ShowWindow( !m_bHardwareFans );
  ((CWnd*)GetDlgItem(IDC_INNERCOMBO))->ShowWindow( !m_bHardwareFans );
  m_scSlider1.ShowWindow( m_bHardwareFans );
  m_scSlider2.ShowWindow( m_bHardwareFans );
  ((CWnd*)GetDlgItem(IDC_EDIT1))->ShowWindow( m_bHardwareFans );
  ((CWnd*)GetDlgItem(IDC_EDIT2))->ShowWindow( m_bHardwareFans );
}

void COptionsAutostart::getVars()
{
  options.autoStart = m_bEnAuto;
  options.acOnly = m_bAcOnly;
  options.autoFanSetting = m_bAutoSetting;
  options.autoInnerSlider = m_iInnerSpeed;
  options.autoOuterSlider = m_iOuterSpeed;
  options.autoSpeedDirect1 = m_iAutoSpeed1;
  options.autoSpeedDirect2 = m_iAutoSpeed2;
  options.autoStartHWFans = m_bHardwareFans;
  options.terminate = m_bAutoTerminate;
}

void COptionsAutostart::fieldConstraints( BOOL observerMode )
{
  if( (options.opmode==TEMPMONITOR || observerMode) && m_bEnAuto )
  {
    // temp control/observer mode & autostart enabled => disable autostart options
    ((CWnd*)GetDlgItem(IDC_ACONLY))->EnableWindow( true );
    ((CWnd*)GetDlgItem(IDC_AUTOFANS))->EnableWindow( false );
    ((CWnd*)GetDlgItem(IDC_STATIC20))->EnableWindow( false );
    ((CWnd*)GetDlgItem(IDC_STATIC21))->EnableWindow( false );
    ((CWnd*)GetDlgItem(IDC_INNERCOMBO))->EnableWindow( false );
    ((CWnd*)GetDlgItem(IDC_OUTERCOMBO))->EnableWindow( false );
    ((CWnd*)GetDlgItem(IDC_TERMINATE))->EnableWindow( false );
    ((CWnd*)GetDlgItem(IDC_HWFANS))->EnableWindow( false );
    m_scSlider1.EnableWindow( false );
    m_scSlider2.EnableWindow( false );
    ((CWnd*)GetDlgItem(IDC_EDIT1))->EnableWindow( false );
    ((CWnd*)GetDlgItem(IDC_EDIT2))->EnableWindow( false );
    m_bAutoSetting = FALSE;
  }
  else
  {
    // enable/disable autostart options
    ((CWnd*)GetDlgItem(IDC_ACONLY))->EnableWindow( m_bEnAuto );
    ((CWnd*)GetDlgItem(IDC_AUTOFANS))->EnableWindow( m_bEnAuto );

    // enable/disable auto fan setting options
    ((CWnd*)GetDlgItem(IDC_STATIC20))->EnableWindow( m_bEnAuto && m_bAutoSetting && options.numFans>0 );
    ((CWnd*)GetDlgItem(IDC_STATIC21))->EnableWindow( m_bEnAuto && m_bAutoSetting && options.numFans>1 );
    ((CWnd*)GetDlgItem(IDC_OUTERCOMBO))->EnableWindow( m_bEnAuto && m_bAutoSetting && options.numFans>0 );
    ((CWnd*)GetDlgItem(IDC_INNERCOMBO))->EnableWindow( m_bEnAuto && m_bAutoSetting && options.numFans>1 );
    ((CWnd*)GetDlgItem(IDC_HWFANS))->EnableWindow( m_bEnAuto && m_bAutoSetting );
    ((CWnd*)GetDlgItem(IDC_TERMINATE))->EnableWindow( m_bEnAuto && m_bAutoSetting );
    m_scSlider1.EnableWindow( m_bEnAuto && m_bAutoSetting && options.numFans>0 );
    m_scSlider2.EnableWindow( m_bEnAuto && m_bAutoSetting && options.numFans>1 );
    ((CWnd*)GetDlgItem(IDC_EDIT1))->EnableWindow( m_bEnAuto && m_bAutoSetting && options.numFans>0 );
    ((CWnd*)GetDlgItem(IDC_EDIT2))->EnableWindow( m_bEnAuto && m_bAutoSetting && options.numFans>1 );
  }
}