/*
   I8kfanGUI V3.0
   Copyright(c) 2001-2006 Christian Diefer
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as 
   published by the Free Software Foundation.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#pragma once
#include "afxcmn.h"

class CI8kfanguiOptionDlg;

// COptionsAutostart dialog

class COptionsAutostart : public CDialog
{
	DECLARE_DYNAMIC(COptionsAutostart)

public:
	COptionsAutostart(CWnd* pParent = NULL);   // standard constructor
	virtual ~COptionsAutostart();
  virtual BOOL OnInitDialog();
  void setParent( CI8kfanguiOptionDlg* p ) { parent=p; }
  void getVars();
  void changeSliders( BOOL direct );
  void fieldConstraints( BOOL observerMode );

// Dialog Data
	enum { IDD = IDD_OPTIONS_AUTOSTART };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
  afx_msg void OnBnClickedAutofans();
  afx_msg void OnHScroll( UINT nSBCode, UINT nPos, CScrollBar* pScrollBar );
  afx_msg void OnBnClickedHwfans();
	DECLARE_MESSAGE_MAP()

private:
  CI8kfanguiOptionDlg* parent;

public:
  BOOL m_bEnAuto;
  int m_iOuterSpeed;
  int m_iInnerSpeed;
  BOOL m_bAcOnly;
  BOOL m_bAutoTerminate;
  afx_msg void OnBnClickedEnauto();
  int m_iAutoSpeed1;
  int m_iAutoSpeed2;
  int m_iSpeedInd1;
  int m_iSpeedInd2;
  CSliderCtrl m_scSlider1;
  CSliderCtrl m_scSlider2;
  BOOL m_bAutoSetting;
  BOOL m_bHardwareFans;
};
