/*
   I8kfanGUI V3.0
   Copyright(c) 2001-2006 Christian Diefer
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as 
   published by the Free Software Foundation.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "stdafx.h"
#include "AtlBase.h"
#include "i8kfangui.h"
#include "TOptions.h"
#include "I8kfanguiOptionDlg.h"
#include "OptionsDirect.h"
#include "I8kfanctrl.h"
#include "GlobalVars.h"

// COptionsDirect dialog

IMPLEMENT_DYNAMIC(COptionsDirect, CDialog)
COptionsDirect::COptionsDirect(CWnd* pParent /*=NULL*/)
	: CDialog(COptionsDirect::IDD, pParent)
  , m_bSensorSupport(FALSE)
  , m_bFan1Force(FALSE)
  , m_bFan2Force(FALSE)
{ }

COptionsDirect::~COptionsDirect()
{ }

void COptionsDirect::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  DDX_Check(pDX, IDC_SENSORSUPPORT, m_bSensorSupport);
  DDX_Check(pDX, IDC_CHECK2, m_bFan1Force);
  DDX_Check(pDX, IDC_CHECK3, m_bFan2Force);
}


BEGIN_MESSAGE_MAP(COptionsDirect, CDialog)
  ON_BN_CLICKED(IDC_SENSORSUPPORT, OnBnClickedSensorsupport)
END_MESSAGE_MAP()


// COptionsDirect message handlers
// erst GUI-Elemente anlegen, dann Dialog anzeigen
BOOL COptionsDirect::OnInitDialog()
{
  CDialog::OnInitDialog();

  m_bSensorSupport = options.sensorSupport;

  m_bFan1Force = options.fan1Force;
  m_bFan2Force = options.fan2Force;

  CString s1, s2;

  s1.LoadStringW( IDS_OPTDIR1 );

  s2.Format( s1, glb_szFan1AliasUpper );
  ((CWnd*)GetDlgItem(IDC_CHECK2))->SetWindowTextW( s2 );

  s2.Format( s1, glb_szFan2AliasUpper );
  ((CWnd*)GetDlgItem(IDC_CHECK3))->SetWindowTextW( s2 );

  UpdateData( FALSE );

  return true;
}

void COptionsDirect::OnBnClickedSensorsupport()
{
  UpdateData();

  if( m_bSensorSupport && options.sensorCheck )
  {
    CString s1, s2;
    
    s1.LoadStringW( IDS_AUTO2 );
    s2.LoadStringW( IDS_WARN );

    if( MessageBoxW(s1,s2,MB_ICONEXCLAMATION|MB_YESNO) == IDYES )
    {
      if( !detectFanSensor(glb_hHndFile) )
      {
        s1.LoadStringW( IDS_AUTO3 );
        s2.LoadStringW( IDS_ERROR );
        MessageBoxW( s1,s2, MB_ICONSTOP|MB_OK );
        m_bSensorSupport = FALSE;
        UpdateData( FALSE );
        return;
      }
      else
      {
        s1.LoadStringW( IDS_AUTO4 );
        s2.LoadStringW( IDS_INFO );
        MessageBoxW( s1,s2, MB_ICONINFORMATION|MB_OK );
        options.sensorCheck = false;
        options.compatibleSensor = true;
        parent->hwSensorFound();
      }
    }
    else
    {
      m_bSensorSupport = FALSE;
      UpdateData( FALSE );
      return;
    }
  }

  parent->OnDirectSensor();
}

void COptionsDirect::getVars()
{
  options.sensorSupport = m_bSensorSupport;
  options.fan1Force = m_bFan1Force;
  options.fan2Force = m_bFan2Force;
}
