/*
   I8kfanGUI V3.0
   Copyright(c) 2001-2006 Christian Diefer
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as 
   published by the Free Software Foundation.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "stdafx.h"
#include "AtlBase.h"
#include "i8kfangui.h"
#include "TOptions.h"
#include "I8kfanguiOptionDlg.h"
#include "OptionsDisplay.h"
#include "GlobalVars.h"

// COptionsDisplay dialog

IMPLEMENT_DYNAMIC(COptionsDisplay, CDialog)
COptionsDisplay::COptionsDisplay(CWnd* pParent /*=NULL*/)
	: CDialog(COptionsDisplay::IDD, pParent)
  , m_iUpdSec(0)
  , m_iUpdMinHD(0)
  , m_bDiagram(FALSE)
  , m_iTempScale(1)
  , m_iFanForceInterval(2)
  , m_iColorTheme(0)
{ }

COptionsDisplay::~COptionsDisplay()
{ }

void COptionsDisplay::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  DDX_CBIndex(pDX, IDC_UPDSEC, m_iUpdSec);
  DDX_CBIndex(pDX, IDC_UPDSEC2, m_iUpdMinHD);
  DDX_CBIndex(pDX, IDC_UPDFANS, m_iFanForceInterval);
  DDX_Check(pDX, IDC_DIAGRAM, m_bDiagram);
  DDX_CBIndex(pDX, IDC_COMBO3, m_iTempScale);
  DDX_Control(pDX, IDC_LIST1, m_lDrawGraphs);
  DDX_CBIndex(pDX, IDC_SCALING, m_iSpeedScaling);
  DDX_CBIndex(pDX, IDC_COMBO1, m_iColorTheme);
}


BEGIN_MESSAGE_MAP(COptionsDisplay, CDialog)
  ON_BN_CLICKED(IDC_DIAGRAM, OnBnClickedDiagram)
  ON_CBN_SELCHANGE(IDC_COMBO3, OnCbnSelchangeCombo3)
END_MESSAGE_MAP()


// COptionsDisplay message handlers
// erst GUI-Elemente anlegen, dann Dialog anzeigen
BOOL COptionsDisplay::OnInitDialog()
{
  CDialog::OnInitDialog();

  m_iUpdSec = options.intervalCPU-1;
  m_iFanForceInterval = options.fanForceInterval;
  m_iUpdMinHD = (options.intervalHD/60)-1;
  m_bDiagram = options.showDiagram;
  m_iSpeedScaling = options.speedScaling-1;
  m_iTempScale = options.fahrenHeit ? 1 : 0;
  m_iColorTheme = options.colorTheme;

  CString s1;
  m_lDrawGraphs.ResetContent();

  s1.LoadStringW( IDS_OPTDIS1 ); m_lDrawGraphs.AddString( s1 );
  s1.LoadStringW( IDS_OPTDIS2 ); m_lDrawGraphs.AddString( s1 );
  s1.LoadStringW( IDS_OPTDIS3 ); m_lDrawGraphs.AddString( s1 );
  s1.LoadStringW( IDS_OPTDIS4 ); m_lDrawGraphs.AddString( s1 );
  s1.LoadStringW( IDS_OPTDIS5 ); m_lDrawGraphs.AddString( s1 );
  s1.LoadStringW( IDS_OPTDIS6 ); m_lDrawGraphs.AddString( s1 );
  m_lDrawGraphs.SetSel( 0, options.drawCPUTemp );
  m_lDrawGraphs.SetSel( 1, options.drawGPUTemp );
  m_lDrawGraphs.SetSel( 2, options.drawMemoryTemp );
  m_lDrawGraphs.SetSel( 3, options.drawChipsetTemp );
  m_lDrawGraphs.SetSel( 4, options.drawCPULoad );
  m_lDrawGraphs.SetSel( 5, options.drawCPUSpeed );

  UpdateData( FALSE );

  OnBnClickedDiagram();

  return true;
}

void COptionsDisplay::OnBnClickedDiagram()
{
  UpdateData();
  m_lDrawGraphs.EnableWindow( m_bDiagram );
  ((CWnd*)GetDlgItem(IDC_STATIC134))->EnableWindow( m_bDiagram );
  ((CWnd*)GetDlgItem(IDC_STATIC17))->EnableWindow( m_bDiagram );
  ((CWnd*)GetDlgItem(IDC_SCALING))->EnableWindow( m_bDiagram );
  ((CWnd*)GetDlgItem(IDC_STATIC7))->EnableWindow( m_bDiagram );
  ((CWnd*)GetDlgItem(IDC_COMBO1))->EnableWindow( m_bDiagram );
}

void COptionsDisplay::OnCbnSelchangeCombo3()
{
  parent->OnTempScale();
}

void COptionsDisplay::getVars()
{
  options.intervalCPU = m_iUpdSec+1;
  options.fanForceInterval = m_iFanForceInterval;
  options.intervalHD = (m_iUpdMinHD+1)*60;
  options.showDiagram = m_bDiagram;
  options.fahrenHeit = (m_iTempScale!=0);
  options.speedScaling = m_iSpeedScaling+1;
  options.colorTheme = m_iColorTheme;
}
