/*
   I8kfanGUI V3.0
   Copyright(c) 2001-2006 Christian Diefer
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as 
   published by the Free Software Foundation.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#pragma once
#include "afxwin.h"
#include "ColorComboEx.h"

class CI8kfanguiOptionDlg;

// COptionsDisplay dialog

class COptionsDisplay : public CDialog
{
	DECLARE_DYNAMIC(COptionsDisplay)

public:
	COptionsDisplay(CWnd* pParent = NULL);   // standard constructor
	virtual ~COptionsDisplay();
  void setParent( CI8kfanguiOptionDlg* p ) { parent=p; }
  void getVars();

// Dialog Data
	enum { IDD = IDD_OPTIONS_DISPLAY };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
  afx_msg void OnBnClickedAutoupdate();
  virtual BOOL OnInitDialog();
  afx_msg void OnBnClickedDiagram();
  afx_msg void OnCbnSelchangeCombo3();
  afx_msg void OnCbnSelchangeCheck1();
  afx_msg void OnCbnSelchangeCheck2();
  afx_msg void OnCbnSelchangeSpeedIcon();
	DECLARE_MESSAGE_MAP()

private:
  CI8kfanguiOptionDlg* parent;

public:
  int m_iUpdSec;
  int m_iFanForceInterval;
  int m_iUpdMinHD;
  BOOL m_bDiagram;
  int m_iTrayDisplay1;
  int m_iTrayDisplay2;
  BOOL m_bSpeedIcon;
  int m_iTempScale;
  CListBox m_lDrawGraphs;
  int m_iSpeedScaling;
  CColorComboEx m_cColor1;
  CColorComboEx m_cColor2;
  int m_iColor1;
  int m_iColor2;
  CColorComboEx m_cFanColor1;
  CColorComboEx m_cFanColor2;
  int m_iFanColor1;
  int m_iFanColor2;
  BOOL m_bTransparent;
  BOOL m_bFanTransparent;
  int m_iTrayFanSpeedDivider;
  BOOL m_bFanIconStateOnly;
protected:
  int m_iColorTheme;
};
