/*
   I8kfanGUI V3.0
   Copyright(c) 2001-2006 Christian Diefer
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as 
   published by the Free Software Foundation.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "stdafx.h"
#include "AtlBase.h"
#include "i8kfangui.h"
#include "TOptions.h"
#include "I8kfanguiOptionDlg.h"
#include "GlobalVars.h"
#include "OptionsIcons.h"

// COptionsIcons dialog

IMPLEMENT_DYNAMIC(COptionsIcons, CDialog)
COptionsIcons::COptionsIcons(CWnd* pParent /*=NULL*/)
	: CDialog(COptionsIcons::IDD, pParent)
  , m_iTrayDisplay1(0)
  , m_iTrayDisplay2(0)
  , m_iColor1(0)
  , m_iColor2(0)
  , m_bTransparent(FALSE)
  , m_iTrayDisplay1b(0)
  , m_iTrayDisplay2b(0)
  , m_iColor1b(0)
  , m_iColor2b(0)
  , m_bTransparentB(FALSE)
  , m_bSpeedIcon(FALSE)
  , m_iTrayFanSpeedDivider(0)
  , m_bFanIconStateOnly(FALSE)
  , m_bStatusIcon2(FALSE)
{ }

COptionsIcons::~COptionsIcons(void)
{ }

void COptionsIcons::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  DDX_CBIndex(pDX, IDC_COMBO1, m_iTrayDisplay1);
  DDX_CBIndex(pDX, IDC_COMBO2, m_iTrayDisplay2);
  DDX_Control(pDX, IDC_COMBO4, m_cColor1);
  DDX_Control(pDX, IDC_COMBO5, m_cColor2);
  DDX_CBIndex(pDX, IDC_COMBO4, m_iColor1);
  DDX_CBIndex(pDX, IDC_COMBO5, m_iColor2);
  DDX_Check(pDX, IDC_CHECK1, m_bTransparent);
  DDX_Check(pDX, IDC_CHECK4, m_bStatusIcon2);
  DDX_CBIndex(pDX, IDC_COMBO8, m_iTrayDisplay1b);
  DDX_CBIndex(pDX, IDC_COMBO9, m_iTrayDisplay2b);
  DDX_Control(pDX, IDC_COMBO10, m_cColor1b);
  DDX_Control(pDX, IDC_COMBO11, m_cColor2b);
  DDX_CBIndex(pDX, IDC_COMBO10, m_iColor1b);
  DDX_CBIndex(pDX, IDC_COMBO11, m_iColor2b);
  DDX_Check(pDX, IDC_CHECK5, m_bTransparentB);
  DDX_Check(pDX, IDC_SPEEDICON, m_bSpeedIcon);
  DDX_Control(pDX, IDC_COMBO6, m_cFanColor1);
  DDX_Control(pDX, IDC_COMBO7, m_cFanColor2);
  DDX_CBIndex(pDX, IDC_COMBO6, m_iFanColor1);
  DDX_CBIndex(pDX, IDC_COMBO7, m_iFanColor2);
  DDX_Check(pDX, IDC_CHECK2, m_bFanTransparent);
  DDX_Text(pDX, IDC_EDIT1, m_iTrayFanSpeedDivider);
  DDX_Check(pDX, IDC_STATEONLY, m_bFanIconStateOnly);
}

BEGIN_MESSAGE_MAP(COptionsIcons, CDialog)
  ON_BN_CLICKED(IDC_CHECK1, OnCbnSelchangeCheck1)
  ON_BN_CLICKED(IDC_CHECK2, OnCbnSelchangeCheck2)
  ON_BN_CLICKED(IDC_SPEEDICON, OnCbnSelchangeSpeedIcon)
  ON_BN_CLICKED(IDC_CHECK4, &COptionsIcons::OnBnClickedCheck4)
  ON_BN_CLICKED(IDC_CHECK5, &COptionsIcons::OnBnClickedCheck5)
END_MESSAGE_MAP()

BOOL COptionsIcons::OnInitDialog()
{
  CDialog::OnInitDialog();

  m_iTrayDisplay1 = options.trayIcon1;
  m_iTrayDisplay2 = options.trayIcon2;
  m_iColor1 = options.trayColor1;
  m_iColor2 = options.trayColor2;
  m_bTransparent = options.transparentBkg;

  m_bStatusIcon2 = options.statusIcon2;
  m_iTrayDisplay1b = options.trayIcon1b;
  m_iTrayDisplay2b = options.trayIcon2b;
  m_iColor1b = options.trayColor1b;
  m_iColor2b = options.trayColor2b;
  m_bTransparentB = options.transparentBkgB;

  m_bSpeedIcon = options.speedIcon;
  m_iFanColor1 = options.fanTrayColor1;
  m_iFanColor2 = options.fanTrayColor2;
  m_bFanTransparent = options.fanTransparentBkg;
  m_iTrayFanSpeedDivider = options.fanTraySpeedDivider;
  m_bFanIconStateOnly = options.fanIconStateOnly;

  ((CWnd*)GetDlgItem(IDC_COMBO5))->EnableWindow( !m_bTransparent );
  ((CWnd*)GetDlgItem(IDC_STATIC345))->EnableWindow( !m_bTransparent );

  UpdateData( FALSE );

  OnCbnSelchangeSpeedIcon();
  OnBnClickedCheck4();

  return true;
}

void COptionsIcons::OnCbnSelchangeCheck1()
{
  UpdateData();
  ((CWnd*)GetDlgItem(IDC_COMBO5))->EnableWindow( !m_bTransparent );
  ((CWnd*)GetDlgItem(IDC_STATIC345))->EnableWindow( !m_bTransparent );
}

void COptionsIcons::OnCbnSelchangeCheck2()
{
  UpdateData();
  ((CWnd*)GetDlgItem(IDC_COMBO7))->EnableWindow( !m_bFanTransparent );
  ((CWnd*)GetDlgItem(IDC_STATIC999))->EnableWindow( !m_bFanTransparent );
}

void COptionsIcons::getVars()
{
  options.trayIcon1 = m_iTrayDisplay1;
  options.trayIcon2 = m_iTrayDisplay2;
  options.trayColor1 = m_iColor1;
  options.trayColor2 = m_iColor2;
  options.transparentBkg = m_bTransparent;

  options.statusIcon2 = m_bStatusIcon2;
  options.trayIcon1b = m_iTrayDisplay1b;
  options.trayIcon2b = m_iTrayDisplay2b;
  options.trayColor1b = m_iColor1b;
  options.trayColor2b = m_iColor2b;
  options.transparentBkgB = m_bTransparentB;

  options.speedIcon = m_bSpeedIcon;
  options.fanTrayColor1 = m_iFanColor1;
  options.fanTrayColor2 = m_iFanColor2;
  options.fanTransparentBkg = m_bFanTransparent;
  options.fanIconStateOnly = m_bFanIconStateOnly;

  if( m_iTrayFanSpeedDivider > 0 )
    options.fanTraySpeedDivider = m_iTrayFanSpeedDivider;
}

void COptionsIcons::OnCbnSelchangeSpeedIcon()
{
  UpdateData();

  ((CWnd*)GetDlgItem(IDC_COMBO6))->EnableWindow( m_bSpeedIcon );
  ((CWnd*)GetDlgItem(IDC_STATIC998))->EnableWindow( m_bSpeedIcon );
  ((CWnd*)GetDlgItem(IDC_CHECK2))->EnableWindow( m_bSpeedIcon );
  ((CWnd*)GetDlgItem(IDC_COMBO7))->EnableWindow( m_bSpeedIcon && !m_bFanTransparent );
  ((CWnd*)GetDlgItem(IDC_STATIC999))->EnableWindow( m_bSpeedIcon && !m_bFanTransparent );
  ((CWnd*)GetDlgItem(IDC_STATIC997))->EnableWindow( m_bSpeedIcon );
  ((CWnd*)GetDlgItem(IDC_EDIT1))->EnableWindow( m_bSpeedIcon );
  ((CWnd*)GetDlgItem(IDC_STATEONLY))->EnableWindow( m_bSpeedIcon );

  UpdateData( FALSE );
}

void COptionsIcons::OnBnClickedCheck4()
{
  UpdateData();

  ((CWnd*)GetDlgItem(IDC_STATIC666))->EnableWindow( m_bStatusIcon2 );
  ((CWnd*)GetDlgItem(IDC_STATIC667))->EnableWindow( m_bStatusIcon2 );
  ((CWnd*)GetDlgItem(IDC_STATIC668))->EnableWindow( m_bStatusIcon2 );
  ((CWnd*)GetDlgItem(IDC_STATIC669))->EnableWindow( m_bStatusIcon2 && !m_bTransparentB );
  ((CWnd*)GetDlgItem(IDC_COMBO11))->EnableWindow( m_bStatusIcon2 && !m_bTransparentB );
  ((CWnd*)GetDlgItem(IDC_COMBO9))->EnableWindow( m_bStatusIcon2 );
  ((CWnd*)GetDlgItem(IDC_COMBO8))->EnableWindow( m_bStatusIcon2 );
  ((CWnd*)GetDlgItem(IDC_COMBO10))->EnableWindow( m_bStatusIcon2 );
  ((CWnd*)GetDlgItem(IDC_CHECK5))->EnableWindow( m_bStatusIcon2 );  
}

void COptionsIcons::OnBnClickedCheck5()
{
  UpdateData();
  ((CWnd*)GetDlgItem(IDC_STATIC669))->EnableWindow( m_bStatusIcon2 && !m_bTransparentB );
  ((CWnd*)GetDlgItem(IDC_COMBO11))->EnableWindow( m_bStatusIcon2 && !m_bTransparentB );
}
