/*
   I8kfanGUI V3.0
   Copyright(c) 2001-2006 Christian Diefer
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as 
   published by the Free Software Foundation.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "stdafx.h"
#include "AtlBase.h"
#include "i8kfangui.h"
#include "TOptions.h"
#include "I8kfanguiOptionDlg.h"
#include "OptionsMisc.h"
#include "GlobalVars.h"

// COptionsMisc dialog

IMPLEMENT_DYNAMIC(COptionsMisc, CDialog)
COptionsMisc::COptionsMisc(CWnd* pParent /*=NULL*/)
	: CDialog(COptionsMisc::IDD, pParent)
  , m_bDebugMode(FALSE)
  , m_bMinimizeOnClose(FALSE)
  , m_bI8100Fix(FALSE)
{ }

COptionsMisc::~COptionsMisc()
{}

void COptionsMisc::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  DDX_Check(pDX, IDC_DEBUGMODE, m_bDebugMode);
  DDX_Check(pDX, IDC_MINIMIZECHECK, m_bMinimizeOnClose);
  DDX_Check(pDX, IDC_I8100FIX, m_bI8100Fix);
}


BEGIN_MESSAGE_MAP(COptionsMisc, CDialog)
  ON_BN_CLICKED(IDC_DEBUGMODE, OnBnClickedDebugmode)
END_MESSAGE_MAP()


// COptionsMisc message handlers
// erst GUI-Elemente anlegen, dann Dialog anzeigen
BOOL COptionsMisc::OnInitDialog()
{
  CDialog::OnInitDialog();

  m_bDebugMode = options.debugMode;
  m_bMinimizeOnClose = options.minimizeOnClose;
  m_bI8100Fix = options.i8100Fix;

  return true;
}

void COptionsMisc::OnBnClickedDebugmode()
{
  UpdateData();	

  if( m_bDebugMode )
  {
    CString s1, s2;
    s1.LoadStringW( IDS_OPTMISC1 );
    s2.LoadStringW( IDS_INFO );
    if( MessageBoxW(s1,s2,MB_ICONEXCLAMATION|MB_YESNO) != IDYES )
    {
      m_bDebugMode = FALSE;
      UpdateData( FALSE );
    }
  }
}

void COptionsMisc::getVars()
{
  options.debugMode = m_bDebugMode;
  options.minimizeOnClose = m_bMinimizeOnClose;
  options.i8100Fix = m_bI8100Fix;
}
