/*
   I8kfanGUI V3.0
   Copyright(c) 2001-2006 Christian Diefer
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as 
   published by the Free Software Foundation.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "stdafx.h"
#include "AtlBase.h"
#include "i8kfangui.h"
#include "TOptions.h"
#include "I8kfanguiOptionDlg.h"
#include "OptionsReading.h"
#include "I8kfanctrl.h"
#include "GlobalVars.h"

// COptionsReading dialog

IMPLEMENT_DYNAMIC(COptionsReading, CDialog)
COptionsReading::COptionsReading(CWnd* pParent /*=NULL*/)
	: CDialog(COptionsReading::IDD, pParent)
  , m_bReadCPUTemp(FALSE)
  , m_bReadGPUTemp(FALSE)
  , m_bReadMemoryTemp(FALSE)
  , m_bReadOtherTemp(FALSE)
  , m_bReadHDTemp(FALSE)
  , m_bReadHDTemp2(FALSE)
  , m_iHDNo(0)
  , m_iHDNo2(0)
  , m_bReadFanSpeed1(FALSE)
  , m_bReadFanSpeed2(FALSE)
  , m_bReadFanStatus1(FALSE)
  , m_bReadFanStatus2(FALSE)
  , m_bReadCPULoad(FALSE)
  , m_bReadCPUSpeed(FALSE)
  , m_iCPUVar(0)
{ }

COptionsReading::~COptionsReading()
{ }

void COptionsReading::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  DDX_Check(pDX, IDC_READCPUTEMP, m_bReadCPUTemp);
  DDX_Check(pDX, IDC_READCPUTEMP2, m_bReadGPUTemp);
  DDX_Check(pDX, IDC_READCPUTEMP3, m_bReadMemoryTemp);
  DDX_Check(pDX, IDC_READCPUTEMP4, m_bReadOtherTemp);
  DDX_Check(pDX, IDC_READHDTEMP, m_bReadHDTemp);
  DDX_CBIndex(pDX, IDC_SELDRIVECOMBO, m_iHDNo);
  DDX_CBIndex(pDX, IDC_SELDRIVECOMBO2, m_iHDNo2);
  DDX_Check(pDX, IDC_READFANSPEED1, m_bReadFanSpeed1);
  DDX_Check(pDX, IDC_READFANSPEED2, m_bReadFanSpeed2);
  DDX_Check(pDX, IDC_READFANSTATUS1, m_bReadFanStatus1);
  DDX_Check(pDX, IDC_READFANSTATUS2, m_bReadFanStatus2);
  DDX_Check(pDX, IDC_READCPULOAD, m_bReadCPULoad);
  DDX_Check(pDX, IDC_READCPUSPEED, m_bReadCPUSpeed);
  DDX_CBIndex(pDX, IDC_CPUVAR, m_iCPUVar);
  DDX_Control(pDX, IDC_CPUVAR, m_cCPUVar);
}


BEGIN_MESSAGE_MAP(COptionsReading, CDialog)
  ON_BN_CLICKED(IDC_READCPUTEMP, OnBnClickedReadcputemp)
  ON_BN_CLICKED(IDC_READCPUTEMP2, OnBnClickedReadcputemp2)
  ON_BN_CLICKED(IDC_READCPUTEMP3, OnBnClickedReadcputemp3)
  ON_BN_CLICKED(IDC_READCPUTEMP4, OnBnClickedReadcputemp4)
  ON_BN_CLICKED(IDC_READHDTEMP, OnBnClickedReadhdtemp)
  ON_BN_CLICKED(IDC_READCPUSPEED, OnBnClickedReadcpuspeed)
  ON_BN_CLICKED(IDC_HDBUTTON, OnBnClickedHdbutton)
END_MESSAGE_MAP()


// erst GUI-Elemente anlegen, dann Dialog anzeigen
BOOL COptionsReading::OnInitDialog()
{
  CDialog::OnInitDialog();

  CString s1;

  s1.LoadStringW( IDS_OPTREAD1 );
  CString name;
  name.Format( s1, options.fan1Alias );
  ((CWnd*)GetDlgItem(IDC_READFANSPEED1))->SetWindowText( name );

  name.Format( s1, options.fan2Alias );
  ((CWnd*)GetDlgItem(IDC_READFANSPEED2))->SetWindowText( name );

  s1.LoadStringW( IDS_OPTREAD2 );
  name.Format( s1, options.fan1Alias );
  ((CWnd*)GetDlgItem(IDC_READFANSTATUS1))->SetWindowText( name );

  name.Format( s1, options.fan2Alias );
  ((CWnd*)GetDlgItem(IDC_READFANSTATUS2))->SetWindowText( name );

  // ComboBox mit HD-Nummern fllen:
  CComboBox* cb = (CComboBox*)GetDlgItem(IDC_SELDRIVECOMBO);
  cb->ResetContent();
  CComboBox* cb2 = (CComboBox*)GetDlgItem(IDC_SELDRIVECOMBO2);
  cb2->ResetContent();
  s1.LoadStringW( IDS_OPTREAD3 );
  cb2->AddString( s1 );

  int j=0;        // nur Laufwerke mit Status 0 verwenden
  m_iHDNo = 0;

  if( !options.readHDTemp2 )
    m_iHDNo2 = 0;

  for( int i=0; i<MAXDRIVES; i++ )
  {
    if( options.hds[i] == 0 )
    {
      hds[j] = i;
      if( options.hdNo == i )
        m_iHDNo = j;

      if( options.hdNo2==i && options.readHDTemp2 )
        m_iHDNo2 = j+1;

	  CString num;
	  num.Format( L"%d", i );
      cb->AddString( num );
      cb2->AddString( num );
      j++;
    }
  }

  hdMax = j;

  if( j == 0 )    // keine Laufwerke mit Tempsupport gefunden
  {
    m_bReadHDTemp = FALSE;
    ((CWnd*)GetDlgItem(IDC_READHDTEMP))->EnableWindow( FALSE );
  }

  if( j <= 1 )
  {
    cb2->ResetContent();
    CString s1;
    s1.LoadStringW( IDS_OPTREAD3 );
    cb2->AddString( s1 );
    m_iHDNo2 = 0;
  }

  // verfgbare CPU-Speed-Zugriffsarten setzen
  m_cCPUVar.ResetContent();
  s1.LoadStringW( IDS_OPTREAD4 ); m_cCPUVar.AddString( s1 );
  s1.LoadStringW( IDS_OPTREAD5 ); m_cCPUVar.AddString( s1 );
  s1.LoadStringW( IDS_OPTREAD6 ); m_cCPUVar.AddString( s1 );
  s1.LoadStringW( IDS_OPTREAD7 ); m_cCPUVar.AddString( s1 );

  m_bReadCPUTemp = options.readCPUTemp;
  m_bReadGPUTemp = options.readGPUTemp;
  m_bReadMemoryTemp = options.readMemoryTemp;
  m_bReadOtherTemp = options.readChipsetTemp;
  m_bReadFanSpeed1 = options.readFanSpeed1;
  m_bReadFanSpeed2 = options.readFanSpeed2;
  m_bReadFanStatus1 = options.readFanStatus1;
  m_bReadFanStatus2 = options.readFanStatus2;
  m_bReadHDTemp = options.readHDTemp;
  m_bReadCPULoad = options.readCPULoad;
  m_bReadCPUSpeed = options.readCPUSpeed;
  m_iCPUVar = options.readCPUVar;

  ((CWnd*)GetDlgItem(IDC_READFANSPEED1))->EnableWindow( options.numFans>0 );
  ((CWnd*)GetDlgItem(IDC_READFANSTATUS1))->EnableWindow( options.numFans>0 );
  ((CWnd*)GetDlgItem(IDC_READFANSPEED2))->EnableWindow( options.numFans>1 );
  ((CWnd*)GetDlgItem(IDC_READFANSTATUS2))->EnableWindow( options.numFans>1 );

  ((CWnd*)GetDlgItem(IDC_SELDRIVESTATIC))->EnableWindow( m_bReadHDTemp );
  ((CWnd*)GetDlgItem(IDC_SELDRIVECOMBO))->EnableWindow( m_bReadHDTemp );
  ((CWnd*)GetDlgItem(IDC_SELDRIVESTATIC2))->EnableWindow( m_bReadHDTemp && j>1 );
  ((CWnd*)GetDlgItem(IDC_SELDRIVECOMBO2))->EnableWindow( m_bReadHDTemp && j>1 );
  ((CWnd*)GetDlgItem(IDC_HDBUTTON))->EnableWindow( m_bReadHDTemp );

  ((CWnd*)GetDlgItem(IDC_STATICCPUVAR))->EnableWindow( m_bReadCPUSpeed );
  ((CWnd*)GetDlgItem(IDC_CPUVAR))->EnableWindow( m_bReadCPUSpeed );

  UpdateData( FALSE );

  return true;
}

BOOL COptionsReading::displaySensorWarning( CString sensor )
{
  static wchar_t sensorMsg[512];

  CString s1, s2;

  s1.LoadStringW( IDS_OPTREAD8 );
  s2.LoadStringW( IDS_WARN );

  wsprintfW( sensorMsg, s1, sensor );

 return MessageBoxW( sensorMsg, s2, MB_ICONEXCLAMATION|MB_YESNO) == IDYES;
}

void COptionsReading::OnBnClickedReadcputemp()
{
  UpdateData();
  
  if( m_bReadCPUTemp )
  {
    CString s1, s2;
    s1.LoadStringW( IDS_OPTREAD9 );
    if( displaySensorWarning(s1) )
    {
      int x;
      if( readTemp(options.cpuSensorNo,x,glb_hHndFile) )
      {
        s1.LoadStringW( IDS_OPTREAD10 );
        s2.LoadStringW( IDS_INFO );
        MessageBoxW( s1, s2, MB_ICONINFORMATION|MB_OK );
      }
      else
      {
        m_bReadCPUTemp = FALSE;
        UpdateData( FALSE );
        s1.LoadStringW( IDS_OPTREAD11 );
        s2.LoadStringW( IDS_OPTREAD12 );
        MessageBoxW( s1, s2, MB_ICONSTOP|MB_OK );
      }
    }
    else
    {
      m_bReadCPUTemp = FALSE;
      UpdateData( FALSE );
    }
  }
}

void COptionsReading::OnBnClickedReadcputemp2()
{
  UpdateData();
  
  if( m_bReadGPUTemp )
  {
    CString s1, s2;
    s1.LoadStringW( IDS_OPTREAD13 );
    if( displaySensorWarning(s1) )
    {
      int x;
      if( readTemp(options.gpuSensorNo,x,glb_hHndFile) )
      {
        s1.LoadStringW( IDS_OPTREAD10 );
        s2.LoadStringW( IDS_INFO );
        MessageBox( s1, s2, MB_ICONINFORMATION|MB_OK );
      }
      else
      {
        m_bReadGPUTemp = FALSE;
        UpdateData( FALSE );
        s1.LoadStringW( IDS_OPTREAD11 );
        s2.LoadStringW( IDS_OPTREAD12 );
        MessageBox( s1, s2, MB_ICONSTOP|MB_OK );
      }
    }
    else
    {
      m_bReadGPUTemp = FALSE;
      UpdateData( FALSE );
    }
  }
}

void COptionsReading::OnBnClickedReadcputemp3()
{
  UpdateData();
  
  if( m_bReadMemoryTemp )
  {
    CString s1, s2;
    s1.LoadStringW( IDS_OPTREAD14 );
    if( displaySensorWarning(s1) )
    {
      int x;
      if( readTemp(options.memorySensorNo,x,glb_hHndFile) )
      {
        s1.LoadStringW( IDS_OPTREAD10 );
        s2.LoadStringW( IDS_INFO );
        MessageBox( s1, s2, MB_ICONINFORMATION|MB_OK );
      }
      else
      {
        m_bReadMemoryTemp = FALSE;
        UpdateData( FALSE );
        s1.LoadStringW( IDS_OPTREAD11 );
        s2.LoadStringW( IDS_OPTREAD12 );
        MessageBoxW( s1, s2, MB_ICONSTOP|MB_OK );
      }
    }
    else
    {
      m_bReadMemoryTemp = FALSE;
      UpdateData( FALSE );
    }
  }
}

void COptionsReading::OnBnClickedReadcputemp4() 
{
  UpdateData();
  
  if( m_bReadOtherTemp )
  {
    CString s1, s2;
    s1.LoadStringW( IDS_OPTREAD15 );
    if( displaySensorWarning(s1) )
    {
      int x;
      if( readTemp(options.chipsetSensorNo,x,glb_hHndFile) )
      {
        s1.LoadStringW( IDS_OPTREAD10 );
        s2.LoadStringW( IDS_INFO );
        MessageBox( s1, s2, MB_ICONINFORMATION|MB_OK );
      }
      else
      {
        m_bReadOtherTemp = FALSE;
        UpdateData( FALSE );
        s1.LoadStringW( IDS_OPTREAD11 );
        s2.LoadStringW( IDS_OPTREAD12 );
        MessageBoxW( s1, s2, MB_ICONSTOP|MB_OK );
      }
    }
    else
    {
      m_bReadOtherTemp = FALSE;
      UpdateData( FALSE );
    }
  }
}

void COptionsReading::OnBnClickedReadhdtemp()
{
  UpdateData();

  ((CWnd*)GetDlgItem(IDC_SELDRIVESTATIC))->EnableWindow( m_bReadHDTemp );
  ((CWnd*)GetDlgItem(IDC_SELDRIVECOMBO))->EnableWindow( m_bReadHDTemp );
  ((CWnd*)GetDlgItem(IDC_SELDRIVESTATIC2))->EnableWindow( m_bReadHDTemp && hdMax>1 );
  ((CWnd*)GetDlgItem(IDC_SELDRIVECOMBO2))->EnableWindow( m_bReadHDTemp && hdMax>1 );
  ((CWnd*)GetDlgItem(IDC_HDBUTTON))->EnableWindow( m_bReadHDTemp );
}

void COptionsReading::OnBnClickedReadcpuspeed()
{
  UpdateData();

  ((CWnd*)GetDlgItem(IDC_STATICCPUVAR))->EnableWindow( m_bReadCPUSpeed );
  ((CWnd*)GetDlgItem(IDC_CPUVAR))->EnableWindow( m_bReadCPUSpeed );
}

void COptionsReading::OnBnClickedHdbutton()
{
  for( int i=0; i<MAXDRIVES; i++ )      // get SMART status of first 4 drives
  {  
    int temp;
    options.hds[i] = readHDTemp( i, temp, NULL, 0, TRUE );
  }

  CComboBox* cb = (CComboBox*)GetDlgItem(IDC_SELDRIVECOMBO);
  cb->ResetContent();
  CComboBox* cb2 = (CComboBox*)GetDlgItem(IDC_SELDRIVECOMBO2);
  cb2->ResetContent();
  cb2->AddString( L"None" );

  int j=0;        // nur Laufwerke mit Status 0 verwenden
  m_iHDNo = 0;

  if( !options.readHDTemp2 )
    m_iHDNo2 = 0;

  for( int i=0; i<MAXDRIVES; i++ )
  {
    if( options.hds[i] == 0 )
    {
      hds[j] = i;
      if( options.hdNo == i )
        m_iHDNo = j;

      if( options.hdNo2==i && options.readHDTemp2 )
        m_iHDNo2 = j+1;

      CString num;
	  num.Format( L"%d", i );
      cb->AddString( num );
      cb2->AddString( num );
      j++;
    }
  }

  hdMax = j;

  if( j == 0 )    // keine Laufwerke mit Tempsupport gefunden
  {
    m_bReadHDTemp = FALSE;
    ((CWnd*)GetDlgItem(IDC_READHDTEMP))->EnableWindow( FALSE );
  }

  if( j <= 1 )
  {
    cb2->ResetContent();
    cb2->AddString( L"None" );
    ((CWnd*)GetDlgItem(IDC_SELDRIVESTATIC2))->EnableWindow( FALSE );
    ((CWnd*)GetDlgItem(IDC_SELDRIVECOMBO2))->EnableWindow( FALSE );
    m_iHDNo2 = 0;
  }

  ((CWnd*)GetDlgItem(IDC_SELDRIVESTATIC))->EnableWindow( m_bReadHDTemp );
  ((CWnd*)GetDlgItem(IDC_SELDRIVECOMBO))->EnableWindow( m_bReadHDTemp );
  ((CWnd*)GetDlgItem(IDC_SELDRIVESTATIC2))->EnableWindow( m_bReadHDTemp && j>1 );
  ((CWnd*)GetDlgItem(IDC_SELDRIVECOMBO2))->EnableWindow( m_bReadHDTemp && j>1 );
  ((CWnd*)GetDlgItem(IDC_HDBUTTON))->EnableWindow( m_bReadHDTemp );

  UpdateData( FALSE );
}

void COptionsReading::getVars()
{
  options.readCPUTemp = m_bReadCPUTemp;
  options.readGPUTemp = m_bReadGPUTemp;
  options.readMemoryTemp = m_bReadMemoryTemp;
  options.readChipsetTemp = m_bReadOtherTemp;
  options.readFanSpeed1 = m_bReadFanSpeed1;
  options.readFanSpeed2 = m_bReadFanSpeed2;
  options.readFanStatus1 = m_bReadFanStatus1;
  options.readFanStatus2 = m_bReadFanStatus2;
  options.readHDTemp = m_bReadHDTemp;
  options.readCPULoad = m_bReadCPULoad;
  options.readCPUSpeed = m_bReadCPUSpeed;
  options.readCPUVar = m_iCPUVar;

  log( L"*** Options: options.readHDTemp:%d", options.readHDTemp );
  if( options.readHDTemp )
  {
    options.hdNo = hds[m_iHDNo];
    
    options.readHDTemp2 = (m_iHDNo2!=0);
    
    if( options.readHDTemp2 )
      options.hdNo2 = hds[m_iHDNo2-1];
  }

  log( L"*** Options: options.hdNos: %d %d", options.hdNo, options.hdNo2 );
}
