// PictureHyperLink.h : header file
//
//
// HyperLink static control. Will open the default browser with the given URL
// when the user clicks on the link.
//
// Copyright Chris Maunder, 1997, 1998
// Feel free to use and distribute. May not be sold for profit. 
//
// Modifications for picture controls by Christian Diefer, 10/22/06

#pragma once

/////////////////////////////////////////////////////////////////////////////
// CPictureHyperLink window

class CPictureHyperLink : public CStatic
{
// Construction/destruction
public:
    CPictureHyperLink();
    virtual ~CPictureHyperLink();

// Attributes
public:

// Operations
public:

    void SetURL(CString strURL, CString msg);
    CString GetURL() const;

    void SetLinkCursor(HCURSOR hCursor);
    HCURSOR GetLinkCursor() const;

// Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CHyperLink)
    public:
    virtual BOOL PreTranslateMessage(MSG* pMsg);
    protected:
    virtual void PreSubclassWindow();
    //}}AFX_VIRTUAL

// Implementation
protected:
    BOOL GotoURL(LPCTSTR url, int showcmd);
    void ReportError(int nError);
    LONG GetRegKey(HKEY key, LPCTSTR subkey, LPTSTR retdata);
    void SetDefaultCursor();

// Protected attributes
protected:
    BOOL     m_bOverControl;                        // cursor over control?
    CString  m_strURL;                              // hyperlink URL
    CString  m_tipMsg;
    HCURSOR  m_hLinkCursor;                         // Cursor for hyperlink
    CToolTipCtrl m_ToolTip;                         // The tooltip

    // Generated message map functions
protected:
    //{{AFX_MSG(CHyperLink)
    afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
    afx_msg void OnMouseMove(UINT nFlags, CPoint point);
    //}}AFX_MSG
    afx_msg void OnClicked();
    DECLARE_MESSAGE_MAP()
};
