/*
   I8kfanGUI V3.0
   Copyright(c) 2001-2006 Christian Diefer
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as 
   published by the Free Software Foundation.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "stdafx.h"
#include "I8kfanGUI.h"
#include "SystemInfo.h"
#include "TOptions.h"
#include "I8kfanctrl.h"
#include "GlobalVars.h"
#include "SystemInfoSMBIOS.h"
#include "SystemInfoCPU.h"
#include "SystemInfoHD.h"

static CSystemInfoSMBIOS biosTab;
static CSystemInfoCPU cpuTab;
static CSystemInfoHD hdTab;

// CSystemInfo-Dialogfeld

IMPLEMENT_DYNAMIC(CSystemInfo, CDialog)

CSystemInfo::CSystemInfo(CWnd* pParent /*=NULL*/)
	: CDialog(CSystemInfo::IDD, pParent)
{ }

CSystemInfo::~CSystemInfo()
{ }

void CSystemInfo::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
  DDX_Control(pDX, IDC_TAB1, tabCtrl);
}


BEGIN_MESSAGE_MAP(CSystemInfo, CDialog)
  ON_NOTIFY(TCN_SELCHANGE, IDC_TAB1, OnTcnSelchangeTab1)
END_MESSAGE_MAP()


// CSystemInfo-Meldungshandler
BOOL CSystemInfo::OnInitDialog()
{
  log( L"OnInitDialog von Sysinfo" );
  CDialog::OnInitDialog();

  // Tab Header anlegen:
  TC_ITEM TabCtrlItem;

  CString s1;
  wchar_t text[256];
  TabCtrlItem.mask = TCIF_TEXT;

  s1.LoadStringW( IDS_SYS1 );
  wcscpy_s( text, s1 );
  TabCtrlItem.pszText = text;
  tabCtrl.InsertItem( 0, &TabCtrlItem );
  s1.LoadStringW( IDS_SYS2 );
  wcscpy_s( text, s1 );
  TabCtrlItem.pszText = text;
  tabCtrl.InsertItem( 1, &TabCtrlItem );
  s1.LoadStringW( IDS_SYS3 );
  wcscpy_s( text, s1 );
  TabCtrlItem.pszText = text;
  tabCtrl.InsertItem( 2, &TabCtrlItem );

  tabs[0] = &biosTab;
  tabs[1] = &cpuTab;
  tabs[2] = &hdTab;

  // die Tabs anlegen:
  biosTab.Create( biosTab.IDD, this );
  cpuTab.Create( cpuTab.IDD, this );
  hdTab.Create( hdTab.IDD, this );

  // 'Autostart'-Tab anzeigen, alle anderen ausblenden:
  biosTab.ShowWindow( SW_SHOW );
  cpuTab.ShowWindow( SW_HIDE );
  hdTab.ShowWindow( SW_HIDE );

  // Fensterposition und -gre berechnen:
  for( int i=0; i<3; i++ )
  {
    RECT rect;

    tabs[i]->GetClientRect( &rect );
    TabCtrl_AdjustRect( tabCtrl, 0, &rect );
    tabCtrl.ClientToScreen( &rect );
    ScreenToClient( &rect );

    tabs[i]->SetWindowPos( &wndTop,
                           rect.left,
                           rect.top,
                           rect.right - rect.left,
                           rect.bottom - rect.top + 22,
                           (i ? SWP_HIDEWINDOW : SWP_SHOWWINDOW) );

    // nur fr XP und hher (zerstrt Kompatibilitt mit Windows NT4 und 2000):
    if( glb_bWinXP && glb_pCallThemeEnable!=NULL )
      glb_pCallThemeEnable( tabs[i]->m_hWnd, ETDT_ENABLETAB );
  }

  // Daten in Tabs anzeigen:
  biosTab.UpdateData( FALSE );
  cpuTab.UpdateData( FALSE );
  hdTab.UpdateData( FALSE );

  log( L"OnInitDialog von Sysinfo zuende" );

  return TRUE;
}

void CSystemInfo::OnTcnSelchangeTab1( NMHDR *pNMHDR, LRESULT *pResult )
{
  int i = tabCtrl.GetCurSel();

  for( int x=0; x<3; x++ )
    tabs[x]->ShowWindow( x==i ? SW_SHOW : SW_HIDE );

  *pResult = 0;
}

