/*
   I8kfanGUI V3.0
   Copyright(c) 2001-2006 Christian Diefer
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as 
   published by the Free Software Foundation.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "stdafx.h"
#include "I8kfanGUI.h"
#include "TOptions.h"
#include "SystemInfoCPU.h"
#include "CPUID.h"
#include "CPUData.h"
#include "cpuspeed.h"

extern TCPUData cpuData;

// CSystemInfoCPU-Dialogfeld

IMPLEMENT_DYNAMIC(CSystemInfoCPU, CDialog)

CSystemInfoCPU::CSystemInfoCPU(CWnd* pParent /*=NULL*/)
	: CDialog(CSystemInfoCPU::IDD, pParent)
{ }

CSystemInfoCPU::~CSystemInfoCPU()
{ }

void CSystemInfoCPU::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  DDX_Control(pDX, IDC_LIST1, m_cList);
}


BEGIN_MESSAGE_MAP(CSystemInfoCPU, CDialog)
END_MESSAGE_MAP()


// CSystemInfoCPU-Meldungshandler
BOOL CSystemInfoCPU::OnInitDialog() 
{
	CDialog::OnInitDialog();

  log( L"OnInitDialog von SystemInfoCPU" );

  CRect rect;
  m_cList.GetClientRect( &rect );
  int nColInterval = rect.Width()/6;
  CString s1;
  s1.LoadStringW( IDS_CPUINF1 );
  m_cList.InsertColumn( 0, s1, LVCFMT_LEFT, nColInterval*2 );
  s1.LoadStringW( IDS_CPUINF2 );
  m_cList.InsertColumn( 1, s1, LVCFMT_LEFT, nColInterval*3+nColInterval/2 );

  cpuData.checkCPUType();

  fillList( cpuData.flagText, &m_cList );

  log( L"Ende von OnInitDialog von SystemInfoCPU" );

  return TRUE;
}

//----------------------------------------------------------
// Konvertierung des CPU-Infostrings in das Listcontrol
//----------------------------------------------------------
void CSystemInfoCPU::fillList( wchar_t* t, CListCtrl* m_cList )
{
  m_cList->DeleteAllItems();

  static wchar_t prop[256];
  static wchar_t value[256];
  int nIndex=-1;
  int i=0;
  int j=0;
  wchar_t* s = t;
  boolean ignore = false;
  CString s1;
  s1.LoadStringW( IDS_CPUINF3 );

  for( ;; )
  {
    s = t;
    while( *s == ' ' ) s++;

    t = s;

    while( *s && *s!='\r' && *s!=':' )
      s++;

    wcsncpy_s( prop, t, s-t );
    prop[s-t] = '\0';

    if( !*prop )    // Leerzeile
    {
      *value = '\0';
      s += 2;
    }
    else if( *s == ':' )
    {
      if( !wcscmp(prop,s1) )    // "Features"
        s += 2;

      s++;
      while( *s == ' ' ) s++;

      t = s;
      while( *s && *s!='\r' )
        s++;
      
      wcsncpy_s( value, t, s-t );
      value[s-t] = '\0';

      if( !*value )
        ignore = true;

      if( *s )
        s += 2;
    }
    else if( !*s )
      *value = '\0';
    else /* if( *s == '\r' ) */
    {
      wcscpy_s( value, prop );
      *prop = '\0';
      s += 2;
    }

    if( !ignore )
    {
      nIndex = m_cList->InsertItem( nIndex+1, prop );
      m_cList->SetItemText( nIndex, 1, value );
    }
    else 
      ignore = false;
    
    t = s;
    
    if( !*s )
      break;
  }
}

