/*
   I8kfanGUI V3.0
   Copyright(c) 2001-2006 Christian Diefer
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as 
   published by the Free Software Foundation.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "stdafx.h"
#include "I8kfanGUI.h"
#include "TOptions.h"
#include "SystemInfoHD.h"
#include "i8kfanctrl.h"

// CSystemInfoHD-Dialogfeld

IMPLEMENT_DYNAMIC(CSystemInfoHD, CDialog)

CSystemInfoHD::CSystemInfoHD(CWnd* pParent /*=NULL*/)
	: CDialog(CSystemInfoHD::IDD, pParent)
  , m_iHDNo(0)
{

}

CSystemInfoHD::~CSystemInfoHD()
{
}

void CSystemInfoHD::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  DDX_CBIndex(pDX, IDC_COMBO1, m_iHDNo);
  DDX_Control(pDX, IDC_HDINFO, m_cList);
}


BEGIN_MESSAGE_MAP(CSystemInfoHD, CDialog)
  ON_CBN_SELCHANGE(IDC_COMBO1, OnCbnSelchangeSelecthd)
END_MESSAGE_MAP()


// CSystemInfoHD-Meldungshandler
BOOL CSystemInfoHD::OnInitDialog() 
{
  CDialog::OnInitDialog();

  log( L"OnInitDialog von SystemInfoHD" );

  CComboBox* cb = (CComboBox*)GetDlgItem(IDC_COMBO1);
  cb->ResetContent();

  int j=0;        // grab the accessible drives
  for( int i=0; i<MAXDRIVES; i++ )
  {
    if( options.hds[i]==0 || options.hds[i]<-2 )
    {
      hds[j++] = i;
      CString num;
      num.Format( L"%d", i );
      cb->AddString( num );
    }
  }

  m_iHDNo = 0;
  UpdateData( FALSE );

  if( j > 0 )
  {
    int x;
    readHDTemp( hds[0], x, t, 32700, FALSE );
  }
  else
    *t = '\0';

  CRect rect;
  m_cList.GetClientRect( &rect );
  int nColInterval = rect.Width()/6;
  CString s1;
  s1.LoadStringW( IDS_HDINF1 );
  m_cList.InsertColumn( 0, s1, LVCFMT_LEFT, nColInterval*3 );
  s1.LoadStringW( IDS_HDINF2 );
  m_cList.InsertColumn( 1, s1, LVCFMT_LEFT, nColInterval*2+nColInterval/2 );

  options.fillList( t, &m_cList );

  UpdateData( FALSE );
	
  log( L"Ende von OnInitDialog von SystemInfoHD" );
  return TRUE;
}

void CSystemInfoHD::OnCbnSelchangeSelecthd()
{
  UpdateData();

  int x;
  readHDTemp( hds[m_iHDNo], x, t, 16384, FALSE );
  options.fillList( t, &m_cList );

  UpdateData( FALSE );
}

