/*
   I8kfanGUI V3.0
   Copyright(c) 2001-2006 Christian Diefer
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as 
   published by the Free Software Foundation.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "stdafx.h"
#include "I8kfanGUI.h"
#include "SystemInfoSMBIOS.h"
#include "TOptions.h"
#include "I8kfanctrl.h"
#include "GlobalVars.h"


// CSystemInfoSMBIOS-Dialogfeld

IMPLEMENT_DYNAMIC(CSystemInfoSMBIOS, CDialog)

CSystemInfoSMBIOS::CSystemInfoSMBIOS(CWnd* pParent /*=NULL*/)
	: CDialog(CSystemInfoSMBIOS::IDD, pParent)
{ }

CSystemInfoSMBIOS::~CSystemInfoSMBIOS()
{ }

void CSystemInfoSMBIOS::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  DDX_Control(pDX, IDC_LIST1, m_cList);
}


BEGIN_MESSAGE_MAP(CSystemInfoSMBIOS, CDialog)
END_MESSAGE_MAP()


// CSystemInfoSMBIOS-Meldungshandler
BOOL CSystemInfoSMBIOS::OnInitDialog() 
{
  CDialog::OnInitDialog();

  log( L"OnInitDialog von SystemInfoSMBIOS" );

  fillLangStrings();

  if( !getSystemInfo(t,glb_hHndFile) )
  {
    CString s1;
    s1.LoadStringW( IDS_BIOSINF1 );
    wcscpy_s( t, s1 );
  }

  //m_sSMBIOSInfo = t;
  CRect rect;
  m_cList.GetClientRect( &rect );
  int nColInterval = rect.Width()/6;
  CString s1;
  s1.LoadStringW( IDS_BIOSINF2 );
  m_cList.InsertColumn( 0, s1, LVCFMT_LEFT, nColInterval*3 );
  s1.LoadStringW( IDS_BIOSINF3 );
  m_cList.InsertColumn( 1, s1, LVCFMT_LEFT, nColInterval*2+nColInterval/2 );

  fillList( t, &m_cList );

  UpdateData( FALSE );

  log( L"Ende von OnInitDialog von SystemInfoSMBIOS" );

  return TRUE;
}

//----------------------------------------------------------
// Konvertierung eines Infostrings in ein Listcontrol
//----------------------------------------------------------
void CSystemInfoSMBIOS::fillList( wchar_t* t, CListCtrl* m_cList )
{
  m_cList->DeleteAllItems();

  static wchar_t prop[256];
  static wchar_t value[256];
  int nIndex=-1;
  int i=0;
  int j=0;
  wchar_t* s = t;

  for( ;; )
  {
    s = t;
    while( isspace(*s) ) s++;
    
    t = s;

    while( *s && *s!=':' )
      s++;

    _tcsncpy_s( prop, t, s-t );
    prop[s-t] = '\0';

    if( *s )
    {
      s += 2;
      t = s;
      while( *s && *s!='\r' )
        s++;
      
      _tcsncpy_s( value, t, s-t );
      value[s-t] = '\0';

      if( *s )
        s += 2;
    }
    else 
      *value = '\0';

    for( int i=0; i<23; i++ )
    {
      if( !_wcsicmp(prop,ori[i]) )
      {
        wcscpy_s( prop, lang[i] );
        break;
      }
    }

    nIndex = m_cList->InsertItem( nIndex+1, prop );
    m_cList->SetItemText( nIndex, 1, value );
    
    t = s;
    
    if( !*s )
      break;
  }

}

void CSystemInfoSMBIOS::fillLangStrings()
{
  ori[0] = L"BIOS vendor";
  ori[1] = L"BIOS version";
  ori[2] = L"BIOS date";
  ori[3] = L"System manufacturer";
  ori[4] = L"Product name";
  ori[5] = L"Service tag";
  ori[6] = L"Asset tag";
  ori[7] = L"CPU manufacturer";
  ori[8] = L"Current CPU speed";
  ori[9] = L"External clock";
  ori[10] = L"Max. CPU speed supported by board";
  ori[11] = L"Video card";
  ori[12] = L"Ethernet card";
  ori[13] = L"Sound card";
  ori[14] = L"L1 cache size";
  ori[15] = L"L2 cache size";
  ori[16] = L"L3 cache size";
  ori[17] = L"SODIMM socket";
  ori[18] = L"Battery manufacturer";
  ori[19] = L"Battery device name";
  ori[20] = L"Battery location";
  ori[21] = L"Battery manufacturing date";
  ori[22] = L"Battery serial no";

  lang[0].LoadStringW( IDS_BIOS1 );
  lang[1].LoadStringW( IDS_BIOS2 );
  lang[2].LoadStringW( IDS_BIOS3 );
  lang[3].LoadStringW( IDS_BIOS4 );
  lang[4].LoadStringW( IDS_BIOS5 );
  lang[5].LoadStringW( IDS_BIOS6 );
  lang[6].LoadStringW( IDS_BIOS7 );
  lang[7].LoadStringW( IDS_BIOS8 );
  lang[8].LoadStringW( IDS_BIOS9 );
  lang[9].LoadStringW( IDS_BIOS10 );
  lang[10].LoadStringW( IDS_BIOS11 );
  lang[11].LoadStringW( IDS_BIOS12 );
  lang[12].LoadStringW( IDS_BIOS13 );
  lang[13].LoadStringW( IDS_BIOS14 );
  lang[14].LoadStringW( IDS_BIOS15 );
  lang[15].LoadStringW( IDS_BIOS16 );
  lang[16].LoadStringW( IDS_BIOS17 );
  lang[17].LoadStringW( IDS_BIOS18 );
  lang[18].LoadStringW( IDS_BIOS19 );
  lang[19].LoadStringW( IDS_BIOS20 );
  lang[20].LoadStringW( IDS_BIOS21 );
  lang[21].LoadStringW( IDS_BIOS22 );
  lang[22].LoadStringW( IDS_BIOS23 );
}

