/*
   I8kfanGUI V3.0
   Copyright(c) 2001-2006 Christian Diefer
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as 
   published by the Free Software Foundation.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

//#define _UNICODE

#include "stdafx.h"
#include "AtlBase.h"
#include "TOptions.h"
#include "resource.h"

#define WRITEDW(a,b)      \
    if( key.SetValue(b,REG_DWORD,&(a),size) != ERROR_SUCCESS ) \
    { \
      key.Close(); \
      return false; \
    }

#define READDW(a,b) \
    size=sizeof DWORD; \
    if( key.QueryValue(b,NULL,&(a),&size) != ERROR_SUCCESS ) \
    { \
      WRITEDW(a,b) \
    }


//----------------------------------------------------------
// Konstruktor: Standardwerte fr alle Optionen setzen
//----------------------------------------------------------
TOptions::TOptions()
{
  // Standardwerte fr ersten Start:
  opmode = OBSERVERMODE;
  autoStart = true;     // Autostart aktiviert
  terminate = false;    // nicht terminieren nach Autostart
  acOnly = false;       // Autostart wenn am Netz und auf Batterie
  autoInnerSlider = 0;  // beim Autostart nicht 1. Lfter starten
  autoOuterSlider = 0;  // beim Autostart nicht 2. Lfter starten
  readCPUTemp = true;   // CPU-Temperatur lesen
  readGPUTemp = false;
  readMemoryTemp = false;
  readChipsetTemp = false;
  readFanSpeed1 = false; // Drehzahl vom 1. Lfter nicht lesen
  readFanSpeed2 = false; // Drehzahl vom 2. Lfter nicht lesen
  readFanStatus1 = false;
  readFanStatus2 = false;
  tempIcon = true;      // Tempicon in Tray anzeigen
  showDiagram = true;   // Diagramm anzeigen
  intervalCPU = 2;      // interne Sensoren alle 2 Sekunden updaten
  intervalHD = 240;     // HD-Temperatur alle 4 Minuten updaten (sehr I/O-intensiv !)
  preDefSet = 3;        // aktuelles Profil fr Tempmonitor
  debugMode = false;    // Debugmodus aus
  *biosVer = '\0';
  readHDTemp = false;	  // keine HD-Temperatur einlesen
  readHDTemp2 = false;
  minimizeOnClose = true;	// ins Tray verkleinern beim Schlieen
  speedIcon = false;		  // kein Icon 
  readCPUSpeed = true;    // CPU-Speed nicht lesen
  readCPULoad = true;     // CPU-Last nicht lesen
  sensorSupport = false;  // nicht im HW-Sensormodus
  sensorCheck = true;     // Check auf HW-Sensor durchfhren wenn HW-Sensoren aktiviert werden
  fahrenHeit = false;     // Standard auf Celsius festlegen
  maintainSpeeds = false; // Drehzahl nicht konstant halten
  readCPUVar = 3;         // Realtime calc (old)
  hdNo = 0;               // HD-Temperatur vom ersten LW holen
  hdNo2 = 1;              // HD-Temperatur vom zweiten LW holen (wenn vorhanden)
  trayIcon1 = 1;          // obere Hlfte des Tempicons: CPU-Temperatur
  trayIcon2 = 0;          // untere Hlfte des Tempicons: nix
  trayIcon1b = 0;         // nix
  trayIcon2b = 0;         // nix
  drawCPUTemp = true;     // CPU-Temp im Diagramm zeichnen
  drawGPUTemp = true;     // GPU-Temp im Diagramm zeichnen
  drawMemoryTemp = true;  // Memory-Temp im Diagramm zeichnen
  drawChipsetTemp = true; // Chipset-Temp im Diagramm zeichnen
  drawCPULoad = true;     // CPU-Last im Diagramm zeichnen
  drawCPUSpeed = true;    // CPU-Speed im Diagramm zeichnen
  speedScaling = 1;       // Skalierung der CPU-Speed: x1
  debugControls = false;  // keine GUI-Elemente fr Debugging anzeigen
  compatibleSensor = false; // es wurde noch kein kompatibler Sensor gefunden
  autoSpeedDirect1 = 0;
  autoSpeedDirect2 = 0;
  autoFanSetting = true;
  autoStartHWFans = false;
  tempCtrlHWFans = false;
  i8100Fix = false;           // Korrektur fr I8100 BIOS A08 aktiviert
  cpuSensorNo = 0;            // Nr. des CPU-Sensors
  gpuSensorNo = 2;            // Nr. des GPU-Sensors
  memorySensorNo = 1;         // Nr. des Speichersensors
  chipsetSensorNo = 3;        // Nr. des Chipsetsensors
  fanSpeedDivider = 30;       // Divisor fr Drehzahl
  numFans = 2;                // 2 Lfter sofern Modell nicht erkannt wird
  fan1Index = 0;
  fan2Index = 1;
  modelChecked = false;       // Prfung auf Modelltyp noch nicht durchgefhrt
  trayColor1 = 0;
  trayColor2 = 15;
  transparentBkg = TRUE;
  statusIcon2 = FALSE;
  trayColor1b = 0;
  trayColor2b = 15;
  transparentBkgB = TRUE;
  fanTransparentBkg = TRUE;
  fanTrayColor1 = 0;
  fanTrayColor2 = 15;
  fanTraySpeedDivider = 100;
  fanIconStateOnly = FALSE;
  cpuCompensation = 0;
  gpuCompensation = 0;
  memoryCompensation = 0;
  chipsetCompensation = 0;
  fan1SensorIndex = 0;
  fan2SensorIndex = 1;
  fanForceInterval = 2;
  fan1Force = TRUE;
  fan2Force = TRUE;
  colorTheme = 0;   // Schwarzes Farbschema fr Verlaufdiagramm


  //------------------------
  // Vordefinierte Profile:
  //------------------------

  // 1. Normal-Profil:
  //------------------
  wcscpy_s( ms[0].alias, L"Normal" );
  ms[0].monEnabled[CPUMON] = TRUE;
  ms[0].monEnabled[GPUMON] = FALSE;
  ms[0].monEnabled[MEMMON] = FALSE;
  ms[0].monEnabled[CHSMON] = FALSE;

  // Temperaturwerte fr CPU-Sensor:
  ms[0].cpuMonTemp[0] = 45;
  ms[0].cpuMonTemp[1] = 38;
  ms[0].cpuMonTemp[2] = 55;
  ms[0].cpuMonTemp[3] = 45;
  ms[0].cpuMonTemp[4] = 65;
  ms[0].cpuMonTemp[5] = 55;
  ms[0].cpuMonTemp[6] = 75;
  ms[0].cpuMonTemp[7] = 65;
  
  for( int i=0; i<8; i++ )
  {
    int x = (((i/2)+1-(i%2))*10)+40;

    ms[0].gpuMonTemp[i] = x;
    ms[1].gpuMonTemp[i] = x;
    ms[2].gpuMonTemp[i] = x;
    ms[3].gpuMonTemp[i] = x;
    ms[0].memoryMonTemp[i] = x;
    ms[1].memoryMonTemp[i] = x;
    ms[2].memoryMonTemp[i] = x;
    ms[3].memoryMonTemp[i] = x;
    ms[0].chipsetMonTemp[i] = x;
    ms[1].chipsetMonTemp[i] = x;
    ms[2].chipsetMonTemp[i] = x;
    ms[3].chipsetMonTemp[i] = x;
  }

  for( int i=0; i<4; i++ )
  {
    ms[i].cpuFan[0] = TRUE;
    ms[i].cpuFan[1] = TRUE;
    ms[i].gpuFan[0] = FALSE;
    ms[i].gpuFan[1] = FALSE;
    ms[i].memoryFan[0] = FALSE;
    ms[i].memoryFan[1] = FALSE;
    ms[i].chipsetFan[0] = FALSE;
    ms[i].chipsetFan[1] = FALSE;
  }

  // SMBIOS-Stati:
  ms[0].cpuFanSpeeds[0] = 2;   // Lfter 1...
  ms[0].cpuFanSpeeds[1] = 2;
  ms[0].cpuFanSpeeds[2] = 2;
  ms[0].cpuFanSpeeds[3] = 3;
  ms[0].cpuFanSpeeds[4] = 1;   // Lfter 2...
  ms[0].cpuFanSpeeds[5] = 2;
  ms[0].cpuFanSpeeds[6] = 3;
  ms[0].cpuFanSpeeds[7] = 3;

  // Sensor-Drehzahlen:
  ms[0].cpuFanSpeeds[8] = 30;  // Lfter 1...
  ms[0].cpuFanSpeeds[9] = 40;
  ms[0].cpuFanSpeeds[10] = 50;  
  ms[0].cpuFanSpeeds[11] = 60;
  ms[0].cpuFanSpeeds[12] = 30;  // Lfter 2...
  ms[0].cpuFanSpeeds[13] = 40;
  ms[0].cpuFanSpeeds[14] = 50;
  ms[0].cpuFanSpeeds[15] = 60;

  for( int j=0; j<4; j++ )
    for( int i=0; i<16; i++ )
    {
      ms[j].gpuFanSpeeds[i] = 0;
      ms[j].memoryFanSpeeds[i] = 0;
      ms[j].chipsetFanSpeeds[i] = 0;
    }

  // 2. Games-Profil:
  //------------------
  wcscpy_s( ms[1].alias, L"Games" );
  ms[1].monEnabled[CPUMON] = TRUE;
  ms[1].monEnabled[GPUMON] = FALSE;
  ms[1].monEnabled[MEMMON] = FALSE;
  ms[1].monEnabled[CHSMON] = FALSE;

  ms[1].cpuMonTemp[0] = 50;
  ms[1].cpuMonTemp[1] = 40;
  ms[1].cpuMonTemp[2] = 60;
  ms[1].cpuMonTemp[3] = 50;
  ms[1].cpuMonTemp[4] = 70;
  ms[1].cpuMonTemp[5] = 60;
  ms[1].cpuMonTemp[6] = 80;
  ms[1].cpuMonTemp[7] = 70;

  ms[1].cpuFanSpeeds[0] = 2;
  ms[1].cpuFanSpeeds[1] = 2;
  ms[1].cpuFanSpeeds[2] = 3;
  ms[1].cpuFanSpeeds[3] = 3;
  ms[1].cpuFanSpeeds[4] = 1;
  ms[1].cpuFanSpeeds[5] = 2;
  ms[1].cpuFanSpeeds[6] = 3;
  ms[1].cpuFanSpeeds[7] = 3;
  ms[1].cpuFanSpeeds[8] = 30;
  ms[1].cpuFanSpeeds[9] = 40;
  ms[1].cpuFanSpeeds[10] = 50;
  ms[1].cpuFanSpeeds[11] = 60;
  ms[1].cpuFanSpeeds[12] = 30;
  ms[1].cpuFanSpeeds[13] = 40;
  ms[1].cpuFanSpeeds[14] = 50;
  ms[1].cpuFanSpeeds[15] = 60;

  // 3. Office-Profil:
  //------------------
  wcscpy_s( ms[2].alias, L"Office" );
  ms[2].monEnabled[CPUMON] = TRUE;
  ms[2].monEnabled[GPUMON] = FALSE;
  ms[2].monEnabled[MEMMON] = FALSE;
  ms[2].monEnabled[CHSMON] = FALSE;

  ms[2].cpuMonTemp[0] = 55;
  ms[2].cpuMonTemp[1] = 45;
  ms[2].cpuMonTemp[2] = 65;
  ms[2].cpuMonTemp[3] = 55;
  ms[2].cpuMonTemp[4] = 75;
  ms[2].cpuMonTemp[5] = 65;
  ms[2].cpuMonTemp[6] = 85;
  ms[2].cpuMonTemp[7] = 75;
  ms[2].cpuFanSpeeds[0] = 2;
  ms[2].cpuFanSpeeds[1] = 2;
  ms[2].cpuFanSpeeds[2] = 3;
  ms[2].cpuFanSpeeds[3] = 3;
  ms[2].cpuFanSpeeds[4] = 1;
  ms[2].cpuFanSpeeds[5] = 2;
  ms[2].cpuFanSpeeds[6] = 3;
  ms[2].cpuFanSpeeds[7] = 3;
  ms[2].cpuFanSpeeds[8] = 30;
  ms[2].cpuFanSpeeds[9] = 40;
  ms[2].cpuFanSpeeds[10] = 50;
  ms[2].cpuFanSpeeds[11] = 60;
  ms[2].cpuFanSpeeds[12] = 30;
  ms[2].cpuFanSpeeds[13] = 40;
  ms[2].cpuFanSpeeds[14] = 50;
  ms[2].cpuFanSpeeds[15] = 60;

  // 4. Meeting-Profil:
  //------------------
  wcscpy_s( ms[3].alias, L"Meeting" );
  ms[3].monEnabled[CPUMON] = TRUE;
  ms[3].monEnabled[GPUMON] = FALSE;
  ms[3].monEnabled[MEMMON] = FALSE;
  ms[3].monEnabled[CHSMON] = FALSE;
  ms[3].cpuMonTemp[0] = 60;
  ms[3].cpuMonTemp[1] = 50;
  ms[3].cpuMonTemp[2] = 70;
  ms[3].cpuMonTemp[3] = 60;
  ms[3].cpuMonTemp[4] = 80;
  ms[3].cpuMonTemp[5] = 70;
  ms[3].cpuMonTemp[6] = 85;
  ms[3].cpuMonTemp[7] = 80;
  ms[3].cpuFanSpeeds[0] = 2;
  ms[3].cpuFanSpeeds[1] = 2;
  ms[3].cpuFanSpeeds[2] = 3;
  ms[3].cpuFanSpeeds[3] = 3;
  ms[3].cpuFanSpeeds[4] = 1;
  ms[3].cpuFanSpeeds[5] = 2;
  ms[3].cpuFanSpeeds[6] = 3;
  ms[3].cpuFanSpeeds[7] = 3;
  ms[3].cpuFanSpeeds[8] = 30;
  ms[3].cpuFanSpeeds[9] = 40;
  ms[3].cpuFanSpeeds[10] = 50;
  ms[3].cpuFanSpeeds[11] = 60;
  ms[3].cpuFanSpeeds[12] = 30;
  ms[3].cpuFanSpeeds[13] = 40;
  ms[3].cpuFanSpeeds[14] = 50;
  ms[3].cpuFanSpeeds[15] = 60;
}

//----------------------------------------------------------
// alle Optionen aus der Registry lesen
//----------------------------------------------------------
bool TOptions::getRegKeys()
{
  LONG lReturn = 0;
  CRegKey key;
  CRegKey keyOld;
  ULONG size = sizeof DWORD;   // DWORD size

  lReturn = key.Create( HKEY_CURRENT_USER, _T("Software\\CD\\I8KFAN\\") );

  if( lReturn == ERROR_SUCCESS )
  {
    for( int i=0; i<4; i++ )
      if( !readMonSet(i) )
        return false;

    // nicht mehr verwendete Einstellungen:
    key.DeleteValue( _T("ReadOtherTemp") );
    key.DeleteValue( _T("ReadDIMMTemp") );
    key.DeleteValue( _T("CPUMonitor") );
    key.DeleteValue( _T("I8500SensorMode") );
    key.DeleteValue( _T("I8500FanMode") );
    key.DeleteValue( _T("ModelChecked") );
    key.DeleteValue( _T("AdvancedOptions") );
    key.DeleteValue( _T("TimerBase") );
    key.DeleteValue( _T("Autoupdate") );
    key.DeleteValue( _T("ObserverMode") );
    key.DeleteValue( _T("FanForce") );
    key.DeleteValue( _T("TempMonitor") );
    //key.DeleteValue( );

    // Einstellungen einlesen:
    READDW(opmode,_T("OperationMode"))
    READDW(preDefSet,_T("Predefset"))
    READDW(autoStart,_T("Autostart"))
    READDW(terminate,_T("AutostartTerminate"))
    READDW(acOnly,_T("AutostartOnACOnly"))
    READDW(autoInnerSlider,_T("AutoInnerSpeed"))
    READDW(autoOuterSlider,_T("AutoOuterSpeed"))
    READDW(readCPUTemp,_T("ReadCPUTemp"))
    READDW(readGPUTemp,_T("ReadGPUTemp"))
    READDW(readMemoryTemp,_T("ReadMemoryTemp"))
    READDW(readChipsetTemp,_T("ReadChipsetTemp"))
    READDW(readHDTemp,_T("ReadHDTemp"))
    READDW(readHDTemp2,_T("ReadHDTemp2"))
    READDW(readFanSpeed1,_T("ReadFanSpeed0"))
    READDW(readFanSpeed2,_T("ReadFanSpeed1"))
    READDW(readFanStatus1,_T("ReadFanStatus0"))
    READDW(readFanStatus2,_T("ReadFanStatus1"))
    READDW(intervalCPU,_T("Updateinterval"))
    READDW(intervalHD,_T("UpdateintervalHD"))
    READDW(showDiagram,_T("ShowDiagram"))
    READDW(debugMode,_T("DebugMode"))
    READDW(minimizeOnClose,_T("MinimizeOnClose"))
    READDW(speedIcon,_T("FanSpeedIcon"))
    READDW(hdNo,_T("ReadHDNo"))
    READDW(hdNo2,_T("ReadHDNo2"))
    READDW(readCPUSpeed,_T("ReadCPUSpeed"))
    READDW(readCPUVar,_T("ReadCPUVar"))
    READDW(readCPULoad,_T("ReadCPULoad"))
    READDW(sensorSupport,_T("SensorSupport"))
    READDW(sensorCheck,_T("SensorCheck"))
    READDW(fahrenHeit,_T("FahrenHeitSupport"))
    READDW(maintainSpeeds,_T("MaintainSpeeds"))
    READDW(drawCPUTemp,_T("DrawCPUTemp"))
    READDW(drawGPUTemp,_T("DrawGPUTemp"))
    READDW(drawMemoryTemp,_T("DrawMemoryTemp"))
    READDW(drawChipsetTemp,_T("DrawChipsetTemp"))
    READDW(drawCPULoad,_T("DrawCPULoad"))
    READDW(drawCPUSpeed,_T("DrawCPUSpeed"))
    READDW(speedScaling,_T("SpeedScaling"))
    READDW(debugControls,_T("ActivateDebugControls"))
    READDW(compatibleSensor,_T("CompatibleSensorFound"))
    READDW(autoSpeedDirect1,_T("AutoSpeedDirect1"))
    READDW(autoSpeedDirect2,_T("AutoSpeedDirect2"))
    READDW(autoFanSetting,_T("AutoFanSetting"))
    READDW(autoStartHWFans,_T("AutoStartHardwareFans"))
    READDW(tempCtrlHWFans,_T("TempControlHardwareFans"))
    READDW(fanUsageBalancing,_T("FanUsageBalancing"))
    READDW(i8100Fix,_T("EnableI8100A08Fix"))
    READDW(modelChecked,_T("ModelTypeChecked"))
    READDW(fanSpeedDivider,_T("FanSpeedDivider"))
    READDW(cpuSensorNo,_T("CPUSensorNo"))
    READDW(gpuSensorNo,_T("GPUSensorNo"))
    READDW(memorySensorNo,_T("MemorySensorNo"))
    READDW(chipsetSensorNo,_T("ChipsetSensorNo"))
    READDW(numFans,_T("NumberOfFans"))
    READDW(fan1Index,_T("Fan1Index"))
    READDW(fan2Index,_T("Fan2Index"))
    READDW(trayIcon1,_T("TrayIcon1"))
    READDW(trayIcon2,_T("TrayIcon2"))
    READDW(trayColor1,_T("TrayColor1"))
    READDW(trayColor2,_T("TrayColor2"))
    READDW(transparentBkg,_T("TransparentBkg"))
    READDW(statusIcon2,_T("StatusIcon2"))
    READDW(trayIcon1b,_T("TrayIcon1b"))
    READDW(trayIcon2b,_T("TrayIcon2b"))
    READDW(trayColor1b,_T("TrayColor1b"))
    READDW(trayColor2b,_T("TrayColor2b"))
    READDW(transparentBkgB,_T("TransparentBkgB"))
    READDW(fanTransparentBkg,_T("FanTransparentBkg"))
    READDW(fanTrayColor1,_T("FanTrayColor1"))
    READDW(fanTrayColor2,_T("FanTrayColor2"))
    READDW(fanTraySpeedDivider,_T("FanTraySpeedDivider"))
    READDW(fanIconStateOnly,_T("FanIconStateOnly"))
    READDW(cpuCompensation,_T("CPUTempCompensation" ))
    READDW(gpuCompensation,_T("GPUTempCompensation" ))
    READDW(memoryCompensation,_T("MemoryTempCompensation" ))
    READDW(chipsetCompensation,_T("ChipsetTempCompensation" ))
    READDW(fan1SensorIndex,_T("Fan1SensorIndex"))
    READDW(fan2SensorIndex,_T("Fan2SensorIndex"))
    READDW(fanForceInterval,_T("FanForceInterval"))
    READDW(fan1Force,_T("Fan1Force"))
    READDW(fan2Force,_T("Fan2Force"))
    READDW(colorTheme,L"ColorTheme")

    DWORD cnt = 31;
    if( key.QueryValue(L"BIOSVersion",NULL,regdummy,&cnt) != ERROR_SUCCESS )
      key.SetValue( L"BIOSVersion",REG_SZ,L"x", 1 );
    else
    {
      regdummy[cnt] = '\0';
      wcscpy_s( biosVer, regdummy );
    }

    cnt = 31;
    if( key.QueryValue(_T("Fan1Alias"),NULL,regdummy,&cnt) == ERROR_SUCCESS )
      fan1Alias = regdummy;

    cnt = 31;
    if( key.QueryValue(_T("Fan2Alias"),NULL,regdummy,&cnt) == ERROR_SUCCESS )
      fan2Alias = regdummy;
  }
  else
    return false;

  key.Close();
  return true;
}

//----------------------------------------------------------
// alle Optionen in die Registry schreiben
//----------------------------------------------------------
bool TOptions::setRegKeys()
{
  LONG lReturn = 0;
  CRegKey key;
  ULONG size = sizeof DWORD;   // DWORD size

  lReturn = key.Create( HKEY_CURRENT_USER, _T("Software\\CD\\I8KFAN\\") );

  if( lReturn == ERROR_SUCCESS )
  {
    for( int i=0; i<4; i++ )
      if( !writeMonSet(i) )
        return false;

    WRITEDW(opmode,_T("OperationMode"))
    WRITEDW(preDefSet,_T("Predefset"))
    WRITEDW(autoStart,_T("Autostart"))
    WRITEDW(terminate,_T("AutostartTerminate"))
    WRITEDW(acOnly,_T("AutostartOnACOnly"))
    WRITEDW(autoInnerSlider,_T("AutoInnerSpeed"))
    WRITEDW(autoOuterSlider,_T("AutoOuterSpeed"))
    WRITEDW(readCPUTemp,_T("ReadCPUTemp"))
    WRITEDW(readGPUTemp,_T("ReadGPUTemp"))
    WRITEDW(readMemoryTemp,_T("ReadMemoryTemp"))
    WRITEDW(readChipsetTemp,_T("ReadChipsetTemp"))
    WRITEDW(readHDTemp,_T("ReadHDTemp"))
    WRITEDW(readHDTemp2,_T("ReadHDTemp2"))
    WRITEDW(readFanSpeed1,_T("ReadFanSpeed0"))
    WRITEDW(readFanSpeed2,_T("ReadFanSpeed1"))
    WRITEDW(readFanStatus1,_T("ReadFanStatus0"))
    WRITEDW(readFanStatus2,_T("ReadFanStatus1"))
    WRITEDW(intervalCPU,_T("Updateinterval"))
    WRITEDW(intervalHD,_T("UpdateintervalHD"))
    WRITEDW(showDiagram,_T("ShowDiagram"))
    WRITEDW(debugMode,_T("DebugMode"))
    WRITEDW(minimizeOnClose,_T("MinimizeOnClose"))
    WRITEDW(speedIcon,_T("FanSpeedIcon"))
    WRITEDW(hdNo,_T("ReadHDNo"))
    WRITEDW(hdNo2,_T("ReadHDNo2"))
    WRITEDW(trayIcon1,_T("TrayIcon1"))
    WRITEDW(trayIcon2,_T("TrayIcon2"))
    WRITEDW(readCPUSpeed,_T("ReadCPUSpeed"))
    WRITEDW(readCPUVar,_T("ReadCPUVar"))
    WRITEDW(readCPULoad,_T("ReadCPULoad"))
    WRITEDW(sensorSupport,_T("SensorSupport"))
    WRITEDW(sensorCheck,_T("SensorCheck"))
    WRITEDW(fahrenHeit,_T("FahrenHeitSupport"))
    WRITEDW(maintainSpeeds,_T("MaintainSpeeds"))
    WRITEDW(drawCPUTemp,_T("DrawCPUTemp"))
    WRITEDW(drawGPUTemp,_T("DrawGPUTemp"))
    WRITEDW(drawMemoryTemp,_T("DrawMemoryTemp"))
    WRITEDW(drawChipsetTemp,_T("DrawChipsetTemp"))
    WRITEDW(drawCPULoad,_T("DrawCPULoad"))
    WRITEDW(drawCPUSpeed,_T("DrawCPUSpeed"))
    WRITEDW(speedScaling,_T("SpeedScaling"))
    WRITEDW(compatibleSensor,_T("CompatibleSensorFound"))
    WRITEDW(autoSpeedDirect1,_T("AutoSpeedDirect1"))
    WRITEDW(autoSpeedDirect2,_T("AutoSpeedDirect2"))
    WRITEDW(autoFanSetting,_T("AutoFanSetting"))
    WRITEDW(autoStartHWFans,_T("AutoStartHardwareFans"))
    WRITEDW(tempCtrlHWFans,_T("TempControlHardwareFans"))
    WRITEDW(fanUsageBalancing,_T("FanUsageBalancing"))
    WRITEDW(i8100Fix,_T("EnableI8100A08Fix"))
    WRITEDW(modelChecked,_T("ModelTypeChecked"))
    WRITEDW(fanSpeedDivider,_T("FanSpeedDivider"))
    WRITEDW(cpuSensorNo,_T("CPUSensorNo"))
    WRITEDW(gpuSensorNo,_T("GPUSensorNo"))
    WRITEDW(memorySensorNo,_T("MemorySensorNo"))
    WRITEDW(chipsetSensorNo,_T("ChipsetSensorNo"))
    WRITEDW(numFans,_T("NumberOfFans"))
    WRITEDW(fan1Index,_T("Fan1Index"))
    WRITEDW(fan2Index,_T("Fan2Index"))
    WRITEDW(trayColor1,_T("TrayColor1"))
    WRITEDW(trayColor2,_T("TrayColor2"))
    WRITEDW(transparentBkg,_T("TransparentBkg"))
    WRITEDW(statusIcon2,_T("StatusIcon2"))
    WRITEDW(fanTransparentBkg,_T("FanTransparentBkg"))
    WRITEDW(fanTrayColor1,_T("FanTrayColor1"))
    WRITEDW(fanTrayColor2,_T("FanTrayColor2"))
    WRITEDW(fanTraySpeedDivider,_T("FanTraySpeedDivider"))
    WRITEDW(fanIconStateOnly,_T("FanIconStateOnly"))
    WRITEDW(cpuCompensation,_T("CPUTempCompensation" ))
    WRITEDW(gpuCompensation,_T("GPUTempCompensation" ))
    WRITEDW(memoryCompensation,_T("MemoryTempCompensation" ))
    WRITEDW(chipsetCompensation,_T("ChipsetTempCompensation" ))
    WRITEDW(fan1SensorIndex,_T("Fan1SensorIndex"))
    WRITEDW(fan2SensorIndex,_T("Fan2SensorIndex"))
    WRITEDW(fanForceInterval,_T("FanForceInterval"))
    WRITEDW(fan1Force,_T("Fan1Force"))
    WRITEDW(fan2Force,_T("Fan2Force"))
    WRITEDW(trayIcon1b,_T("TrayIcon1b"))
    WRITEDW(trayIcon2b,_T("TrayIcon2b"))
    WRITEDW(trayColor1b,_T("TrayColor1b"))
    WRITEDW(trayColor2b,_T("TrayColor2b"))
    WRITEDW(transparentBkgB,_T("TransparentBkgB"))
    WRITEDW(colorTheme,L"ColorTheme")

    if( key.SetValue(_T("BIOSVersion"),REG_SZ,(LPCTSTR)biosVer,(ULONG)(_tcslen(biosVer)*sizeof(wchar_t))) != ERROR_SUCCESS )
    {
      key.Close();
      return false;
    }

    if( key.SetValue(_T("Fan1Alias"),REG_SZ,(LPCTSTR)fan1Alias,(ULONG)(_tcslen(fan1Alias)*sizeof(wchar_t))) != ERROR_SUCCESS )
    {
      key.Close();
      return false;
    }

    if( key.SetValue(_T("Fan2Alias"),REG_SZ,(LPCTSTR)fan2Alias,(ULONG)(_tcslen(fan2Alias)*sizeof(wchar_t))) != ERROR_SUCCESS )
    {
      key.Close();
      return false;
    }
  }
  else
    return false;

  key.Close();

  return true;
}

//----------------------------------------------------------
// Schreiben eines kompletten Monitorprofils in die Registry
//----------------------------------------------------------
bool TOptions::writeMonSet( int no )
{
  wchar_t name[64];
  long lReturn;
  CRegKey key;

  wsprintfW( name, _T("Software\\CD\\I8KFAN\\Monpolicy%d"), no+1 );

  lReturn = key.Create( HKEY_CURRENT_USER, name );
  if( lReturn == ERROR_SUCCESS )
  {
    if( !writeIntList(key,ms[no].monEnabled,4,_T("MonEnabled"))
    ||  !writeIntList(key,ms[no].cpuMonTemp,8,_T("CPUMonTemp")) 
    ||  !writeIntList(key,ms[no].gpuMonTemp,8,_T("GPUMonTemp")) 
    ||  !writeIntList(key,ms[no].memoryMonTemp,8,_T("MemoryMonTemp"))
    ||  !writeIntList(key,ms[no].chipsetMonTemp,8,_T("ChipsetMonTemp")) 
    ||  !writeIntList(key,ms[no].cpuFan,2,_T("CPUFan")) 
    ||  !writeIntList(key,ms[no].gpuFan,2,_T("GPUFan"))
    ||  !writeIntList(key,ms[no].memoryFan,2,_T("MemoryFan"))
    ||  !writeIntList(key,ms[no].chipsetFan,2,_T("ChipsetFan"))
    ||  !writeIntList(key,ms[no].cpuFanSpeeds,16,_T("CPUFanSpeeds"))
    ||  !writeIntList(key,ms[no].gpuFanSpeeds,16,_T("GPUFanSpeeds"))
    ||  !writeIntList(key,ms[no].memoryFanSpeeds,16,_T("MemoryFanSpeeds"))
    ||  !writeIntList(key,ms[no].chipsetFanSpeeds,16,_T("ChipsetFanSpeeds")) )
      return false;

    if( key.SetValue(_T("Alias"),REG_SZ,(LPCTSTR)ms[no].alias,(ULONG)(_tcslen(ms[no].alias)*sizeof(wchar_t))) != ERROR_SUCCESS )
    {
      key.Close();
      return false;
    }

    key.Close();
  }
  else 
    return false;

  return true;
}

//----------------------------------------------------------
// Auslesen eines kompletten Monitorprofils aus der Registry
//----------------------------------------------------------
bool TOptions::readMonSet( int no )
{
  wchar_t name[128];
  long lReturn;
  CRegKey key;

  wsprintfW( name, _T("Software\\CD\\I8KFAN\\Monpolicy%d"), no+1 );

  lReturn = key.Create( HKEY_CURRENT_USER, name );
  if( lReturn == ERROR_SUCCESS )
  {
    readIntList( key, ms[no].monEnabled, 4, _T("MonEnabled") );
    readIntList( key, ms[no].cpuMonTemp, 8, _T("CPUMonTemp") );
    readIntList( key, ms[no].gpuMonTemp, 8, _T("GPUMonTemp") );
    readIntList( key, ms[no].memoryMonTemp, 8, _T("MemoryMonTemp") );
    readIntList( key, ms[no].chipsetMonTemp, 8, _T("ChipsetMonTemp") );
    readIntList( key, ms[no].cpuFan, 2, _T("CPUFan") );
    readIntList( key, ms[no].gpuFan, 2, _T("GPUFan") );
    readIntList( key, ms[no].memoryFan, 2, _T("MemoryFan") );
    readIntList( key, ms[no].chipsetFan, 2, _T("ChipsetFan") );
    readIntList( key, ms[no].cpuFanSpeeds, 16, _T("CPUFanSpeeds") );
    readIntList( key, ms[no].gpuFanSpeeds, 16, _T("GPUFanSpeeds") );
    readIntList( key, ms[no].memoryFanSpeeds, 16, _T("MemoryFanSpeeds") );
    readIntList( key, ms[no].chipsetFanSpeeds, 16, _T("ChipsetFanSpeeds") );

    DWORD cnt = 127;
    if( key.QueryValue(_T("Alias"),NULL,regdummy,&cnt) == ERROR_SUCCESS )
    {
      regdummy[cnt] = '\0';
      wcscpy_s( ms[no].alias, regdummy );
    }

    key.Close();
  }

  return true;
}

//----------------------------------------------------------
// Schreiben einer Option eines Profils in die Registry
//----------------------------------------------------------
bool TOptions::writeIntList( CRegKey& key, int* ptr, int d, wchar_t* keyName )
{
  static wchar_t value[4096];

  *value = '\0';

  for( int i=0; i<d; i++ )
    wsprintfW( &value[_tcslen(value)], _T("%d "), ptr[i] );

  for( size_t i=_tcslen(value)-1; i>=0 && i<4096; i-- )
  {
    if( value[i] == ' ' )
      value[i] = '\0';
    else
      break;
  }

  if( key.SetValue(keyName,REG_SZ,(LPCTSTR)value,(ULONG)(_tcslen(value)*sizeof(wchar_t))) != ERROR_SUCCESS )
  {
    key.Close();
    return false;
  }

  return true;
}

//----------------------------------------------------------
// Lesen einer Option eines Profils aus der Registry
//----------------------------------------------------------
bool TOptions::readIntList( CRegKey& key, int* ptr, int d, wchar_t* keyName )
{
  static wchar_t value[4096];
  static DWORD cnt;

  cnt = 4095;

  if( key.QueryValue(keyName,NULL,value,&cnt) != ERROR_SUCCESS )
    return false;

  static wchar_t t[32];
  wchar_t* u = value;
  int i=0;

  for( ;; )
  {
    while( isspace(*u) ) u++;
    int k=0;
    *t = '\0';

    while( *u )
      if( *u && !isspace(*u) )
        t[k++] = *u++;
      else
        break;

    t[k] = '\0';

    ptr[i] = _wtoi( t );

    i++;
    if( i >= d )
      break;
  }

  return true;
}

//----------------------------------------------------------
// Konvertierung von Celsius nach Fahrenheit und zurck
//----------------------------------------------------------
int TOptions::convertTemp( int temp, int target )
{
  double t = (double)temp+40.0;

  if( target == CELSIUS )
    t *= (double)5.0/(double)9.0;
  else
    t *= (double)1.8;

  t -= 40;

  return (int)t;
}

//----------------------------------------------------------
// Konvertierung eines Infostrings in ein Listcontrol
//----------------------------------------------------------
void TOptions::fillList( wchar_t* t, CListCtrl* m_cList )
{
  m_cList->DeleteAllItems();

  static wchar_t prop[256];
  static wchar_t value[256];
  int nIndex=-1;
  int i=0;
  int j=0;
  wchar_t* s = t;

  for( ;; )
  {
    s = t;
    while( isspace(*s) ) s++;
    
    t = s;

    while( *s && *s!=':' )
      s++;

    _tcsncpy_s( prop, t, s-t );
    prop[s-t] = '\0';

    if( *s )
    {
      s += 2;
      t = s;
      while( *s && *s!='\r' )
        s++;
      
      _tcsncpy_s( value, t, s-t );
      value[s-t] = '\0';

      if( *s )
        s += 2;
    }
    else 
      *value = '\0';

    nIndex = m_cList->InsertItem( nIndex+1, prop );
    m_cList->SetItemText( nIndex, 1, value );
    
    t = s;
    
    if( !*s )
      break;
  }

}
