/*
   I8kfanGUI V3.0
   Copyright(c) 2001-2006 Christian Diefer
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as 
   published by the Free Software Foundation.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef __TEMPCONTROL_H
#define __TEMPCONTROL_H

class TMonSettings;

class CTempControl {
  public:
    inline CTempControl() { fanRotation=false; }
    inline ~CTempControl() {}
    void readTempData( BOOL init=false );
    int readFanStates();
    void maintainSpeeds();
	  void control();

  private:
    void getTempLevel( int temp, int& level, int* monTemp );
    void setFanLevel( int fanNo, TMonSettings* ms, int* levels, BOOL* active, 
                      BOOL statusReading, int curStatus, int curSensorSpeed );
    void setSpeed( int fanNo, int speed );

    unsigned stat1;
    unsigned stat2;
    bool fanRotation;
    bool changed;

    int rstat1, rstat2;
    int ms11, ms12;
    int ms21, ms22;
    int ms31, ms32;
    int ms41, ms42;
    int ss11, ss12;
    int ss21, ss22;
    int ss31, ss32;
    int ss41, ss42;
};

#endif
