/*
   I8kfanGUI V3.0
   Copyright(c) 2001-2006 Christian Diefer

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as 
   published by the Free Software Foundation.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "stdafx.h"
#include "AtlBase.h"
#include "i8kfangui.h"
#include "TOptions.h"
#include "GlobalVars.h"
#include "TrayIconManager.h"
#include <winuser.h>
#include "i8kfanctrl.h"

//---------------------------------------------------------------
// Icons frs Systemtray aufbauen und anzeigen
//---------------------------------------------------------------
void TTrayIconManager::displayTrayIcon( DWORD msg, bool forceMainIcon, bool forceMainIcon2, bool forceFanIcon )
{
  NOTIFYICONDATA_CD nid;
  wchar_t tp[192];
  bool prev = false;

  // Prfen, ob schon Icons angezeigt werden und ob neue dazu kommen => die bestehenden Icons zuerst entfernen!
  // oder ob ein/mehrere Icons, die zur Zeit angezeigt werden, in den Optionen deaktiviert wurden => diese entfernen

  if( options.speedIcon && !options.readFanSpeed1 && !options.readFanSpeed2 
    && !options.readFanStatus1 && !options.readFanStatus2 )
    options.speedIcon = FALSE;

  // Systemicon #1 entfernen?
  if( glb_bTrayIcon1Active 
  &&  (!options.tempIcon || (options.statusIcon2 && !glb_bTrayIcon2Active) || (options.speedIcon && !glb_bSpeedIconActive)) )
  {
    nid.cbSize = sizeof( NOTIFYICONDATA );
    nid.hWnd = glb_hWnd;
    nid.uID = 700;
    nid.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
    nid.uCallbackMessage = WM_ICONNOTIFY;

    if( options.trayIcon1==0 && options.trayIcon2==0 )
      nid.hIcon = glb_hIcon;
    else     
      nid.hIcon = glb_hTempIcon;

    Shell_NotifyIcon( NIM_DELETE, (PNOTIFYICONDATA)&nid );
    glb_bTrayIcon1Active = false;
  }

  // Systemicon #2 entfernen?
  if( glb_bTrayIcon2Active 
  &&  (!options.statusIcon2 || (options.tempIcon && !glb_bTrayIcon1Active) || (options.speedIcon && !glb_bSpeedIconActive)) )
  {
    nid.cbSize = sizeof( NOTIFYICONDATA );
    nid.hWnd = glb_hWnd;
    nid.uID = 701;
    nid.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
    nid.uCallbackMessage = WM_ICONNOTIFY;
    nid.hIcon = glb_hTempIcon2;
    Shell_NotifyIcon( NIM_DELETE, (PNOTIFYICONDATA)&nid );
    glb_bTrayIcon2Active = false;
  }

  // Lftericon entfernen?
  if( glb_bSpeedIconActive 
  &&  (!options.speedIcon || (options.tempIcon && !glb_bTrayIcon1Active) || (options.statusIcon2 && !glb_bTrayIcon2Active)) )
  {
    nid.cbSize = sizeof( NOTIFYICONDATA );
    nid.hWnd = glb_hWnd;
    nid.uID = 702;
    nid.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
    nid.uCallbackMessage = WM_ICONNOTIFY;
    nid.hIcon = glb_hSpeedIcon;
    Shell_NotifyIcon( NIM_DELETE, (PNOTIFYICONDATA)&nid );
    glb_bSpeedIconActive = false;
  }

  if( options.speedIcon && (options.readFanSpeed1 || options.readFanSpeed2 || options.readFanStatus1 || options.readFanStatus2) )
    createFanIcon( msg, forceFanIcon );
  else if( glb_bSpeedIconActive )
  {
    nid.cbSize = sizeof( NOTIFYICONDATA );
    nid.hWnd = glb_hWnd;
    nid.uID = 702;
    nid.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
    nid.uCallbackMessage = WM_ICONNOTIFY;
    nid.hIcon = glb_hSpeedIcon;
    Shell_NotifyIcon( NIM_DELETE, (PNOTIFYICONDATA)&nid );
    glb_bSpeedIconActive = false;
  }

  // Tooltip fr die Systemicons anlegen:
  *tp = '\0';
  prev = false;

  if( options.readCPUTemp )
  {
    CString max;
    if( glb_iCPUMax == 0 )
      max = L"---";
    else
      max.Format( L"%d%c", 
                  options.fahrenHeit ? options.convertTemp(glb_iCPUMax,FAHRENHEIT) : glb_iCPUMax,
                  options.fahrenHeit ? 'F' : 'C' );
    prev = true;
    sx.LoadStringW( IDS_TRAY1 );
    wsprintfW( tp, sx, 
                  options.fahrenHeit ? options.convertTemp(glb_iCPUTemp,FAHRENHEIT) : glb_iCPUTemp,
                  options.fahrenHeit ? 'F' : 'C',
                  max );
  }

  if( options.readGPUTemp )
  {
    if( prev )
      _tcscat_s( tp, L"\n" );
  
    CString max;
    if( glb_iGPUMax == 0 )
      max = "---";
    else
      max.Format( L"%d%c", 
                  options.fahrenHeit ? options.convertTemp(glb_iGPUMax,FAHRENHEIT) : glb_iGPUMax,
                  options.fahrenHeit ? 'F' : 'C' );
    prev = true;
    sx.LoadStringW( IDS_TRAY2 );
    wsprintfW( &tp[_tcslen(tp)], sx, 
                               options.fahrenHeit ? options.convertTemp(glb_iGPUTemp,FAHRENHEIT) : glb_iGPUTemp,
                               options.fahrenHeit ? 'F' : 'C',
                               max );
  }

  if( options.readMemoryTemp )
  {
    if( prev )
      _tcscat_s( tp, L"\n" );
  
    CString max;
    if( glb_iMemoryMax == 0 )
      max = L"---";
    else
      max.Format( L"%d%c", 
                  options.fahrenHeit ? options.convertTemp(glb_iMemoryMax,FAHRENHEIT) : glb_iMemoryMax,
                  options.fahrenHeit ? 'F' : 'C' );
    prev = true;
    sx.LoadStringW( IDS_TRAY3 );
    wsprintfW( &tp[_tcslen(tp)], sx, 
                                 options.fahrenHeit ? options.convertTemp(glb_iMemoryTemp,FAHRENHEIT) : glb_iMemoryTemp,
                                 options.fahrenHeit ? 'F' : 'C',
                                 max );
  }

  if( options.readChipsetTemp )
  {
    if( prev )
      _tcscat_s( tp, L"\n" );
  
    CString max;
    if( glb_iChipsetMax == 0 )
      max = L"---";
    else
      max.Format( L"%d%c", 
                  options.fahrenHeit ? options.convertTemp(glb_iChipsetMax,FAHRENHEIT) : glb_iChipsetMax,
                  options.fahrenHeit ? 'F' : 'C' );
    prev = true;
    sx.LoadStringW( IDS_TRAY4 );
    wsprintfW( &tp[_tcslen(tp)], sx, 
                                 options.fahrenHeit ? options.convertTemp(glb_iChipsetTemp,FAHRENHEIT) : glb_iChipsetTemp,
                                 options.fahrenHeit ? 'F' : 'C',
                                 max );
  }

  if( options.readHDTemp )
  {
    if( prev )
      _tcscat_s( tp, L"\n" );
  
    CString max;
    if( glb_iHDMax == 0 )
      max = L"---";
    else
      max.Format( L"%d%c", 
                  options.fahrenHeit ? options.convertTemp(glb_iHDMax,FAHRENHEIT) : glb_iHDMax,
                  options.fahrenHeit ? 'F' : 'C' );
    prev = true;
    sx.LoadStringW( IDS_TRAY5 );
    wsprintfW( &tp[_tcslen(tp)], sx, 
                                 options.fahrenHeit ? options.convertTemp(glb_iHDTemp,FAHRENHEIT) : glb_iHDTemp,
                                 options.fahrenHeit ? 'F' : 'C',
                                 max );
  }

  if( options.readHDTemp2 )
  {
    if( prev )
      _tcscat_s( tp, L"\n" );
  
    CString max;
    if( glb_iHDMax2 == 0 )
      max = L"---";
    else
      max.Format( L"%d%c", 
                  options.fahrenHeit ? options.convertTemp(glb_iHDMax2,FAHRENHEIT) : glb_iHDMax2,
                  options.fahrenHeit ? 'F' : 'C' );
    prev = true;
    sx.LoadStringW( IDS_TRAY6 );
    wsprintfW( &tp[_tcslen(tp)], sx, 
                                 options.fahrenHeit ? options.convertTemp(glb_iHDTemp2,FAHRENHEIT) : glb_iHDTemp2,
                                 options.fahrenHeit ? 'F' : 'C',
                                 max );
  }

  if( options.readCPUSpeed )
  {
    if( prev )
      _tcscat_s( tp, L"\n" );
  
    prev = true;
    sx.LoadStringW( IDS_TRAY7 );
    wsprintfW( &tp[_tcslen(tp)], sx, glb_szCPUSpeed );
  }

  if( options.readCPULoad )
  {
    if( prev )
      _tcscat_s( tp, L"\n" );

    sx.LoadStringW( IDS_TRAY8 );
    wsprintfW( &tp[_tcslen(tp)], sx, glb_szCPULoad );
  }

  if( !*tp )
  {
    sx.LoadStringW( IDS_TRAY9 );
    _tcscpy_s( tp, sx );
  }

  if( !glb_bShellVer5 )    // IE < 5
  {
    if( _tcslen(tp) > 63 )   // nur 63 Zeichen erlaubt
      _tcscpy_s( tp+60, 4, L"..." );
    
    nid.cbSize = sizeof( NOTIFYICONDATA );  // alte Strukturgre verwenden
  }
  else    // IE >= 5
  {
    if( _tcslen(tp) > 127 )      // nur 127 Zeichen erlaubt (reicht locker)
      _tcscpy_s( tp+124, 4, L"..." );
  }

  if( options.statusIcon2 && (options.trayIcon1b!=0 || options.trayIcon2b!=0) )
    createSystemIcon( msg, forceMainIcon2, tp, 1 );
  else if( glb_bTrayIcon2Active )
  {
    nid.cbSize = sizeof( NOTIFYICONDATA );
    nid.hWnd = glb_hWnd;
    nid.uID = 701;
    nid.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
    nid.uCallbackMessage = WM_ICONNOTIFY;
    nid.hIcon = glb_hTempIcon2;
    Shell_NotifyIcon( NIM_DELETE, (PNOTIFYICONDATA)&nid );
    glb_bTrayIcon2Active = false;
  }

  createSystemIcon( msg, forceMainIcon, tp, 0 );
}

//---------------------------------------------------------------
// legt eines der beiden Systemicons an
//---------------------------------------------------------------
void TTrayIconManager::createSystemIcon( DWORD msg, bool force, wchar_t* tp, int iconNo )
{
  NOTIFYICONDATA_CD nid;

  nid.cbSize = sizeof( NOTIFYICONDATA_CD );
  nid.hWnd = glb_hWnd;
  nid.uID = 700+iconNo;
  nid.uFlags = NIF_MESSAGE | NIF_TIP;
  nid.uCallbackMessage = WM_ICONNOTIFY;

  lstrcpyW( nid.szTip, tp );

  if( iconNo == 0 )
  {
    if( !glb_bTrayIcon1Active )
      msg = NIM_ADD;
    else
      msg = NIM_MODIFY;
  }
  else if( iconNo == 1 )
  {
    if( !glb_bTrayIcon2Active )
      msg = NIM_ADD;
    else
      msg = NIM_MODIFY;
  }

  if( iconNo==0 && options.trayIcon1==0 && options.trayIcon2==0 )    // 2x nix => Standardicon anzeigen
  {
    nid.uFlags |= NIF_ICON;
    nid.hIcon = glb_hIcon;
    Shell_NotifyIcon( msg, (PNOTIFYICONDATA)&nid );
    glb_bTrayIcon1Active = true;
    return;
  }
  else if( iconNo==1 && options.trayIcon1b==0 && options.trayIcon2b==0 )
    return;

  // neues Temperaturicon anlegen:
  static int oldTemp1 = -1;
  static int oldTemp2 = -1;
  static int oldTemp1b = -1;
  static int oldTemp2b = -1;
  int temp1=0, temp2=0;

  if( force && iconNo==0 )
    oldTemp1 = oldTemp2 = -2;
  else if( force && iconNo==1 )
    oldTemp1b = oldTemp2b = -2;

  int sw1, sw2, ot1, ot2;

  if( iconNo == 0 )
  {
    sw1 = options.trayIcon1;
    sw2 = options.trayIcon2;
    ot1 = oldTemp1;
    ot2 = oldTemp2;
  }
  else if( iconNo == 1 )
  {
    sw1 = options.trayIcon1b;
    sw2 = options.trayIcon2b;
    ot1 = oldTemp1b;
    ot2 = oldTemp2b;
  }

  switch( sw1 )
  {
    case 0: temp1 = -1;     // nur untere Hlfte belegt
            break;

    case 1: if( options.readCPUTemp )
              temp1 = glb_iCPUTemp;
            else
              temp1 = -3;
            break;

    case 2: if( options.readGPUTemp )
              temp1 = glb_iGPUTemp;
            else
              temp1 = -3;
            break;

    case 3: if( options.readMemoryTemp )
              temp1 = glb_iMemoryTemp;
            else
              temp1 = -3;
            break;

    case 4: if( options.readHDTemp )
              temp1 = glb_iHDTemp;
            else
              temp1 = -3;
            break;

    case 5: if( options.readChipsetTemp )
              temp1 = glb_iChipsetTemp;
            else
              temp1 = -3;
            break;

    case 6: if( options.readCPULoad )
              temp1 = glb_iCPULoad;
            else
              temp1 = -3;
            break;

    case 7: if( options.readCPUSpeed )
            {
              int x = glb_iCPUSpeed;
              
              temp1 = x/100;
              if( x%100 >= 90 )
                temp1++;
            }
            else
              temp1 = -3;
            break;

    case 8: if( options.readHDTemp2 )
              temp1 = glb_iHDTemp2;
            else
              temp1 = -3;
            break;
  }

  switch( sw2 )
  {
    case 0: temp2 = -1;     // nur obere Hlfte belegt
            break;

    case 1: if( options.readCPUTemp )
              temp2 = glb_iCPUTemp;
            else
              temp2 = -3;
            break;

    case 2: if( options.readGPUTemp )
              temp2 = glb_iGPUTemp;
            else
              temp2 = -3;
            break;

    case 3: if( options.readMemoryTemp )
              temp2 = glb_iMemoryTemp;
            else
              temp2 = -3;
            break;

    case 4: if( options.readHDTemp )
              temp2 = glb_iHDTemp;
            else
              temp2 = -3;
            break;

    case 5: if( options.readChipsetTemp )
              temp2 = glb_iChipsetTemp;
            else
              temp2 = -3;
            break;

    case 6: if( options.readCPULoad )
              temp2 = glb_iCPULoad;
            else
              temp2 = -3;
            break;

    case 7: if( options.readCPUSpeed )
            {
              int x = glb_iCPUSpeed;
              
              temp2 = x/100;
              if( x%100 >= 90 )
                temp2++;
            }
            else
              temp2 = -3;
            break;

    case 8: if( options.readHDTemp2 )
              temp2 = glb_iHDTemp2;
            else
              temp2 = -3;
            break;
  }

  bool changed = false;           // muss eine neue Iconressource angelegt werden?

  int t1=temp1, t2=temp2;

  if( options.fahrenHeit )
  {
    if( iconNo == 0 )
    {
      if( t1>0 && options.trayIcon1!=6 ) t1 = options.convertTemp( t1, FAHRENHEIT );
      if( t2>0 && options.trayIcon2!=6 ) t2 = options.convertTemp( t2, FAHRENHEIT );
    }
    else if( iconNo == 1 )
    {
      if( t1>0 && options.trayIcon1b!=6 ) t1 = options.convertTemp( t1, FAHRENHEIT );
      if( t2>0 && options.trayIcon2b!=6 ) t2 = options.convertTemp( t2, FAHRENHEIT );
    }
  }

  bool upperStatus = false;
  bool lowerStatus = false;
  int upperValue = 0;
  int lowerValue = 0;

  if( temp1==-1 || temp2==-1 )        // nur einen Wert im Trayicon darstellen
  {
    if( (ot1!=-1 && ot2!=-1)    // statt 2 nur noch 1 Wert darstellen
    ||  (temp1==-1 && oldTemp2!=temp2)    // oder 2. Wert gendert
    ||  (temp2==-1 && oldTemp1!=temp1) )  // oder 1. Wert gendert
    {
      changed = true;
      upperStatus = true;
      upperValue = (temp1==-1 ? t2 : t1);
    }
  }
  else      // 2 Werte im Trayicon darstellen
  {
    bool override = (ot1==-1 || ot2==-1);   // Wechsel von 1 zu 2 Werten ?

    if( override || ot1!=temp1 || ot2!=temp2 )   // Anzeigenwechsel oder mindestens ein Wert gendert
    {
      changed = true;
      upperStatus = true;
      upperValue = t1;
      lowerStatus = true;
      lowerValue = t2;
    }
  }

  if( changed )     // neue Iconressource aus Bitmap anlegen
  {
    DestroyIcon( iconNo==0 ? glb_hTempIcon : glb_hTempIcon2 );    // altes Icon lschen

    if( iconNo == 0 )
      glb_hTempIcon = createIcon( upperStatus, upperValue, lowerStatus, lowerValue, 0 );
    else
      glb_hTempIcon2 = createIcon( upperStatus, upperValue, lowerStatus, lowerValue, 1 );

    nid.uFlags |= NIF_ICON;
  }

  if( iconNo == 0 )
  {
    oldTemp1 = temp1;
    oldTemp2 = temp2;
  }
  else
  {
    oldTemp1b = temp1;
    oldTemp2b = temp2;
  }

  nid.hIcon = (iconNo==0 ? glb_hTempIcon : glb_hTempIcon2);
  Shell_NotifyIcon( msg, (PNOTIFYICONDATA)&nid );

  if( iconNo == 0 )
    glb_bTrayIcon1Active = true;
  else if( iconNo == 1 )
    glb_bTrayIcon2Active = true;
}

//---------------------------------------------------------------
// legt das Lftericon an
//---------------------------------------------------------------
void TTrayIconManager::createFanIcon( DWORD msg, bool forceFanIcon )
{
  NOTIFYICONDATA_CD nid;
  wchar_t tp[192];
  bool prev = false;

  // Anlegen des Lftericons:
  nid.cbSize = sizeof( NOTIFYICONDATA );
  nid.hWnd = glb_hWnd;
  nid.uID = 702;
  nid.uFlags = NIF_MESSAGE | NIF_TIP;
  nid.uCallbackMessage = WM_ICONNOTIFY;

  *tp = '\0';

  static int oldSpeed1=-2;    // -2 reserviert fr ersten Schleifendurchlauf
  static int oldSpeed2=-2;

  if( forceFanIcon )
    oldSpeed1 = oldSpeed2 = -2;

  int s1 = options.readFanSpeed1 ? (glb_iFanSpeed1/options.fanTraySpeedDivider)%1000 : -3;
  int s2 = options.readFanSpeed2 ? (glb_iFanSpeed2/options.fanTraySpeedDivider)%1000 : -3;

  if( (options.fanIconStateOnly || s1==-3) && options.readFanStatus1 && glb_iFanStatus1!=-1 )
  {
    switch( glb_iFanStatus1 )
    {
      case 0: s1 = 0;     // '00'
              break;

      case 1: s1 = -4;    // 'Sl'
              break;

      case 2: s1 = -5;    // 'Hi'
              break;
    }
  }

  if( (options.fanIconStateOnly || s2==-3) && options.readFanStatus2 && glb_iFanStatus2!=-1 )
  {
    switch( glb_iFanStatus2 )
    {
      case 0: s2 = 0;     // '00'
              break;

      case 1: s2 = -4;    // 'Sl'
              break;

      case 2: s2 = -5;    // 'Hi'
              break;
    }
  }

  if( options.readFanSpeed1 )
  {
    prev = true;
    sx.LoadStringW( IDS_TRAY10 );
    wsprintfW( tp, sx, glb_szFan1AliasUpper, glb_iFanSpeed1 );

    if( options.readFanStatus1 )
      wsprintfW( &tp[_tcslen(tp)], L" (%s)", glb_szSpeedString1 );

    if( options.compatibleSensor )
      wsprintfW( &tp[_tcslen(tp)], L" (%d)", glb_iSensorSpeed1 );
  }
  else if( options.readFanStatus1 )
  {
    prev = true;
    sx.LoadStringW( IDS_TRAY11 );
    wsprintfW( tp, sx, glb_szFan1AliasUpper, glb_szSpeedString1 );
  }

  if( options.readFanSpeed2 )
  {
    if( prev )
      _tcscat_s( tp, L"\n" );

    prev = true;
    sx.LoadStringW( IDS_TRAY10 );
    wsprintfW( &tp[_tcslen(tp)], sx, glb_szFan2AliasUpper, glb_iFanSpeed2 );

    if( options.readFanStatus2 )
      wsprintf( &tp[_tcslen(tp)], L" (%s)", glb_szSpeedString2 );

    if( options.compatibleSensor )
      wsprintf( &tp[_tcslen(tp)], L" (%d)", glb_iSensorSpeed2 );
  } 
  else if( options.readFanStatus2 )
  {
    if( prev )
      _tcscat_s( tp, L"\n" );
  
    prev = true;
    sx.LoadStringW( IDS_TRAY11 );
    wsprintfW( &tp[_tcslen(tp)], sx, glb_szFan2AliasUpper, glb_szSpeedString2 );
  }

  lstrcpy( nid.szTip, tp );

  if( !glb_bSpeedIconActive || forceFanIcon || oldSpeed1!=s1 || oldSpeed2!=s2 )
  {
    DestroyIcon( glb_hSpeedIcon );    // keine Ressourcen vergeuden, also altes Icon lschen!
    glb_hSpeedIcon = createIcon( true, s1, true, s2, 2 );
    nid.uFlags |= NIF_ICON;
  }

  nid.hIcon = glb_hSpeedIcon;

  if( !glb_bSpeedIconActive )
    msg = NIM_ADD;
  else if( glb_bSpeedIconActive )
    msg = NIM_MODIFY;

  Shell_NotifyIcon( msg, (PNOTIFYICONDATA)&nid );

  glb_bSpeedIconActive = true;

  oldSpeed1 = s1;
  oldSpeed2 = s2;
}

//---------------------------------------------------
// fllt die Bitmap fr ein Icon
//   upperStatus: true, wenn der obere Iconteil gefllt werden soll
//   upperValue: der im oberen Iconbereich anzuzeigende Wert
//   lowerStatus: true, wenn der untere Iconteil gefllt werden soll
//   lowerValue: der im unteren Iconbereich anzuzeigende Wert
//   iconType: 0=1.Systemicon, 1=2.Systemicon, 2=Lftericon
//---------------------------------------------------
HICON TTrayIconManager::createIcon( bool upperStatus, int upperValue, bool lowerStatus, int lowerValue, int iconType )
{
  DWORD dwWidth, dwHeight;
  BITMAPINFO* bi;
  HBITMAP hBitmap;
  void *lpBits;
  HICON hIcon = NULL;

  dwWidth  = 16;
  dwHeight = 16;

  bi = (BITMAPINFO*)new char[ sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD) * 2]; 

  ZeroMemory( bi, sizeof(BITMAPINFOHEADER) + sizeof(RGBQUAD) * 2 );

  bi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
  bi->bmiHeader.biWidth = dwWidth;
  bi->bmiHeader.biHeight = dwHeight;
  bi->bmiHeader.biPlanes = 1;
  bi->bmiHeader.biBitCount = 1;
  bi->bmiHeader.biCompression = BI_RGB;
  
  if( iconType == 0 )   // 1. Systemicon
  {
    bi->bmiColors[0].rgbRed = colorVal[options.trayColor1][0];
    bi->bmiColors[0].rgbGreen = colorVal[options.trayColor1][1];
    bi->bmiColors[0].rgbBlue = colorVal[options.trayColor1][2];
    bi->bmiColors[1].rgbRed = colorVal[options.trayColor2][0];
    bi->bmiColors[1].rgbGreen = colorVal[options.trayColor2][1];
    bi->bmiColors[1].rgbBlue = colorVal[options.trayColor2][2];
  }
  else if( iconType == 1 )    // 2. Systemicon
  {
    bi->bmiColors[0].rgbRed = colorVal[options.trayColor1b][0];
    bi->bmiColors[0].rgbGreen = colorVal[options.trayColor1b][1];
    bi->bmiColors[0].rgbBlue = colorVal[options.trayColor1b][2];
    bi->bmiColors[1].rgbRed = colorVal[options.trayColor2b][0];
    bi->bmiColors[1].rgbGreen = colorVal[options.trayColor2b][1];
    bi->bmiColors[1].rgbBlue = colorVal[options.trayColor2b][2];
  }

  else if( iconType == 2 )    // 3. Lftericon
  {
    bi->bmiColors[0].rgbRed = colorVal[options.fanTrayColor1][0];
    bi->bmiColors[0].rgbGreen = colorVal[options.fanTrayColor1][1];
    bi->bmiColors[0].rgbBlue = colorVal[options.fanTrayColor1][2];
    bi->bmiColors[1].rgbRed = colorVal[options.fanTrayColor2][0];
    bi->bmiColors[1].rgbGreen = colorVal[options.fanTrayColor2][1];
    bi->bmiColors[1].rgbBlue = colorVal[options.fanTrayColor2][2];
  }

  bi->bmiColors[0].rgbReserved = 0;
  bi->bmiColors[1].rgbReserved = 0;

  HDC hdc = ::GetDC( NULL );

  hBitmap = CreateDIBSection( hdc, 
                              bi, 
                              DIB_RGB_COLORS,
                              (void**)&lpBits, 
                              NULL, 
                              (DWORD)0 );

  BYTE* bitmap = (BYTE*)lpBits;

  createTempIcon( upperStatus?upperValue:lowerValue, (upperStatus&&lowerStatus)?1:0, bitmap );

  if( upperStatus && lowerStatus )
    createTempIcon( lowerValue, 2, bitmap );

  // Create mask bitmap
  BYTE andMask[128];

  for( int i=0; i<128; i++ )
    andMask[i] = 0x00;

  if( (iconType==0 && options.transparentBkg)
  ||  (iconType==1 && options.transparentBkgB)
  ||  (iconType==2 && options.fanTransparentBkg) )
  {
    int k = 15;

    for( int i=0; i<16; i++ )
    {
      for( int j=0; j<2; j++ )
        andMask[k*2+j] = bitmap[i*4+j];
      k--;
    }
  }

  HBITMAP hMonoBitmap = CreateBitmap( dwWidth, dwHeight, 1, 1, andMask );

  ICONINFO ii;
  ii.fIcon = TRUE;
  ii.xHotspot = 0;
  ii.yHotspot = 0;
  ii.hbmMask = hMonoBitmap;
  ii.hbmColor = hBitmap;

  hIcon = CreateIconIndirect( &ii );

  ::ReleaseDC( glb_hWnd, hdc );
  ::DeleteObject( hBitmap );
  ::DeleteObject( hMonoBitmap );

  delete bi;

  return hIcon;
}


//---------------------------------------------------------------
// Iconbitmap mit bestimmtem Wert fllen
//
// temp: 0-200 = normale Temperatur oder Last (0-100)
//       -3    = '--' anzeigen
//       -4    = 'Sl' anzeigen
//       -5    = 'Hi' anzeigen
//---------------------------------------------------------------
void TTrayIconManager::createTempIcon( int temp, int where, BYTE* and )
{
  int num0 = (temp/100)%10;   // erste Dezimalziffer
  int num1 = (temp/10)%10;    // zweite Dezimalziffer
  int num2 = temp%10;         // dritte Dezimalziffer
  int j;
  int lstart, lend, yscaling;

  if( temp == -3 )      // Spezialfall fr 'inaktiv' ("--")
  {
    num0 = 0;
    num1 = 20;
    num2 = 20;
  }
  else if( temp == -4 )   // Zeichen fr 'Sl' auswhlen
  {
    num0 = 0;
    num1 = 21;
    num2 = 22;
  }
  else if( temp == -5 )   // Zeichen fr 'Hi' auswhlen
  {
    num0 = 0;
    num1 = 23;
    num2 = 24;
  }

  if( where == 0 )        // nur ein Wert im Icon
  {
    lstart = 0;     // komplette Iconbitmap damit fllen
    lend = 15;
    yscaling = 2;   // jede Ziffer auf 16 Zeilen erweitern
  }
  else if( where == 1 )   // obere Hlfte des Icons fllen
  {
    lstart = 8;     // nur obere Hlfte der Bitmap fllen
    lend = 15;
    yscaling = 1;   // keine Skalierung (8 Zeilen)
  }
  else if( where == 2 )   // untere Hlfte des Icons fllen
  {
    lstart = 0;     // nur untere Hlfte der Bitmap fllen
    lend = 7;
    yscaling = 1;   // keine Skalierung (8 Zeilen)
  }

  if( num0 != 0 )   // zur Anzeige von Fahrenheitwerten
  {
    j=7;
    for( int i=lstart; i<=lend; i+=yscaling )
    {
      for( int m=0; m<yscaling; m++ )   // eine Iconzeile pro Durchlauf
      {
        and[(i+m)*4] = 0xff ^ (digits[num0+10][j] | digits[num1+10][j]>>5);
        and[(i+m)*4+1] = 0xff ^ (digits[num1+10][j]<<3 | digits[num2+10][j]>>2);
      }
 
      j--;   // weiter im digits2-Array
    }
  }
  else              // Standardwerte (Celsius)
  {
    j=7;

    for( int i=lstart; i<=lend; i+=yscaling )    // Iconregion fllen
    {
      for( int m=0; m<yscaling; m++ )   // eine Iconzeile pro Durchlauf
      {
        and[(i+m)*4] = 0xff ^ digits[num1][j];
        and[(i+m)*4+1] = 0xff ^ digits[num2][j];
      }
 
      j--;   // weiter im digits-Array
    }
  }
}

static unsigned char digits[25][8] = 
{
  // Ziffern 0-9 in 8x8:
  { 0x3c,0x42,0x42,0x42,0x42,0x42,0x42,0x3c },
  { 0x10,0x30,0x70,0x10,0x10,0x10,0x10,0x7c },
  { 0x3c,0x42,0x02,0x04,0x08,0x10,0x20,0x7e },
  { 0x3c,0x42,0x02,0x0c,0x02,0x02,0x42,0x3c },
  { 0x08,0x18,0x28,0x48,0xfe,0x08,0x08,0x3e },
  { 0x7e,0x40,0x40,0x7c,0x02,0x02,0x42,0x3c },
  { 0x1c,0x20,0x40,0x7c,0x42,0x42,0x42,0x3c },
  { 0x7c,0x44,0x08,0x08,0x10,0x10,0x20,0x20 },
  { 0x3c,0x42,0x42,0x3c,0x42,0x42,0x42,0x3c },
  { 0x3c,0x42,0x42,0x42,0x3e,0x02,0x04,0x38 },

  // Ziffern 0-9 in 5x8:
  { 0x60,0x90,0x90,0x90,0x90,0x90,0x90,0x60 },
  { 0x20,0x20,0x60,0x20,0x20,0x20,0x20,0x70 },
  { 0x60,0x90,0x10,0x20,0x20,0x40,0x40,0xf0 },
  { 0x60,0x90,0x10,0x20,0x10,0x10,0x90,0x60 },
  { 0x20,0x60,0x60,0xa0,0xf0,0x20,0x20,0x70 },
  { 0xf0,0x80,0x80,0xe0,0x10,0x10,0x90,0x60 },
  { 0x70,0x80,0x80,0xe0,0x90,0x90,0x90,0x60 },
  { 0xf0,0x90,0x10,0x10,0x20,0x20,0x20,0x20 },
  { 0x60,0x90,0x90,0x60,0x90,0x90,0x90,0x60 },
  { 0x60,0x90,0x90,0x90,0x70,0x10,0x20,0x60 },

  // 1 zustzliches Zeichen fr '-' in 8x8:
  { 0x00,0x00,0x00,0x7e,0x7e,0x00,0x00,0x00 },

  // 4 zustzliche Zeichen fr 'Sl' und 'Hi' in 8x8:
  { 0x3e,0x40,0x40,0x40,0x3c,0x02,0x02,0x7c },
  { 0x40,0x40,0x40,0x40,0x40,0x40,0x40,0x3c },
  { 0x42,0x42,0x42,0x42,0x7e,0x42,0x42,0x42 },
  { 0x00,0x00,0x10,0x00,0x10,0x10,0x10,0x38 }
};

static int colorVal[16][3] = 
{
  {0, 0, 0},			// Black
  {128, 0, 0},		// Dark Red
  {0, 128, 0},		// Dark Green
  {128, 128, 0},	// Dark Yellow
  {0, 0, 128},		// Dark Blue
  {128, 0, 128},	// Dark Magenta
  {0, 128, 128},	// Dark Cyan	
  {192, 192, 192},// Light Grey
  {128, 128, 128},// Medium Grey
  {255, 0, 0},		// Red
  {0, 255, 0},		// Green
  {255, 255, 0},	// Yellow
  {0, 0, 255},  	// Blue
  {255, 0, 255},	// Magenta
  {0, 255, 255},	// Cyan
  {255, 255, 255}	// White
};

