;   I8kfanGUI V3.1
;   Copyright(c) 2001-2007 Christian Diefer
; 
;   This program is free software; you can redistribute it and/or modify
;   it under the terms of the GNU General Public License version 2 as 
;   published by the Free Software Foundation.
;   
;   This program is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;   
;   You should have received a copy of the GNU General Public License
;   along with this program; if not, write to the Free Software
;   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.



; These functions were previously written as inline assembly instructions 
; embedded within the C++ source code. Due to the lack of inline assembly 
; in the MS x64 C++ compiler these code fragments needed to be sourced out 
; into this separate asm file. It is assembled by invoking
;    
;   ml64 /c /Fl hardio64.asm
;
; It is needed only by the x64 version of I8kfanGUI. The 32bit version still
; contains the inline assembly instructions with conditional compilation
; directives.

.code

; the four functions:
PUBLIC readRDTSC
PUBLIC readCPUID
public wincpuidsupport
public findMaskWidth

;rcx: UINT64* value
readRDTSC PROC

    push rax
    push rbx
    push rdx
    
    push rcx
    
    xor rax,rax
    cpuid
    rdtsc
    
    pop rcx
    mov dword ptr [rcx+0],eax
    mov dword ptr [rcx+4],edx
    
    pop rdx
    pop rbx
    pop rax
    RET

readRDTSC ENDP

;rcx: DWORD* fr EAX-Wert
;rdx: DWORD* fr EBX
;r8: DWORD* fr ECX
;r9: DWORD* fr EDX
readCPUID PROC

    push rbx
    push rcx
    push rdx
    push r8
    push r9
    mov aptr,rcx
    mov bptr,rdx
    mov cptr,r8
    mov dptr,r9
    mov eax,dword ptr [rcx]
    mov ecx,dword ptr [r8]
    cpuid
    mov r8,aptr
    mov dword ptr [r8],eax
    mov r8,bptr
    mov dword ptr [r8],ebx
    mov r8,cptr
    mov dword ptr [r8],ecx
    mov r8,dptr
    mov dword ptr [r8],edx
    pop r9
    pop r8
    pop rdx
    pop rcx
    pop rbx
    RET    
    
readCPUID ENDP

wincpuidsupport PROC
    xor rax,rax
    inc rax
    RET

wincpuidsupport ENDP

;rcx:CountItem
findMaskWidth PROC
    mov eax,ecx
    xor ecx,ecx
    mov retv,ecx
    dec eax
    bsr cx,ax
    jz next
    inc cx
    mov retv,ecx
next:
    xor rax,rax
    mov eax,retv
    RET
    
findMaskWidth ENDP

.data
aptr    dq 0
bptr    dq 0
cptr    dq 0
dptr    dq 0
retv    dd 0,0

END
