/*
   I8kfanGUI V3.1
   Copyright(c) 2001-2007 Christian Diefer
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License version 2 as 
   published by the Free Software Foundation.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "afxwin.h"
#if !defined(AFX_I8KFANGUIDLG_H__2E68874F_D412_4A2D_977A_A6FC6B078EAE__INCLUDED_)
#define AFX_I8KFANGUIDLG_H__2E68874F_D412_4A2D_977A_A6FC6B078EAE__INCLUDED_

#include "cpudata.h"
#include "colorstatic.h"

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

extern TCPUData cpuData;

// for detecting XP session changes
typedef BOOL (WINAPI *SESSIONREG) ( HWND hWnd, DWORD dwFlags );
typedef BOOL (WINAPI *SESSIONUNREG) ( HWND hWnd );

/////////////////////////////////////////////////////////////////////////////
// CI8kfanguiDlg

class CI8kfanguiDlg : public CDialog
{
public:
  CI8kfanguiDlg(CWnd* pParent = NULL);
  void setCmdLine( wchar_t* cl );

  //{{AFX_DATA(CI8kfanguiDlg)
  enum { IDD = IDD_I8KFANGUI_DIALOG };
  CSliderCtrl m_scOuterSlider;
  CSliderCtrl m_scInnerSlider;
  BOOL m_bOuterFan;
  BOOL m_bInnerFan;
  CString m_szSpeedString1;
  CString m_szSpeedString2;
  CString m_szCPULoad;
  CString m_szCPUTemp;
  CString m_szHDTemp;
  CString m_szHDTemp2;
  CString m_szFanSpeed1;
  CString m_szFanSpeed2;
  CString m_szGPUTemp;
  CString m_szMemoryTemp;
  CString m_szChipsetTemp;
  CString m_szCPUSpeed;
  int m_iCPULevel;
  int m_iSensorSpeed1;
  int m_iSensorSpeed2;
  int m_iSensorIndicator1;
  int m_iSensorIndicator2;
  CComboBox m_cControlProfile;
  int m_iGPULevel;
  int m_iMemoryLevel;
  int m_iChipsetLevel;
  BOOL m_bMaintainSpeed;
  CColorStatic m_cCPUTemp;
  CColorStatic m_cGPUTemp;
  CColorStatic m_cMemoryTemp;
  CColorStatic m_cChipsetTemp;
  CColorStatic m_cCPUSpeed;
  CColorStatic m_cCPULoad;
  CString m_szCPUTempMC1;
  CColorStatic m_cCoreText;
  //}}AFX_DATA

  //{{AFX_VIRTUAL(CI8kfanguiDlg)
protected:
  virtual void DoDataExchange( CDataExchange* pDX );
  virtual void PostNcDestroy();
  virtual BOOL PreTranslateMessage( MSG* pMsg );
  //}}AFX_VIRTUAL

protected:
  HICON m_hIcon;

  //{{AFX_MSG(CI8kfanguiDlg)
  virtual BOOL OnInitDialog();
  afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
  afx_msg void OnPaint();
  afx_msg HCURSOR OnQueryDragIcon();
  afx_msg void OnApply();
  afx_msg void OnCheck1();
  afx_msg void OnCheck2();
  afx_msg void OnAbout();
  afx_msg void OnOptbutton();
  afx_msg void OnClose();
  afx_msg void OnTimer(UINT_PTR nIDEvent);
  afx_msg void OnTempUpdate();
  afx_msg void OnSysinfobutton();
  afx_msg void OnBnClickedClose();
  afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
  LRESULT OnIconNotify( WPARAM wp, LPARAM lp );
  LRESULT OnWtsSessionChange( WPARAM wp, LPARAM lp );
  LRESULT OnTaskBarCreated( WPARAM wp, LPARAM lp );
  afx_msg void OnShowMainMenu( void );
  afx_msg void OnObserverModeMenu( void );
  afx_msg void OnManualControlMenu( void );
  afx_msg void OnTempControlMenu( void );
  afx_msg void OnForceHighSpeedMenu( void );
  afx_msg void OnTempProfile1Menu( void );
  afx_msg void OnTempProfile2Menu( void );
  afx_msg void OnTempProfile3Menu( void );
  afx_msg void OnTempProfile4Menu( void );
  afx_msg void OnCelsiusMenu( void );
  afx_msg void OnFahrenheitMenu( void );
  afx_msg void OnSensorUpdateMenu( void );
  afx_msg void OnShowDiagram( void );
  afx_msg void OnCbnSelchangeProfile();
  afx_msg void OnSelectTrayIcon01( void );
  afx_msg void OnSelectTrayIcon02( void );
  afx_msg void OnSelectTrayIcon11( void );
  afx_msg void OnSelectTrayIcon12( void );
  afx_msg void OnSelectTrayIcon21( void );
  afx_msg void OnSelectTrayIcon22( void );
  afx_msg void OnSelectTrayIcon31( void );
  afx_msg void OnSelectTrayIcon32( void );
  afx_msg void OnSelectTrayIcon41( void );
  afx_msg void OnSelectTrayIcon42( void );
  afx_msg void OnSelectTrayIcon51( void );
  afx_msg void OnSelectTrayIcon52( void );
  afx_msg void OnSelectTrayIcon61( void );
  afx_msg void OnSelectTrayIcon62( void );
  afx_msg void OnSelectTrayIcon71( void );
  afx_msg void OnSelectTrayIcon72( void );
  afx_msg void OnSelectTrayIcon81( void );
  afx_msg void OnSelectTrayIcon82( void );
  afx_msg void OnSelectSpeedIcon( void );
  afx_msg void OnSelectShutdown( void );
  afx_msg void OnBnClickedEntemp();
  afx_msg void OnEndSession(BOOL bEnding);
  afx_msg void OnBnClickedPeakbutton();
  afx_msg void OnBnClickedMaintainspeed();
  afx_msg void OnBnClickedFanforcing();
  afx_msg void OnBnClickedLogbutton();
  afx_msg void OnBnClickedResethistory();
  afx_msg void OnBnClickedRadio1();
  afx_msg void OnBnClickedRadio2();
  afx_msg void OnBnClickedRadio3();
  afx_msg void OnBnClickedRadio4();
  //}}AFX_MSG
  DECLARE_MESSAGE_MAP()

private:
  void minimizeToTray();
  void getRegKeys();
  void setRegKeys();
  void setAutoStartRegistry();
  void deleteAutoStartRegistry();
  int setSpeed( int outsp, int insp );
  bool closeQuery();
  void drawDiagram();
  int wtsRegistration();
  void updateHDTemp();
  void readDataFromSensors( BOOL init=false );
  void setFanSliders( BOOL sensorSupport );
  void hideFanControl( BOOL hide );
  void detectHDs( BOOL enSMART );
  void createPopupMenu();
  void showTempMonElements( BOOL x );
  void fillProfileList();
  void diagramRedraw( BOOL erase );
  void addToolTip( int no, int id, CString str );
  //void showTempControl();
  void setFanAlias();
  void createUpperFanAlias();
  void maintainFanNumLimits();
  void setDiagramScale();
  void fanForcing();
  void checkTimerInterval();
  void exitTempMonitor();
  void setLegendColors();

  CRect cpuFrame;
  CRect legendFrame;
  char* cmdLine;
  unsigned tickCounterCPU;
  unsigned tickCounterFanForce;
  unsigned tickCounterHD;
  BOOL activeTimer;
  BOOL activeSessionNotification;
  BOOL activeSession;
  int diagramOffset;
  HMODULE wtsApi32DLL;
  SESSIONREG sr;
  SESSIONUNREG su;
  int wtsStatus;
  int m_iHDTemp;
  int m_iHDTemp2;
  wchar_t intBuf[16];
  wchar_t biosVer[32];
  CWnd* frameStart;
  CWnd* frameEnd;
  int legendLine;
  CTempControl tempControl;
  BOOL optionsDlgActive;
  CToolTipCtrl m_tToolTip[22];
  bool controlQuitWarning;
  bool forceShutdown;
  bool inPopupCreation;
  bool initComplete;
};

//{{AFX_INSERT_LOCATION}}


#endif // !defined(AFX_I8KFANGUIDLG_H__2E68874F_D412_4A2D_977A_A6FC6B078EAE__INCLUDED_)
